#version 430

layout(binding = 0, std140) uniform UBO
{
    mat4 MVP;
    vec4 SourceSize;
    vec4 OriginalSize;
    vec4 CorePassSize;
    vec4 CorePassFeedbackSize;
    vec4 OutputSize;
    vec4 FinalViewportSize;
    vec4 NegativeCropAddedPassSize;
    vec4 DerezedPassSize;
    int FrameDirection;
    uint FrameCount;
    float HSM_RESOLUTION_DEBUG_ON;
    float HSM_CACHE_GRAPHICS_ON;
    float HSM_CACHE_UPDATE_INDICATOR_MODE;
    float HSM_GLOBAL_GRAPHICS_BRIGHTNESS;
    float HSM_STATIC_LAYERS_GAMMA;
    float HSM_AMBIENT_LIGHTING_OPACITY;
    float HSM_AMBIENT2_LIGHTING_OPACITY;
    float HSM_AMBIENT_LIGHTING_SWAP_IMAGES;
    float HSM_AMBIENT_LIGHTING_HUE;
    float HSM_AMBIENT_LIGHTING_SATURATION;
    float HSM_AMBIENT_LIGHTING_VALUE;
    float HSM_AMBIENT_LIGHTING_CONTRAST;
    float HSM_AMBIENT_LIGHTING_SCALE_KEEP_ASPECT;
    float HSM_AMBIENT_LIGHTING_SCALE_WITH_ZOOM;
    float HSM_AMBIENT_LIGHTING_SCALE;
    float HSM_AMBIENT_LIGHTING_SCALE_X;
    float HSM_AMBIENT_LIGHTING_ROTATE;
    float HSM_AMBIENT_LIGHTING_MIRROR_HORZ;
    float HSM_AMBIENT_LIGHTING_POSITION_X;
    float HSM_AMBIENT_LIGHTING_POSITION_Y;
    float HSM_AMBIENT_LIGHTING_DITHERING_SAMPLES;
    float HSM_AMBIENT2_LIGHTING_HUE;
    float HSM_AMBIENT2_LIGHTING_SATURATION;
    float HSM_AMBIENT2_LIGHTING_VALUE;
    float HSM_AMBIENT2_LIGHTING_CONTRAST;
    float HSM_AMBIENT2_LIGHTING_SCALE_KEEP_ASPECT;
    float HSM_AMBIENT2_LIGHTING_SCALE_WITH_ZOOM;
    float HSM_AMBIENT2_LIGHTING_SCALE;
    float HSM_AMBIENT2_LIGHTING_SCALE_X;
    float HSM_AMBIENT2_LIGHTING_ROTATE;
    float HSM_AMBIENT2_LIGHTING_MIRROR_HORZ;
    float HSM_AMBIENT2_LIGHTING_POSITION_X;
    float HSM_AMBIENT2_LIGHTING_POSITION_Y;
    float HSM_VIEWPORT_ZOOM;
    float HSM_VIEWPORT_POSITION_X;
    float HSM_VIEWPORT_POSITION_Y;
    float HSM_VIEWPORT_ZOOM_MASK;
    float HSM_FLIP_VIEWPORT_VERTICAL;
    float HSM_FLIP_VIEWPORT_HORIZONTAL;
    float HSM_FLIP_CORE_VERTICAL;
    float HSM_FLIP_CORE_HORIZONTAL;
    float HSM_ROTATE_CORE_IMAGE;
    float HSM_ASPECT_RATIO_ORIENTATION;
    float HSM_ASPECT_RATIO_MODE;
    float HSM_ASPECT_RATIO_EXPLICIT;
    float HSM_INT_SCALE_MODE;
    float HSM_INT_SCALE_MULTIPLE_OFFSET;
    float HSM_INT_SCALE_MULTIPLE_OFFSET_LONG;
    float HSM_INT_SCALE_MAX_HEIGHT;
    float HSM_VERTICAL_PRESET;
    float HSM_NON_INTEGER_SCALE;
    float HSM_USE_PHYSICAL_SIZE_FOR_NON_INTEGER;
    float HSM_PHYSICAL_MONITOR_ASPECT_RATIO;
    float HSM_PHYSICAL_MONITOR_DIAGONAL_SIZE;
    float HSM_PHYSICAL_SIM_TUBE_DIAGONAL_SIZE;
    float HSM_USE_IMAGE_FOR_PLACEMENT;
    float HSM_PLACEMENT_IMAGE_USE_HORIZONTAL;
    float HSM_PLACEMENT_IMAGE_MODE;
    float HSM_NON_INTEGER_SCALE_OFFSET;
    float HSM_USE_SNAP_TO_CLOSEST_INT_SCALE;
    float HSM_SNAP_TO_CLOSEST_INT_SCALE_TOLERANCE;
    float HSM_SCREEN_POSITION_X;
    float HSM_SCREEN_POSITION_Y;
    float HSM_CROP_MODE;
    float HSM_CROP_PERCENT_ZOOM;
    float HSM_CROP_PERCENT_TOP;
    float HSM_CROP_PERCENT_BOTTOM;
    float HSM_CROP_PERCENT_LEFT;
    float HSM_CROP_PERCENT_RIGHT;
    float HSM_CROP_BLACK_THRESHOLD;
    float HSM_SCANLINE_DIRECTION;
    float HSM_CORE_RES_SAMPLING_MULT_SCANLINE_DIR;
    float HSM_DOWNSAMPLE_BLUR_SCANLINE_DIR;
    float HSM_CORE_RES_SAMPLING_MULT_OPPOSITE_DIR;
    float HSM_DOWNSAMPLE_BLUR_OPPOSITE_DIR;
    float HSM_CORE_RES_SAMPLING_SHIFT_OPPOSITE_DIR;
    float HSM_INTERLACE_TRIGGER_RES;
    float HSM_INTERLACE_MODE;
    float HSM_INTERLACE_EFFECT_SMOOTHNESS_INTERS;
    float HSM_INTERLACE_SCANLINE_EFFECT;
    float iscans;
    float HSM_FAKE_SCANLINE_MODE;
    float HSM_FAKE_SCANLINE_OPACITY;
    float HSM_FAKE_SCANLINE_RES_MODE;
    float HSM_FAKE_SCANLINE_RES;
    float HSM_FAKE_SCANLINE_INT_SCALE;
    float HSM_FAKE_SCANLINE_ROLL;
    float HSM_FAKE_SCANLINE_CURVATURE;
    float HSM_FAKE_SCANLINE_BRIGHTNESS_CUTOFF;
    float HSM_DUALSCREEN_MODE;
    float HSM_DUALSCREEN_CORE_IMAGE_SPLIT_MODE;
    float HSM_DUALSCREEN_CORE_IMAGE_SWAP_SCREENS;
    float HSM_DUALSCREEN_CORE_IMAGE_SPLIT_OFFSET;
    float HSM_DUALSCREEN_VIEWPORT_SPLIT_LOCATION;
    float HSM_DUALSCREEN_SHIFT_POSITION_WITH_SCALE;
    float HSM_DUALSCREEN_POSITION_OFFSET_BETWEEN_SCREENS;
    float HSM_2ND_SCREEN_ASPECT_RATIO_MODE;
    float HSM_2ND_SCREEN_INDEPENDENT_SCALE;
    float HSM_2ND_SCREEN_SCALE_OFFSET;
    float HSM_2ND_SCREEN_POS_X;
    float HSM_2ND_SCREEN_POS_Y;
    float HSM_2ND_SCREEN_CROP_PERCENT_ZOOM;
    float HSM_2ND_SCREEN_CROP_PERCENT_TOP;
    float HSM_2ND_SCREEN_CROP_PERCENT_BOTTOM;
    float HSM_2ND_SCREEN_CROP_PERCENT_LEFT;
    float HSM_2ND_SCREEN_CROP_PERCENT_RIGHT;
    float HSM_CURVATURE_MODE;
    float HSM_CURVATURE_2D_SCALE_LONG_AXIS;
    float HSM_CURVATURE_2D_SCALE_SHORT_AXIS;
    float HSM_CURVATURE_3D_RADIUS;
    float HSM_CURVATURE_3D_VIEW_DIST;
    float HSM_CURVATURE_3D_TILT_ANGLE_X;
    float HSM_CURVATURE_3D_TILT_ANGLE_Y;
    float HSM_CRT_CURVATURE_SCALE;
    float HSM_ANTI_FLICKER_ON;
    float HSM_ANTI_FLICKER_THRESHOLD;
    float HSM_AB_COMPARE_SHOW_MODE;
    float HSM_AB_COMPARE_AREA;
    float HSM_AB_COMPARE_FREEZE_CRT_TUBE;
    float HSM_AB_COMPARE_FREEZE_GRAPHICS;
    float HSM_AB_COMPARE_SPLIT_AREA;
    float HSM_AB_COMPARE_SPLIT_POSITION;
    float HSM_CRT_BLEND_MODE;
    float HSM_CRT_BLEND_AMOUNT;
    float HSM_CRT_SCREEN_BLEND_MODE;
    float HSM_SCREEN_VIGNETTE_ON;
    float HSM_SCREEN_VIGNETTE_DUALSCREEN_VIS_MODE;
    float HSM_SCREEN_VIGNETTE_STRENGTH;
    float HSM_SCREEN_VIGNETTE_POWER;
    float HSM_SCREEN_VIGNETTE_IN_REFLECTION;
    float HSM_MONOCHROME_MODE;
    float HSM_MONOCHROME_BRIGHTNESS;
    float HSM_MONOCHROME_GAMMA;
    float HSM_MONOCHROME_HUE_OFFSET;
    float HSM_MONOCHROME_SATURATION;
    float HSM_MONOCHROME_DUALSCREEN_VIS_MODE;
    float HSM_SCREEN_REFLECTION_SCALE;
    float HSM_SCREEN_REFLECTION_POS_X;
    float HSM_SCREEN_REFLECTION_POS_Y;
    float HSM_TUBE_DIFFUSE_MODE;
    float HSM_TUBE_DIFFUSE_IMAGE_DUALSCREEN_VIS_MODE;
    float HSM_TUBE_DIFFUSE_OPACITY;
    float HSM_TUBE_DIFFUSE_IMAGE_HUE;
    float HSM_TUBE_DIFFUSE_IMAGE_COLORIZE_ON;
    float HSM_TUBE_DIFFUSE_IMAGE_SATURATION;
    float HSM_TUBE_DIFFUSE_IMAGE_BRIGHTNESS;
    float HSM_TUBE_DIFFUSE_IMAGE_GAMMA;
    float HSM_TUBE_DIFFUSE_IMAGE_AMBIENT_LIGHTING;
    float HSM_TUBE_DIFFUSE_IMAGE_AMBIENT2_LIGHTING;
    float HSM_TUBE_DIFFUSE_IMAGE_SCALE;
    float HSM_TUBE_DIFFUSE_IMAGE_SCALE_X;
    float HSM_TUBE_EMPTY_THICKNESS;
    float HSM_TUBE_EMPTY_THICKNESS_X_SCALE;
    float HSM_TUBE_DIFFUSE_FORCE_ASPECT;
    float HSM_TUBE_EXPLICIT_ASPECT;
    float HSM_SCREEN_CORNER_RADIUS_SCALE;
    float HSM_TUBE_COLORED_GEL_IMAGE_ON;
    float HSM_TUBE_COLORED_GEL_IMAGE_DUALSCREEN_VIS_MODE;
    float HSM_TUBE_COLORED_GEL_IMAGE_MULTIPLY_AMOUNT;
    float HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_AMOUNT;
    float HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_BRIGHTNESS;
    float HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_VIGNETTE;
    float HSM_TUBE_COLORED_GEL_IMAGE_TRANSPARENCY_THRESHOLD;
    float HSM_TUBE_COLORED_GEL_IMAGE_ADDITIVE_AMOUNT;
    float HSM_SHOW_CRT_ON_TOP_OF_COLORED_GEL;
    float HSM_TUBE_SHADOW_IMAGE_ON;
    float HSM_TUBE_SHADOW_IMAGE_OPACITY;
    float HSM_TUBE_SHADOW_IMAGE_SCALE_X;
    float HSM_TUBE_SHADOW_IMAGE_SCALE_Y;
    float HSM_TUBE_SHADOW_IMAGE_POS_X;
    float HSM_TUBE_SHADOW_IMAGE_POS_Y;
    float HSM_TUBE_SHADOW_CURVATURE_SCALE;
    float HSM_TUBE_COLORED_GEL_IMAGE_AMBIENT_LIGHTING;
    float HSM_TUBE_COLORED_GEL_IMAGE_AMBIENT2_LIGHTING;
    float HSM_TUBE_COLORED_GEL_IMAGE_FAKE_SCANLINE_AMOUNT;
    float HSM_TUBE_COLORED_GEL_IMAGE_SCALE;
    float HSM_TUBE_COLORED_GEL_IMAGE_FLIP_HORIZONTAL;
    float HSM_TUBE_COLORED_GEL_IMAGE_FLIP_VERTICAL;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_ON;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_DUALSCREEN_VIS_MODE;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_OPACITY;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_AMBIENT_LIGHTING;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_AMBIENT2_LIGHTING;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_SCALE;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_SHADOW_OPACITY;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_DITHERING_SAMPLES;
    float HSM_GLOBAL_CORNER_RADIUS;
    float HSM_TUBE_BLACK_EDGE_CORNER_RADIUS_SCALE;
    float HSM_TUBE_BLACK_EDGE_SHARPNESS;
    float HSM_TUBE_BLACK_EDGE_CURVATURE_SCALE;
    float HSM_TUBE_BLACK_EDGE_THICKNESS;
    float HSM_TUBE_BLACK_EDGE_THICKNESS_X_SCALE;
    float HSM_BZL_USE_INDEPENDENT_SCALE;
    float HSM_BZL_INDEPENDENT_SCALE;
    float HSM_BZL_USE_INDEPENDENT_CURVATURE;
    float HSM_BZL_INDEPENDENT_CURVATURE_SCALE_LONG_AXIS;
    float HSM_BZL_INDEPENDENT_CURVATURE_SCALE_SHORT_AXIS;
    float HSM_BZL_OPACITY;
    float HSM_BZL_BLEND_MODE;
    float HSM_BZL_WIDTH;
    float HSM_BZL_HEIGHT;
    float HSM_BZL_SCALE_OFFSET;
    float HSM_BZL_INNER_CURVATURE_SCALE;
    float HSM_BZL_INNER_CORNER_RADIUS_SCALE;
    float HSM_BZL_OUTER_CURVATURE_SCALE;
    float HSM_BZL_INNER_EDGE_THICKNESS;
    float HSM_BZL_INNER_EDGE_SHARPNESS;
    float HSM_BZL_OUTER_CORNER_RADIUS_SCALE;
    float HSM_BZL_INNER_EDGE_SHADOW;
    float HSM_BZL_COLOR_HUE;
    float HSM_BZL_COLOR_SATURATION;
    float HSM_BZL_COLOR_VALUE;
    float HSM_BZL_NOISE;
    float HSM_BZL_BRIGHTNESS;
    float HSM_BZL_HIGHLIGHT;
    float HSM_BZL_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_BZL_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_FRM_USE_INDEPENDENT_COLOR;
    float HSM_FRM_COLOR_HUE;
    float HSM_FRM_COLOR_SATURATION;
    float HSM_FRM_COLOR_VALUE;
    float HSM_FRM_NOISE;
    float HSM_FRM_OUTER_CURVATURE_SCALE;
    float HSM_FRM_THICKNESS;
    float HSM_FRM_THICKNESS_SCALE_X;
    float HSM_FRM_OUTER_POS_Y;
    float HSM_FRM_INNER_EDGE_THICKNESS;
    float HSM_FRM_OUTER_EDGE_THICKNESS;
    float HSM_FRM_OUTER_EDGE_SHADING;
    float HSM_FRM_OUTER_CORNER_RADIUS;
    float HSM_BZL_OUTER_POSITION_Y;
    float HSM_FRM_SHADOW_OPACITY;
    float HSM_FRM_SHADOW_WIDTH;
    float HSM_REFLECT_CORNER_FADE;
    float HSM_REFLECT_CORNER_INNER_SPREAD;
    float HSM_REFLECT_CORNER_OUTER_SPREAD;
    float HSM_REFLECT_CORNER_ROTATION_OFFSET_TOP;
    float HSM_REFLECT_CORNER_ROTATION_OFFSET_BOTTOM;
    float HSM_REFLECT_CORNER_SPREAD_FALLOFF;
    float HSM_REFLECT_CORNER_FADE_DISTANCE;
    float HSM_REFLECT_GLOBAL_AMOUNT;
    float HSM_REFLECT_GLOBAL_GAMMA_ADJUST;
    float HSM_REFLECT_BEZEL_INNER_EDGE_AMOUNT;
    float HSM_REFLECT_BEZEL_INNER_EDGE_FULLSCREEN_GLOW;
    float HSM_REFLECT_FRAME_INNER_EDGE_AMOUNT;
    float HSM_REFLECT_FRAME_INNER_EDGE_SHARPNESS;
    float HSM_REFLECT_DIRECT_AMOUNT;
    float HSM_REFLECT_DIFFUSED_AMOUNT;
    float HSM_REFLECT_FULLSCREEN_GLOW;
    float HSM_REFLECT_FULLSCREEN_GLOW_GAMMA;
    float HSM_REFLECT_FADE_AMOUNT;
    float HSM_REFLECT_RADIAL_FADE_WIDTH;
    float HSM_REFLECT_RADIAL_FADE_HEIGHT;
    float HSM_REFLECT_LATERAL_OUTER_FADE_POSITION;
    float HSM_REFLECT_LATERAL_OUTER_FADE_DISTANCE;
    float HSM_REFLECT_VIGNETTE_AMOUNT;
    float HSM_REFLECT_VIGNETTE_SIZE;
    float HSM_REFLECT_NOISE_AMOUNT;
    float HSM_REFLECT_NOISE_SAMPLES;
    float HSM_REFLECT_NOISE_SAMPLE_DISTANCE;
    float HSM_REFLECT_BLUR_NUM_SAMPLES;
    float HSM_REFLECT_BLUR_FALLOFF_DISTANCE;
    float HSM_REFLECT_BLUR_MIN;
    float HSM_REFLECT_BLUR_MAX;
    float HSM_REFLECT_MASK_IMG_AMOUNT;
    float HSM_REFLECT_IS_LAST_PASS;
    float HSM_GLASS_BORDER_ON;
    float HSM_POTATO_SHOW_BG_OVER_SCREEN;
    float HSM_STANDARD_DECAL_SCALE_WITH_FRAME;
    float HSM_STANDARD_TOP_SCALE_WITH_FRAME;
    float HSM_BG_LAYER_ORDER;
    float HSM_VIEWPORT_VIGNETTE_LAYER_ORDER;
    float HSM_CRT_LAYER_ORDER;
    float HSM_DEVICE_LAYER_ORDER;
    float HSM_CAB_GLASS_LAYER_ORDER;
    float HSM_DECAL_LAYER_ORDER;
    float HSM_LED_LAYER_ORDER;
    float HSM_TOP_LAYER_ORDER;
    float HSM_CUTOUT_ASPECT_MODE;
    float HSM_CUTOUT_EXPLICIT_ASPECT;
    float HSM_CUTOUT_SCALE_MODE;
    float HSM_CUTOUT_SCALE_FULL_WITH_ZOOM;
    float HSM_CUTOUT_KEEP_ASPECT;
    float HSM_CUTOUT_SCALE;
    float HSM_CUTOUT_SCALE_X;
    float HSM_CUTOUT_CORNER_RADIUS;
    float HSM_CUTOUT_POS_X;
    float HSM_CUTOUT_POS_Y;
    float HSM_BG_OPACITY;
    float HSM_BG_HUE;
    float HSM_BG_COLORIZE_ON;
    float HSM_BG_SATURATION;
    float HSM_BG_BRIGHTNESS;
    float HSM_BG_GAMMA;
    float HSM_BG_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_BG_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_BG_APPLY_AMBIENT_IN_ADD_MODE;
    float HSM_BG_BLEND_MODE;
    float HSM_BG_SOURCE_MATTE_TYPE;
    float HSM_BG_MASK_MODE;
    float HSM_BG_CUTOUT_MODE;
    float HSM_BG_DUALSCREEN_VIS_MODE;
    float HSM_BG_SCALE_MODE;
    float HSM_BG_SCALE_FULL_WITH_ZOOM;
    float HSM_BG_FILL_MODE;
    float HSM_BG_SCALE_KEEP_ASPECT;
    float HSM_BG_SCALE;
    float HSM_BG_SCALE_X;
    float HSM_BG_POS_X;
    float HSM_BG_POS_Y;
    float HSM_BG_MIRROR_WRAP;
    float HSM_BG_MIPMAPPING_BLEND_BIAS;
    float HSM_VIEWPORT_VIGNETTE_OPACITY;
    float HSM_VIEWPORT_VIGNETTE_MASK_MODE;
    float HSM_VIEWPORT_VIGNETTE_CUTOUT_MODE;
    float HSM_VIEWPORT_VIGNETTE_SCALE_MODE;
    float HSM_VIEWPORT_VIGNETTE_SCALE;
    float HSM_VIEWPORT_VIGNETTE_SCALE_X;
    float HSM_VIEWPORT_VIGNETTE_POS_X;
    float HSM_VIEWPORT_VIGNETTE_POS_Y;
    float HSM_LED_OPACITY;
    float HSM_LED_HUE;
    float HSM_LED_COLORIZE_ON;
    float HSM_LED_SATURATION;
    float HSM_LED_BRIGHTNESS;
    float HSM_LED_GAMMA;
    float HSM_LED_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_LED_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_LED_APPLY_AMBIENT_IN_ADD_MODE;
    float HSM_LED_BLEND_MODE;
    float HSM_LED_SOURCE_MATTE_TYPE;
    float HSM_LED_MASK_MODE;
    float HSM_LED_CUTOUT_MODE;
    float HSM_LED_DUALSCREEN_VIS_MODE;
    float HSM_LED_SCALE_MODE;
    float HSM_LED_SCALE_FULL_WITH_ZOOM;
    float HSM_LED_SCALE_KEEP_ASPECT;
    float HSM_LED_FILL_MODE;
    float HSM_LED_SCALE;
    float HSM_LED_SCALE_X;
    float HSM_LED_POS_X;
    float HSM_LED_POS_Y;
    float HSM_LED_MIPMAPPING_BLEND_BIAS;
    float HSM_DEVICE_OPACITY;
    float HSM_DEVICE_HUE;
    float HSM_DEVICE_COLORIZE_ON;
    float HSM_DEVICE_SATURATION;
    float HSM_DEVICE_BRIGHTNESS;
    float HSM_DEVICE_GAMMA;
    float HSM_DEVICE_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_DEVICE_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_DEVICE_APPLY_AMBIENT_IN_ADD_MODE;
    float HSM_DEVICE_BLEND_MODE;
    float HSM_DEVICE_SOURCE_MATTE_TYPE;
    float HSM_DEVICE_MASK_MODE;
    float HSM_DEVICE_CUTOUT_MODE;
    float HSM_DEVICE_DUALSCREEN_VIS_MODE;
    float HSM_DEVICE_SCALE_MODE;
    float HSM_DEVICE_SCALE_FULL_WITH_ZOOM;
    float HSM_DEVICE_SCALE_KEEP_ASPECT;
    float HSM_DEVICE_FILL_MODE;
    float HSM_DEVICE_SCALE;
    float HSM_DEVICE_SCALE_X;
    float HSM_DEVICE_POS_X;
    float HSM_DEVICE_POS_Y;
    float HSM_DEVICE_COPY_INHERITED_COORD;
    float HSM_REFLECT_MASK_SCALE_MODE;
    float HSM_DEVICE_MIPMAPPING_BLEND_BIAS;
    float HSM_FRM_OPACITY;
    float HSM_FRM_BLEND_MODE;
    float HSM_FRM_TEXTURE_OPACITY;
    float HSM_FRM_TEXTURE_BLEND_MODE;
    float HSM_DECAL_OPACITY;
    float HSM_DECAL_HUE;
    float HSM_DECAL_COLORIZE_ON;
    float HSM_DECAL_SATURATION;
    float HSM_DECAL_BRIGHTNESS;
    float HSM_DECAL_GAMMA;
    float HSM_DECAL_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_DECAL_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_DECAL_APPLY_AMBIENT_IN_ADD_MODE;
    float HSM_DECAL_BLEND_MODE;
    float HSM_DECAL_SOURCE_MATTE_TYPE;
    float HSM_DECAL_MASK_MODE;
    float HSM_DECAL_CUTOUT_MODE;
    float HSM_DECAL_DUALSCREEN_VIS_MODE;
    float HSM_DECAL_SCALE_MODE;
    float HSM_DECAL_SCALE_FULL_WITH_ZOOM;
    float HSM_DECAL_SCALE_KEEP_ASPECT;
    float HSM_DECAL_FILL_MODE;
    float HSM_DECAL_SCALE;
    float HSM_DECAL_SCALE_X;
    float HSM_DECAL_POS_X;
    float HSM_DECAL_POS_Y;
    float HSM_DECAL_MIPMAPPING_BLEND_BIAS;
    float HSM_CAB_GLASS_OPACITY;
    float HSM_CAB_GLASS_HUE;
    float HSM_CAB_GLASS_COLORIZE_ON;
    float HSM_CAB_GLASS_SATURATION;
    float HSM_CAB_GLASS_BRIGHTNESS;
    float HSM_CAB_GLASS_GAMMA;
    float HSM_CAB_GLASS_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_CAB_GLASS_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_CAB_GLASS_APPLY_AMBIENT_IN_ADD_MODE;
    float HSM_CAB_GLASS_BLEND_MODE;
    float HSM_CAB_GLASS_SOURCE_MATTE_TYPE;
    float HSM_CAB_GLASS_MASK_MODE;
    float HSM_CAB_GLASS_CUTOUT_MODE;
    float HSM_CAB_GLASS_DUALSCREEN_VIS_MODE;
    float HSM_CAB_GLASS_SCALE_MODE;
    float HSM_CAB_GLASS_SCALE_FULL_WITH_ZOOM;
    float HSM_CAB_GLASS_SCALE_KEEP_ASPECT;
    float HSM_CAB_GLASS_FILL_MODE;
    float HSM_CAB_GLASS_SCALE;
    float HSM_CAB_GLASS_SCALE_X;
    float HSM_CAB_GLASS_POS_X;
    float HSM_CAB_GLASS_POS_Y;
    float HSM_CAB_GLASS_MIPMAPPING_BLEND_BIAS;
    float HSM_TOP_OPACITY;
    float HSM_TOP_HUE;
    float HSM_TOP_COLORIZE_ON;
    float HSM_TOP_SATURATION;
    float HSM_TOP_BRIGHTNESS;
    float HSM_TOP_GAMMA;
    float HSM_TOP_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_TOP_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_TOP_APPLY_AMBIENT_IN_ADD_MODE;
    float HSM_TOP_BLEND_MODE;
    float HSM_TOP_SOURCE_MATTE_TYPE;
    float HSM_TOP_MASK_MODE;
    float HSM_TOP_CUTOUT_MODE;
    float HSM_TOP_DUALSCREEN_VIS_MODE;
    float HSM_TOP_SCALE_MODE;
    float HSM_TOP_SCALE_FULL_WITH_ZOOM;
    float HSM_TOP_SCALE_KEEP_ASPECT;
    float HSM_TOP_FILL_MODE;
    float HSM_TOP_SCALE;
    float HSM_TOP_SCALE_X;
    float HSM_TOP_POS_X;
    float HSM_TOP_POS_Y;
    float HSM_TOP_MIRROR_WRAP;
    float HSM_TOP_MIPMAPPING_BLEND_BIAS;
    float HSM_RENDER_SIMPLE_MODE;
    float HSM_RENDER_SIMPLE_MASK_TYPE;
    float HSM_LAYERING_DEBUG_MASK_MODE;
    float HSM_INTRO_LOGO_BLEND_MODE;
    float HSM_INTRO_LOGO_FLIP_VERTICAL;
    float HSM_INTRO_NOISE_BLEND_MODE;
    float HSM_INTRO_NOISE_HOLD;
    float HSM_INTRO_NOISE_FADE_OUT;
    float HSM_INTRO_SOLID_BLACK_HOLD;
    float HSM_INTRO_SOLID_BLACK_FADE_OUT;
    float HSM_INTRO_SOLID_COLOR_BLEND_MODE;
    float HSM_INTRO_LOGO_OVER_SOLID_COLOR;
    float HSM_INTRO_LOGO_PLACEMENT;
    float HSM_INTRO_LOGO_HEIGHT;
    float HSM_INTRO_LOGO_POS_X;
    float HSM_INTRO_LOGO_POS_Y;
    float HSM_INTRO_WHEN_TO_SHOW;
    float HSM_INTRO_SPEED;
    float HSM_INTRO_LOGO_WAIT;
    float HSM_INTRO_LOGO_FADE_IN;
    float HSM_INTRO_LOGO_HOLD;
    float HSM_INTRO_LOGO_FADE_OUT;
    float HSM_INTRO_SOLID_COLOR_HUE;
    float HSM_INTRO_SOLID_COLOR_SAT;
    float HSM_INTRO_SOLID_COLOR_VALUE;
    float HSM_INTRO_SOLID_COLOR_HOLD;
    float HSM_INTRO_SOLID_COLOR_FADE_OUT;
    float GAMMA_INPUT;
    float gamma_out;
    float post_br;
    float post_br_affect_black_level;
    float glow;
    float bloom;
    float mask_bloom;
    float bloom_dist;
    float halation;
    float TATE;
    float IOS;
    float OS;
    float BLOOM;
    float overscanX;
    float overscanY;
    float intres;
    float prescalex;
    float c_shape;
    float sborder;
    float csize;
    float bsize1;
    float warpX;
    float warpY;
    float gamma_c;
    float brightboost;
    float brightboost1;
    float blendMode;
    float gsl;
    float scanline1;
    float scanline2;
    float beam_min;
    float beam_max;
    float beam_size;
    float vertmask;
    float scans;
    float scan_falloff;
    float spike;
    float ring;
    float scangamma;
    float rolling_scan;
    float h_sharp;
    float s_sharp;
    float smart_ei;
    float ei_limit;
    float sth;
    float barspeed;
    float barintensity;
    float bardir;
    float shadowMask;
    float maskstr;
    float mcut;
    float masksize;
    float maskDark;
    float maskLight;
    float mask_gamma;
    float slotmask;
    float slotmask1;
    float slotwidth;
    float double_slot;
    float slotms;
    float mclip;
    float mshift;
    float mask_layout;
    float GDV_DECONVERGENCE_ON;
    float decons;
    float GDV_NOISE_ON;
    float addnoised;
    float noisetype;
    float noiseresd;
    float deconrr;
    float deconrg;
    float deconrb;
    float deconrry;
    float deconrgy;
    float deconrby;
    float deconsmooth;
    float dctypex;
    float dctypey;
    float g_grade_on;
    float wp_temperature;
    float g_satr;
    float g_satg;
    float g_satb;
    float AS;
    float asat;
    float hcrt_h_size;
    float hcrt_v_size;
    float hcrt_h_cent;
    float hcrt_v_cent;
    float hcrt_pin_phase;
    float hcrt_pin_amp;
} global;

layout(binding = 8) uniform sampler2D InfoCachePass;
layout(binding = 9) uniform sampler2D InfoCachePassFeedback;
layout(binding = 2) uniform sampler2D TextPassFeedback;

layout(location = 0) in vec2 vTexCoord;
layout(location = 0) out vec4 FragColor;
float NEGATIVE_CROP_EXPAND_MULTIPLIER;
float MAX_NEGATIVE_CROP;
float DEFAULT_SCREEN_ASPECT;
float DEFAULT_BEZEL_ASPECT;
vec2 DEFAULT_SCREEN_SCALE;
vec2 DEFAULT_BEZEL_SCALE;
int INFOCACHE_MAX_INDEX;
float BLEND_MODE_OFF;
float BLEND_MODE_NORMAL;
float BLEND_MODE_ADD;
float BLEND_MODE_MULTIPLY;
float SOURCE_MATTE_PREMULTIPLIED;
float SOURCE_MATTE_WHITE;
float SOURCE_MATTE_NONE;
float IMAGE_ASPECT_MODE_INHERIT_ASPECT_SCALE;
float IMAGE_ASPECT_MODE_KEEP_ASPECT;
float FILL_MODE_STRETCH;
float FILL_MODE_SPLIT_FILL_HORIZONTAL;
float FILL_MODE_SPLIT_FILL_VERTICAL;
bool CACHE_INFO_PARAM_SUM_CHANGED;
float CURRENT_FRAME_FROM_CACHE_INFO;
float TUBE_DIFFUSE_MASK;
float TUBE_MASK;
float BEZEL_MASK;
float INSIDE_BEZEL_MASK;
float OUTSIDE_TUBE_MASK_FOR_IMAGE;
float FRAME_MASK;
float FRAME_MASK_FOR_IMAGE;
float OUTSIDE_BEZEL_MASK;
float OUTSIDE_FRAME_MASK_FOR_IMAGE;
float OUTSIDE_FRAME_MASK;
float CUTOUT_MASK;
float SCREEN_INDEX;
float SCREEN_ASPECT;
vec2 SCREEN_SCALE;
vec2 SCREEN_POS_OFFSET;
vec2 SCREEN_SCALE_2ND_SCREEN;
vec2 SCREEN_POS_OFFSET_2ND_SCREEN;
vec2 VIEWPORT_SCALE;
vec2 VIEWPORT_POS;
vec2 TUBE_SCALE;
vec2 TUBE_DIFFUSE_SCALE;
float TUBE_DIFFUSE_ASPECT;
vec2 FRAME_SCALE;
vec2 BEZEL_OUTSIDE_SCALE;
vec2 BACKGROUND_SCALE;
vec2 LED_SCALE;
vec2 DEVICE_SCALE;
vec2 DECAL_SCALE;
vec2 CAB_GLASS_SCALE;
vec2 TOP_IMAGE_SCALE;
float AVERAGE_LUMA;
float USE_VERTICAL_SCANLINES;
vec2 CORE_SIZE;
vec2 ROTATED_CORE_ORIGINAL_SIZE;
vec2 ROTATED_CORE_PREPPED_SIZE;
vec2 ROTATED_DEREZED_SIZE;
vec2 CROPPED_ROTATED_SIZE_WITH_RES_MULT;
vec2 CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK;
vec2 CROPPED_ROTATED_SIZE;
vec2 SAMPLE_AREA_START_PIXEL_COORD;
vec2 VIEWPORT_UNSCALED_COORD;
vec2 SCREEN_COORD;
vec2 TUBE_COORD;
vec2 TUBE_DIFFUSE_COORD;
vec2 BEZEL_OUTSIDE_COORD;
vec2 BACKGROUND_COORD;
vec2 DEVICE_COORD;
vec2 LED_COORD;
vec2 DECAL_COORD;
vec2 CAB_GLASS_COORD;
vec2 TOP_IMAGE_COORD;
vec2 SCREEN_CURVED_COORD;
vec2 TUBE_CURVED_COORD;
vec2 TUBE_DIFFUSE_CURVED_COORD;
vec2 BEZEL_OUTSIDE_CURVED_COORD;
vec2 FRAME_OUTSIDE_CURVED_COORD;
vec2 BACKGROUND_CURVED_COORD;
vec2 LED_CURVED_COORD;
vec2 DEVICE_CURVED_COORD;
vec2 DECAL_CURVED_COORD;
vec2 CAB_GLASS_CURVED_COORD;
vec2 TOP_IMAGE_CURVED_COORD;
float HSM_RESOLUTION_DEBUG_ON;
float HSM_CACHE_GRAPHICS_ON;
float HSM_CACHE_UPDATE_INDICATOR_MODE;
float HSM_GLOBAL_GRAPHICS_BRIGHTNESS;
float HSM_STATIC_LAYERS_GAMMA;
float HSM_AMBIENT_LIGHTING_OPACITY;
float HSM_AMBIENT2_LIGHTING_OPACITY;
float HSM_AMBIENT_LIGHTING_SWAP_IMAGES;
float HSM_VIEWPORT_ZOOM;
float HSM_VIEWPORT_ZOOM_MASK;
float HSM_VIEWPORT_POSITION_X;
float HSM_VIEWPORT_POSITION_Y;
float HSM_FLIP_VIEWPORT_VERTICAL;
float HSM_FLIP_VIEWPORT_HORIZONTAL;
float HSM_FLIP_CORE_VERTICAL;
float HSM_FLIP_CORE_HORIZONTAL;
float HSM_ROTATE_CORE_IMAGE;
float HSM_ASPECT_RATIO_ORIENTATION;
float HSM_ASPECT_RATIO_MODE;
float HSM_ASPECT_RATIO_EXPLICIT;
float HSM_VERTICAL_PRESET;
float HSM_INT_SCALE_MAX_HEIGHT;
float HSM_NON_INTEGER_SCALE;
float HSM_USE_PHYSICAL_SIZE_FOR_NON_INTEGER;
float HSM_PHYSICAL_MONITOR_ASPECT_RATIO;
float HSM_PHYSICAL_MONITOR_DIAGONAL_SIZE;
float HSM_PHYSICAL_SIM_TUBE_DIAGONAL_SIZE;
float HSM_USE_IMAGE_FOR_PLACEMENT;
float HSM_PLACEMENT_IMAGE_USE_HORIZONTAL;
float HSM_PLACEMENT_IMAGE_MODE;
float HSM_NON_INTEGER_SCALE_OFFSET;
float HSM_USE_SNAP_TO_CLOSEST_INT_SCALE;
float HSM_SNAP_TO_CLOSEST_INT_SCALE_TOLERANCE;
float HSM_SCREEN_POSITION_X;
float HSM_SCREEN_POSITION_Y;
float HSM_CROP_MODE;
float HSM_CROP_PERCENT_ZOOM;
float HSM_CROP_PERCENT_TOP;
float HSM_CROP_PERCENT_BOTTOM;
float HSM_CROP_PERCENT_LEFT;
float HSM_CROP_PERCENT_RIGHT;
float HSM_CROP_BLACK_THRESHOLD;
float HSM_SCANLINE_DIRECTION;
float HSM_CORE_RES_SAMPLING_MULT_SCANLINE_DIR;
float HSM_DOWNSAMPLE_BLUR_SCANLINE_DIR;
float HSM_CORE_RES_SAMPLING_MULT_OPPOSITE_DIR;
float HSM_DOWNSAMPLE_BLUR_OPPOSITE_DIR;
float HSM_CORE_RES_SAMPLING_SHIFT_OPPOSITE_DIR;
float HSM_USE_GEOM;
float HSM_CURVATURE_MODE;
float HSM_CURVATURE_3D_RADIUS;
float HSM_CURVATURE_3D_VIEW_DIST;
float HSM_CURVATURE_3D_TILT_ANGLE_X;
float HSM_CURVATURE_3D_TILT_ANGLE_Y;
float HSM_CRT_CURVATURE_SCALE;
float HSM_AB_COMPARE_SHOW_MODE;
float HSM_AB_COMPARE_AREA;
float HSM_AB_COMPARE_SPLIT_POSITION;
float HSM_AB_COMPARE_FREEZE_CRT_TUBE;
float HSM_AB_COMPARE_FREEZE_GRAPHICS;
float HSM_SCREEN_VIGNETTE_DUALSCREEN_VIS_MODE;
float HSM_MONOCHROME_DUALSCREEN_VIS_MODE;
float HSM_TUBE_DIFFUSE_MODE;
float HSM_TUBE_DIFFUSE_OPACITY;
float HSM_TUBE_DIFFUSE_IMAGE_DUALSCREEN_VIS_MODE;
float HSM_TUBE_DIFFUSE_IMAGE_COLORIZE_ON;
float HSM_TUBE_DIFFUSE_IMAGE_HUE;
float HSM_TUBE_DIFFUSE_IMAGE_SATURATION;
float HSM_TUBE_DIFFUSE_IMAGE_BRIGHTNESS;
float HSM_TUBE_DIFFUSE_IMAGE_GAMMA;
float HSM_TUBE_DIFFUSE_IMAGE_AMBIENT_LIGHTING;
float HSM_TUBE_DIFFUSE_IMAGE_AMBIENT2_LIGHTING;
float HSM_TUBE_DIFFUSE_IMAGE_SCALE;
float HSM_TUBE_DIFFUSE_IMAGE_SCALE_X;
float HSM_TUBE_SHADOW_IMAGE_ON;
float HSM_TUBE_SHADOW_IMAGE_OPACITY;
float HSM_TUBE_SHADOW_IMAGE_POS_X;
float HSM_TUBE_SHADOW_IMAGE_POS_Y;
float HSM_TUBE_SHADOW_IMAGE_SCALE_X;
float HSM_TUBE_SHADOW_IMAGE_SCALE_Y;
float HSM_TUBE_SHADOW_CURVATURE_SCALE;
float HSM_TUBE_COLORED_GEL_IMAGE_ON;
float HSM_TUBE_COLORED_GEL_IMAGE_SCALE;
float HSM_TUBE_COLORED_GEL_IMAGE_FLIP_HORIZONTAL;
float HSM_TUBE_COLORED_GEL_IMAGE_FLIP_VERTICAL;
float HSM_TUBE_COLORED_GEL_IMAGE_DUALSCREEN_VIS_MODE;
float HSM_TUBE_COLORED_GEL_IMAGE_MULTIPLY_AMOUNT;
float HSM_TUBE_COLORED_GEL_IMAGE_ADDITIVE_AMOUNT;
float HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_AMOUNT;
float HSM_TUBE_COLORED_GEL_IMAGE_TRANSPARENCY_THRESHOLD;
float HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_BRIGHTNESS;
float HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_VIGNETTE;
float HSM_TUBE_COLORED_GEL_IMAGE_FAKE_SCANLINE_AMOUNT;
float HSM_TUBE_COLORED_GEL_IMAGE_AMBIENT_LIGHTING;
float HSM_TUBE_COLORED_GEL_IMAGE_AMBIENT2_LIGHTING;
float HSM_SHOW_CRT_ON_TOP_OF_COLORED_GEL;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_ON;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_DUALSCREEN_VIS_MODE;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_OPACITY;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_AMBIENT_LIGHTING;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_AMBIENT2_LIGHTING;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_SCALE;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_SHADOW_OPACITY;
float HSM_DUALSCREEN_MODE;
float HSM_DUALSCREEN_CORE_IMAGE_SPLIT_MODE;
float HSM_DUALSCREEN_CORE_IMAGE_SWAP_SCREENS;
float HSM_DUALSCREEN_CORE_IMAGE_SPLIT_OFFSET;
float HSM_DUALSCREEN_VIEWPORT_SPLIT_LOCATION;
float HSM_DUALSCREEN_SHIFT_POSITION_WITH_SCALE;
float HSM_DUALSCREEN_POSITION_OFFSET_BETWEEN_SCREENS;
float HSM_2ND_SCREEN_ASPECT_RATIO_MODE;
float HSM_2ND_SCREEN_INDEPENDENT_SCALE;
float HSM_2ND_SCREEN_SCALE_OFFSET;
float HSM_2ND_SCREEN_POS_X;
float HSM_2ND_SCREEN_POS_Y;
float HSM_2ND_SCREEN_CROP_PERCENT_ZOOM;
float HSM_2ND_SCREEN_CROP_PERCENT_TOP;
float HSM_2ND_SCREEN_CROP_PERCENT_BOTTOM;
float HSM_2ND_SCREEN_CROP_PERCENT_LEFT;
float HSM_2ND_SCREEN_CROP_PERCENT_RIGHT;
float HSM_SCREEN_REFLECTION_SCALE;
float HSM_SCREEN_REFLECTION_POS_X;
float HSM_SCREEN_REFLECTION_POS_Y;
float HSM_AMBIENT_LIGHTING_HUE;
float HSM_AMBIENT_LIGHTING_SATURATION;
float HSM_AMBIENT_LIGHTING_VALUE;
float HSM_AMBIENT_LIGHTING_CONTRAST;
float HSM_AMBIENT_LIGHTING_SCALE_KEEP_ASPECT;
float HSM_AMBIENT_LIGHTING_SCALE_WITH_ZOOM;
float HSM_AMBIENT_LIGHTING_SCALE;
float HSM_AMBIENT_LIGHTING_SCALE_X;
float HSM_AMBIENT_LIGHTING_ROTATE;
float HSM_AMBIENT_LIGHTING_MIRROR_HORZ;
float HSM_AMBIENT_LIGHTING_POSITION_X;
float HSM_AMBIENT_LIGHTING_POSITION_Y;
float HSM_AMBIENT_LIGHTING_DITHERING_SAMPLES;
float HSM_AMBIENT2_LIGHTING_HUE;
float HSM_AMBIENT2_LIGHTING_SATURATION;
float HSM_AMBIENT2_LIGHTING_VALUE;
float HSM_AMBIENT2_LIGHTING_CONTRAST;
float HSM_AMBIENT2_LIGHTING_SCALE_KEEP_ASPECT;
float HSM_AMBIENT2_LIGHTING_SCALE_WITH_ZOOM;
float HSM_AMBIENT2_LIGHTING_SCALE;
float HSM_AMBIENT2_LIGHTING_SCALE_X;
float HSM_AMBIENT2_LIGHTING_ROTATE;
float HSM_AMBIENT2_LIGHTING_MIRROR_HORZ;
float HSM_AMBIENT2_LIGHTING_POSITION_X;
float HSM_AMBIENT2_LIGHTING_POSITION_Y;
float HSM_BZL_OPACITY;
float HSM_BZL_BLEND_MODE;
float HSM_BZL_WIDTH;
float HSM_BZL_HEIGHT;
float HSM_BZL_INNER_CORNER_RADIUS_SCALE;
float HSM_BZL_INNER_EDGE_THICKNESS;
float HSM_BZL_INNER_EDGE_SHARPNESS;
float HSM_BZL_OUTER_POSITION_Y;
float HSM_BZL_OUTER_CURVATURE_SCALE;
float HSM_BZL_OUTER_CORNER_RADIUS_SCALE;
float HSM_BZL_BRIGHTNESS;
float HSM_BZL_HIGHLIGHT;
float HSM_BZL_NOISE;
float HSM_BZL_INNER_EDGE_SHADOW;
float HSM_BZL_COLOR_HUE;
float HSM_BZL_COLOR_SATURATION;
float HSM_BZL_COLOR_VALUE;
float HSM_BZL_AMBIENT_LIGHTING_MULTIPLIER;
float HSM_BZL_AMBIENT2_LIGHTING_MULTIPLIER;
float HSM_FRM_USE_INDEPENDENT_COLOR;
float HSM_FRM_COLOR_HUE;
float HSM_FRM_COLOR_SATURATION;
float HSM_FRM_COLOR_VALUE;
float HSM_FRM_OPACITY;
float HSM_FRM_BLEND_MODE;
float HSM_FRM_TEXTURE_OPACITY;
float HSM_FRM_TEXTURE_BLEND_MODE;
float HSM_FRM_NOISE;
float HSM_FRM_INNER_EDGE_THICKNESS;
float HSM_FRM_THICKNESS;
float HSM_FRM_THICKNESS_SCALE_X;
float HSM_FRM_OUTER_POS_Y;
float HSM_FRM_OUTER_CURVATURE_SCALE;
float HSM_FRM_OUTER_CORNER_RADIUS;
float HSM_FRM_OUTER_EDGE_THICKNESS;
float HSM_FRM_OUTER_EDGE_SHADING;
float HSM_FRM_SHADOW_OPACITY;
float HSM_FRM_SHADOW_WIDTH;
float HSM_REFLECT_CORNER_FADE;
float HSM_REFLECT_CORNER_FADE_DISTANCE;
float HSM_REFLECT_CORNER_INNER_SPREAD;
float HSM_REFLECT_CORNER_OUTER_SPREAD;
float HSM_REFLECT_CORNER_ROTATION_OFFSET_TOP;
float HSM_REFLECT_CORNER_ROTATION_OFFSET_BOTTOM;
float HSM_REFLECT_CORNER_SPREAD_FALLOFF;
float HSM_REFLECT_GLOBAL_AMOUNT;
float HSM_REFLECT_GLOBAL_GAMMA_ADJUST;
float HSM_REFLECT_DIRECT_AMOUNT;
float HSM_REFLECT_DIFFUSED_AMOUNT;
float HSM_REFLECT_FULLSCREEN_GLOW;
float HSM_REFLECT_FULLSCREEN_GLOW_GAMMA;
float HSM_REFLECT_BEZEL_INNER_EDGE_AMOUNT;
float HSM_REFLECT_BEZEL_INNER_EDGE_FULLSCREEN_GLOW;
float HSM_REFLECT_FRAME_INNER_EDGE_AMOUNT;
float HSM_REFLECT_FRAME_INNER_EDGE_SHARPNESS;
float HSM_REFLECT_FADE_AMOUNT;
float HSM_REFLECT_RADIAL_FADE_WIDTH;
float HSM_REFLECT_RADIAL_FADE_HEIGHT;
float HSM_REFLECT_LATERAL_OUTER_FADE_POSITION;
float HSM_REFLECT_LATERAL_OUTER_FADE_DISTANCE;
float HSM_REFLECT_BLUR_NUM_SAMPLES;
float HSM_REFLECT_BLUR_MIN;
float HSM_REFLECT_BLUR_MAX;
float HSM_REFLECT_BLUR_FALLOFF_DISTANCE;
float HSM_REFLECT_NOISE_AMOUNT;
float HSM_REFLECT_NOISE_SAMPLES;
float HSM_REFLECT_NOISE_SAMPLE_DISTANCE;
float HSM_GLASS_BORDER_ON;
float HSM_REFLECT_VIGNETTE_AMOUNT;
float HSM_REFLECT_VIGNETTE_SIZE;
float HSM_BG_LAYER_ORDER;
float HSM_VIEWPORT_VIGNETTE_LAYER_ORDER;
float HSM_LED_LAYER_ORDER;
float HSM_DEVICE_LAYER_ORDER;
float HSM_CRT_LAYER_ORDER;
float HSM_DECAL_LAYER_ORDER;
float HSM_CAB_GLASS_LAYER_ORDER;
float HSM_TOP_LAYER_ORDER;
float HSM_CUTOUT_ASPECT_MODE;
float HSM_CUTOUT_EXPLICIT_ASPECT;
float HSM_CUTOUT_SCALE_MODE;
float HSM_CUTOUT_SCALE_FULL_WITH_ZOOM;
float HSM_CUTOUT_KEEP_ASPECT;
float HSM_CUTOUT_SCALE;
float HSM_CUTOUT_SCALE_X;
float HSM_CUTOUT_POS_X;
float HSM_CUTOUT_POS_Y;
float HSM_CUTOUT_CORNER_RADIUS;
float HSM_LAYERING_DEBUG_MASK_MODE;
float HSM_BG_OPACITY;
float HSM_BG_COLORIZE_ON;
float HSM_BG_HUE;
float HSM_BG_SATURATION;
float HSM_BG_BRIGHTNESS;
float HSM_BG_GAMMA;
float HSM_BG_AMBIENT_LIGHTING_MULTIPLIER;
float HSM_BG_AMBIENT2_LIGHTING_MULTIPLIER;
float HSM_BG_APPLY_AMBIENT_IN_ADD_MODE;
float HSM_BG_BLEND_MODE;
float HSM_BG_SOURCE_MATTE_TYPE;
float HSM_BG_MASK_MODE;
float HSM_BG_CUTOUT_MODE;
float HSM_BG_DUALSCREEN_VIS_MODE;
float HSM_BG_SCALE_MODE;
float HSM_BG_SCALE_FULL_WITH_ZOOM;
float HSM_BG_SCALE_KEEP_ASPECT;
float HSM_BG_FILL_MODE;
float HSM_BG_SCALE;
float HSM_BG_SCALE_X;
float HSM_BG_POS_X;
float HSM_BG_POS_Y;
float HSM_BG_MIRROR_WRAP;
float HSM_BG_MIPMAPPING_BLEND_BIAS;
float HSM_VIEWPORT_VIGNETTE_OPACITY;
float HSM_VIEWPORT_VIGNETTE_MASK_MODE;
float HSM_VIEWPORT_VIGNETTE_CUTOUT_MODE;
float HSM_VIEWPORT_VIGNETTE_SCALE_MODE;
float HSM_VIEWPORT_VIGNETTE_SCALE;
float HSM_VIEWPORT_VIGNETTE_SCALE_X;
float HSM_VIEWPORT_VIGNETTE_POS_X;
float HSM_VIEWPORT_VIGNETTE_POS_Y;
float HSM_LED_OPACITY;
float HSM_LED_COLORIZE_ON;
float HSM_LED_HUE;
float HSM_LED_SATURATION;
float HSM_LED_BRIGHTNESS;
float HSM_LED_GAMMA;
float HSM_LED_AMBIENT_LIGHTING_MULTIPLIER;
float HSM_LED_AMBIENT2_LIGHTING_MULTIPLIER;
float HSM_LED_APPLY_AMBIENT_IN_ADD_MODE;
float HSM_LED_BLEND_MODE;
float HSM_LED_SOURCE_MATTE_TYPE;
float HSM_LED_MASK_MODE;
float HSM_LED_CUTOUT_MODE;
float HSM_LED_DUALSCREEN_VIS_MODE;
float HSM_LED_SCALE_MODE;
float HSM_LED_SCALE_FULL_WITH_ZOOM;
float HSM_LED_SCALE_KEEP_ASPECT;
float HSM_LED_FILL_MODE;
float HSM_LED_SCALE;
float HSM_LED_SCALE_X;
float HSM_LED_POS_X;
float HSM_LED_POS_Y;
float HSM_LED_MIPMAPPING_BLEND_BIAS;
float HSM_DEVICE_OPACITY;
float HSM_DEVICE_COLORIZE_ON;
float HSM_DEVICE_HUE;
float HSM_DEVICE_SATURATION;
float HSM_DEVICE_BRIGHTNESS;
float HSM_DEVICE_GAMMA;
float HSM_DEVICE_AMBIENT_LIGHTING_MULTIPLIER;
float HSM_DEVICE_AMBIENT2_LIGHTING_MULTIPLIER;
float HSM_DEVICE_APPLY_AMBIENT_IN_ADD_MODE;
float HSM_DEVICE_BLEND_MODE;
float HSM_DEVICE_SOURCE_MATTE_TYPE;
float HSM_DEVICE_MASK_MODE;
float HSM_DEVICE_CUTOUT_MODE;
float HSM_DEVICE_DUALSCREEN_VIS_MODE;
float HSM_DEVICE_SCALE_MODE;
float HSM_DEVICE_SCALE_FULL_WITH_ZOOM;
float HSM_DEVICE_COPY_INHERITED_COORD;
float HSM_DEVICE_SCALE_KEEP_ASPECT;
float HSM_DEVICE_FILL_MODE;
float HSM_DEVICE_SCALE;
float HSM_DEVICE_SCALE_X;
float HSM_DEVICE_POS_X;
float HSM_DEVICE_POS_Y;
float HSM_DEVICE_MIPMAPPING_BLEND_BIAS;
float HSM_DECAL_OPACITY;
float HSM_DECAL_COLORIZE_ON;
float HSM_DECAL_HUE;
float HSM_DECAL_SATURATION;
float HSM_DECAL_BRIGHTNESS;
float HSM_DECAL_GAMMA;
float HSM_DECAL_AMBIENT_LIGHTING_MULTIPLIER;
float HSM_DECAL_AMBIENT2_LIGHTING_MULTIPLIER;
float HSM_DECAL_APPLY_AMBIENT_IN_ADD_MODE;
float HSM_DECAL_BLEND_MODE;
float HSM_DECAL_SOURCE_MATTE_TYPE;
float HSM_DECAL_MASK_MODE;
float HSM_DECAL_CUTOUT_MODE;
float HSM_DECAL_DUALSCREEN_VIS_MODE;
float HSM_DECAL_SCALE_MODE;
float HSM_DECAL_SCALE_FULL_WITH_ZOOM;
float HSM_DECAL_SCALE_KEEP_ASPECT;
float HSM_DECAL_FILL_MODE;
float HSM_DECAL_SCALE;
float HSM_DECAL_SCALE_X;
float HSM_DECAL_POS_X;
float HSM_DECAL_POS_Y;
float HSM_DECAL_MIPMAPPING_BLEND_BIAS;
float HSM_CAB_GLASS_OPACITY;
float HSM_CAB_GLASS_COLORIZE_ON;
float HSM_CAB_GLASS_HUE;
float HSM_CAB_GLASS_SATURATION;
float HSM_CAB_GLASS_BRIGHTNESS;
float HSM_CAB_GLASS_GAMMA;
float HSM_CAB_GLASS_AMBIENT_LIGHTING_MULTIPLIER;
float HSM_CAB_GLASS_AMBIENT2_LIGHTING_MULTIPLIER;
float HSM_CAB_GLASS_APPLY_AMBIENT_IN_ADD_MODE;
float HSM_CAB_GLASS_BLEND_MODE;
float HSM_CAB_GLASS_SOURCE_MATTE_TYPE;
float HSM_CAB_GLASS_MASK_MODE;
float HSM_CAB_GLASS_CUTOUT_MODE;
float HSM_CAB_GLASS_DUALSCREEN_VIS_MODE;
float HSM_CAB_GLASS_SCALE_MODE;
float HSM_CAB_GLASS_SCALE_FULL_WITH_ZOOM;
float HSM_CAB_GLASS_SCALE_KEEP_ASPECT;
float HSM_CAB_GLASS_FILL_MODE;
float HSM_CAB_GLASS_SCALE;
float HSM_CAB_GLASS_SCALE_X;
float HSM_CAB_GLASS_POS_X;
float HSM_CAB_GLASS_POS_Y;
float HSM_CAB_GLASS_MIPMAPPING_BLEND_BIAS;
float HSM_TOP_OPACITY;
float HSM_TOP_COLORIZE_ON;
float HSM_TOP_HUE;
float HSM_TOP_SATURATION;
float HSM_TOP_BRIGHTNESS;
float HSM_TOP_GAMMA;
float HSM_TOP_AMBIENT_LIGHTING_MULTIPLIER;
float HSM_TOP_AMBIENT2_LIGHTING_MULTIPLIER;
float HSM_TOP_APPLY_AMBIENT_IN_ADD_MODE;
float HSM_TOP_BLEND_MODE;
float HSM_TOP_SOURCE_MATTE_TYPE;
float HSM_TOP_MASK_MODE;
float HSM_TOP_CUTOUT_MODE;
float HSM_TOP_DUALSCREEN_VIS_MODE;
float HSM_TOP_SCALE_MODE;
float HSM_TOP_SCALE_FULL_WITH_ZOOM;
float HSM_TOP_SCALE_KEEP_ASPECT;
float HSM_TOP_FILL_MODE;
float HSM_TOP_SCALE;
float HSM_TOP_SCALE_X;
float HSM_TOP_POS_X;
float HSM_TOP_POS_Y;
float HSM_TOP_MIRROR_WRAP;
float HSM_TOP_MIPMAPPING_BLEND_BIAS;
float HSM_RENDER_SIMPLE_MODE;
float HSM_RENDER_SIMPLE_MASK_TYPE;
float CURVATURE_MODE_OFF;
float CURVATURE_MODE_2D;
float CURVATURE_MODE_2D_CYLINDER;
float CURVATURE_MODE_3D_1;
float CURVATURE_MODE_3D_2;
float CURVATURE_MODE_3D_CYLINDER;
int TEXT_MODE;
vec4 ch_spc;
vec4 ch_exc;
vec4 ch_quo;
vec4 ch_hsh;
vec4 ch_dol;
vec4 ch_pct;
vec4 ch_amp;
vec4 ch_apo;
vec4 ch_lbr;
vec4 ch_rbr;
vec4 ch_ast;
vec4 ch_crs;
vec4 ch_com;
vec4 ch_dsh;
vec4 ch_per;
vec4 ch_lsl;
vec4 ch_0;
vec4 ch_1;
vec4 ch_2;
vec4 ch_3;
vec4 ch_4;
vec4 ch_5;
vec4 ch_6;
vec4 ch_7;
vec4 ch_8;
vec4 ch_9;
vec4 ch_col;
vec4 ch_scl;
vec4 ch_les;
vec4 ch_equ;
vec4 ch_grt;
vec4 ch_que;
vec4 ch_ats;
vec4 ch_A;
vec4 ch_B;
vec4 ch_C;
vec4 ch_D;
vec4 ch_E;
vec4 ch_F;
vec4 ch_G;
vec4 ch_H;
vec4 ch_I;
vec4 ch_J;
vec4 ch_K;
vec4 ch_L;
vec4 ch_M;
vec4 ch_N;
vec4 ch_O;
vec4 ch_P;
vec4 ch_Q;
vec4 ch_R;
vec4 ch_S;
vec4 ch_T;
vec4 ch_U;
vec4 ch_V;
vec4 ch_W;
vec4 ch_X;
vec4 ch_Y;
vec4 ch_Z;
vec4 ch_lsb;
vec4 ch_rsl;
vec4 ch_rsb;
vec4 ch_pow;
vec4 ch_usc;
vec4 ch_a;
vec4 ch_b;
vec4 ch_c;
vec4 ch_d;
vec4 ch_e;
vec4 ch_f;
vec4 ch_g;
vec4 ch_h;
vec4 ch_i;
vec4 ch_j;
vec4 ch_k;
vec4 ch_l;
vec4 ch_m;
vec4 ch_n;
vec4 ch_o;
vec4 ch_p;
vec4 ch_q;
vec4 ch_r;
vec4 ch_s;
vec4 ch_t;
vec4 ch_u;
vec4 ch_v;
vec4 ch_w;
vec4 ch_x;
vec4 ch_y;
vec4 ch_z;
vec4 ch_lpa;
vec4 ch_bar;
vec4 ch_rpa;
vec4 ch_tid;
vec4 ch_lar;
vec2 textCanvasResolution;
vec2 printPos;
float epsilon;

vec2 HSM_GetViewportCoordWithFlip(vec2 viewport_coord)
{
    vec2 out_coord = viewport_coord;
    if (HSM_FLIP_VIEWPORT_VERTICAL == (-1.0))
    {
        out_coord.y = 1.0 - out_coord.y;
    }
    if (HSM_FLIP_VIEWPORT_HORIZONTAL == (-1.0))
    {
        out_coord.x = 1.0 - out_coord.x;
    }
    return out_coord;
}

vec2 HSM_GetViewportCoordWithZoomAndPan(vec2 viewport_coord)
{
    vec2 param = viewport_coord;
    vec2 out_coord = HSM_GetViewportCoordWithFlip(param);
    out_coord = ((out_coord - vec2(0.5)) / vec2(HSM_VIEWPORT_ZOOM)) + vec2(0.5);
    out_coord.x += HSM_VIEWPORT_POSITION_X;
    out_coord.y -= HSM_VIEWPORT_POSITION_Y;
    return out_coord;
}

float HSM_GetScreenIndex(vec2 viewport_coord)
{
    float out_index = 1.0;
    float output_aspect = global.FinalViewportSize.x / global.FinalViewportSize.y;
    if (HSM_DUALSCREEN_MODE == 0.0)
    {
        out_index = 1.0;
    }
    if (HSM_DUALSCREEN_MODE == 1.0)
    {
        out_index = float((viewport_coord.y < (0.5 + (HSM_DUALSCREEN_VIEWPORT_SPLIT_LOCATION / output_aspect))) ? 1 : 2);
    }
    if (HSM_DUALSCREEN_MODE == 2.0)
    {
        out_index = float((viewport_coord.x < (0.5 + (HSM_DUALSCREEN_VIEWPORT_SPLIT_LOCATION / output_aspect))) ? 1 : 2);
    }
    return out_index;
}

vec2 HSM_GetRotatedNegativeCropAddedSize()
{
    return (global.NegativeCropAddedPassSize.yx * HSM_ROTATE_CORE_IMAGE) + (global.NegativeCropAddedPassSize.xy * (1.0 - HSM_ROTATE_CORE_IMAGE));
}

vec2 HSM_GetRotatedCoreOriginalSize()
{
    return (global.OriginalSize.yx * HSM_ROTATE_CORE_IMAGE) + (global.OriginalSize.xy * (1.0 - HSM_ROTATE_CORE_IMAGE));
}

vec4 HSM_GetCacheSampleRange(float column_index, float row_index)
{
    float num_rows = 8.0;
    float num_columns = 8.0;
    float range_width = 1.0 / num_columns;
    float range_height = 1.0 / num_rows;
    float zero_based_row_index = row_index - 1.0;
    float zero_based_column_index = column_index - 1.0;
    vec4 out_sample_range = vec4(0.0);
    out_sample_range.x = zero_based_column_index * range_width;
    out_sample_range.y = zero_based_row_index * range_height;
    out_sample_range.z = out_sample_range.x + range_width;
    out_sample_range.w = out_sample_range.y + range_height;
    return out_sample_range;
}

vec2 HSM_GetCacheSampleCoord(float column_index, float row_index)
{
    float num_rows = 8.0;
    float num_columns = 8.0;
    float range_width = 1.0 / num_columns;
    float range_height = 1.0 / num_rows;
    float param = column_index;
    float param_1 = row_index;
    vec4 sample_range = HSM_GetCacheSampleRange(param, param_1);
    return vec2(sample_range.x + (range_width / 2.0), sample_range.y + (range_height / 2.0));
}

float HSM_GetUseVerticalScanlines(float screen_aspect)
{
    float auto_use_vert_scanlines = float(int(screen_aspect < 1.0));
    float scanline_direction = float((HSM_SCANLINE_DIRECTION < 2.0) ? 0 : 1);
    if (HSM_SCANLINE_DIRECTION < 1.0)
    {
        if (HSM_DUALSCREEN_MODE < 1.0)
        {
            scanline_direction = auto_use_vert_scanlines;
        }
    }
    return scanline_direction;
}

vec2 HSM_GetCoordWithPositionOffset(vec2 in_coord, vec2 position_offset)
{
    return in_coord - position_offset;
}

vec2 HSM_GetInverseScaledCoord(vec2 in_coord, vec2 in_scale)
{
    vec2 middle = vec2(0.499989986419677734375);
    vec2 diff = in_coord - middle;
    vec2 screen_inverse_scale = vec2(1.0) / in_scale;
    vec2 scaled_coord = middle + (diff * screen_inverse_scale);
    return scaled_coord;
}

vec2 HSM_GetVTexCoordWithArgs(vec2 in_coord, vec2 in_scale, vec2 position_offset)
{
    vec2 param = in_coord;
    vec2 param_1 = position_offset;
    vec2 param_2 = HSM_GetCoordWithPositionOffset(param, param_1);
    vec2 param_3 = in_scale;
    return HSM_GetInverseScaledCoord(param_2, param_3);
}

vec4 HSM_UpdateGlobalScreenValuesFromCache(sampler2D in_cache_pass, sampler2D in_cache_feedback_pass, vec2 vTexCoord_1)
{
    float output_aspect = global.FinalViewportSize.x / global.FinalViewportSize.y;
    vec2 param = vTexCoord_1;
    vec2 flipped_viewport_coord = HSM_GetViewportCoordWithZoomAndPan(param);
    vec2 param_1 = flipped_viewport_coord;
    SCREEN_INDEX = HSM_GetScreenIndex(param_1);
    CORE_SIZE = global.CorePassSize.xy;
    ROTATED_CORE_PREPPED_SIZE = HSM_GetRotatedNegativeCropAddedSize();
    ROTATED_CORE_ORIGINAL_SIZE = HSM_GetRotatedCoreOriginalSize();
    vec2 sample_coord = vec2(0.0);
    vec4 texture_sample = vec4(0.0);
    float param_2 = 1.0;
    float param_3 = 1.0;
    sample_coord = HSM_GetCacheSampleCoord(param_2, param_3);
    texture_sample = texture(in_cache_pass, sample_coord);
    AVERAGE_LUMA = texture_sample.w;
    float res_mult_size_sum = 0.0;
    float res_mult_size_sum_feedback = 0.0;
    float res_mult_size2_sum = 0.0;
    float res_mult_size2_sum_feedback = 0.0;
    if (SCREEN_INDEX == 1.0)
    {
        float param_4 = 2.0;
        float param_5 = 1.0;
        sample_coord = HSM_GetCacheSampleCoord(param_4, param_5);
        texture_sample = texture(in_cache_pass, sample_coord);
        SCREEN_ASPECT = texture_sample.x;
        SCREEN_SCALE = texture_sample.zw;
        float param_6 = 3.0;
        float param_7 = 1.0;
        sample_coord = HSM_GetCacheSampleCoord(param_6, param_7);
        texture_sample = texture(in_cache_pass, sample_coord);
        TUBE_SCALE = texture_sample.xy;
        SCREEN_POS_OFFSET = texture_sample.zw;
        float param_8 = 3.0;
        float param_9 = 4.0;
        sample_coord = HSM_GetCacheSampleCoord(param_8, param_9);
        texture_sample = texture(in_cache_pass, sample_coord);
        TUBE_DIFFUSE_SCALE = texture_sample.xy;
        TUBE_DIFFUSE_ASPECT = (TUBE_DIFFUSE_SCALE.x / TUBE_DIFFUSE_SCALE.y) * output_aspect;
        float param_10 = 4.0;
        float param_11 = 1.0;
        sample_coord = HSM_GetCacheSampleCoord(param_10, param_11);
        texture_sample = texture(in_cache_pass, sample_coord);
        CROPPED_ROTATED_SIZE_WITH_RES_MULT = texture_sample.xy;
        res_mult_size_sum = CROPPED_ROTATED_SIZE_WITH_RES_MULT.x + CROPPED_ROTATED_SIZE_WITH_RES_MULT.y;
        texture_sample = texture(in_cache_feedback_pass, sample_coord);
        CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK = texture_sample.xy;
        res_mult_size_sum_feedback = CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK.x + CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK.y;
        float param_12 = 1.0;
        float param_13 = 2.0;
        sample_coord = HSM_GetCacheSampleCoord(param_12, param_13);
        texture_sample = texture(in_cache_pass, sample_coord);
        CROPPED_ROTATED_SIZE = texture_sample.xy;
        SAMPLE_AREA_START_PIXEL_COORD = texture_sample.zw;
    }
    if (SCREEN_INDEX == 2.0)
    {
        float param_14 = 2.0;
        float param_15 = 2.0;
        sample_coord = HSM_GetCacheSampleCoord(param_14, param_15);
        texture_sample = texture(in_cache_pass, sample_coord);
        SCREEN_ASPECT = texture_sample.x;
        SCREEN_SCALE = texture_sample.yz;
        float param_16 = 3.0;
        float param_17 = 2.0;
        sample_coord = HSM_GetCacheSampleCoord(param_16, param_17);
        texture_sample = texture(in_cache_pass, sample_coord);
        TUBE_SCALE = texture_sample.xy;
        SCREEN_POS_OFFSET = texture_sample.zw;
        float param_18 = 3.0;
        float param_19 = 4.0;
        sample_coord = HSM_GetCacheSampleCoord(param_18, param_19);
        texture_sample = texture(in_cache_pass, sample_coord);
        TUBE_DIFFUSE_SCALE = texture_sample.zw;
        TUBE_DIFFUSE_ASPECT = (TUBE_DIFFUSE_SCALE.x / TUBE_DIFFUSE_SCALE.y) * output_aspect;
        float param_20 = 4.0;
        float param_21 = 2.0;
        sample_coord = HSM_GetCacheSampleCoord(param_20, param_21);
        texture_sample = texture(in_cache_pass, sample_coord);
        CROPPED_ROTATED_SIZE_WITH_RES_MULT = texture_sample.xy;
        res_mult_size2_sum = CROPPED_ROTATED_SIZE_WITH_RES_MULT.x + CROPPED_ROTATED_SIZE_WITH_RES_MULT.y;
        texture_sample = texture(in_cache_feedback_pass, sample_coord);
        CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK = texture_sample.xy;
        res_mult_size2_sum_feedback = CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK.x + CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK.y;
        float param_22 = 1.0;
        float param_23 = 3.0;
        sample_coord = HSM_GetCacheSampleCoord(param_22, param_23);
        texture_sample = texture(in_cache_pass, sample_coord);
        CROPPED_ROTATED_SIZE = texture_sample.xy;
        SAMPLE_AREA_START_PIXEL_COORD = texture_sample.zw;
    }
    float param_24 = 2.0;
    float param_25 = 3.0;
    sample_coord = HSM_GetCacheSampleCoord(param_24, param_25);
    texture_sample = texture(in_cache_pass, sample_coord);
    CORE_SIZE = texture_sample.xy;
    float param_26 = 3.0;
    float param_27 = 3.0;
    sample_coord = HSM_GetCacheSampleCoord(param_26, param_27);
    texture_sample = texture(in_cache_pass, sample_coord);
    VIEWPORT_SCALE = texture_sample.xy;
    VIEWPORT_POS = texture_sample.zw;
    float param_28 = 4.0;
    float param_29 = 3.0;
    sample_coord = HSM_GetCacheSampleCoord(param_28, param_29);
    texture_sample = texture(in_cache_pass, sample_coord);
    SCREEN_SCALE_2ND_SCREEN = texture_sample.xy;
    SCREEN_POS_OFFSET_2ND_SCREEN = texture_sample.zw;
    float param_30 = 1.0;
    float param_31 = 4.0;
    sample_coord = HSM_GetCacheSampleCoord(param_30, param_31);
    texture_sample = texture(in_cache_pass, sample_coord);
    float parameter_sum = texture_sample.x;
    CURRENT_FRAME_FROM_CACHE_INFO = texture_sample.y;
    ROTATED_DEREZED_SIZE = texture_sample.zw;
    texture_sample = texture(in_cache_feedback_pass, sample_coord);
    float parameter_sum_feedback = texture_sample.x;
    float param_32 = 2.0;
    float param_33 = 4.0;
    sample_coord = HSM_GetCacheSampleCoord(param_32, param_33);
    texture_sample = texture(in_cache_pass, sample_coord);
    NEGATIVE_CROP_EXPAND_MULTIPLIER = texture_sample.x;
    MAX_NEGATIVE_CROP = texture_sample.y;
    float param_34 = SCREEN_ASPECT;
    USE_VERTICAL_SCANLINES = HSM_GetUseVerticalScanlines(param_34);
    vec2 param_35 = flipped_viewport_coord;
    vec2 param_36 = SCREEN_SCALE;
    vec2 param_37 = SCREEN_POS_OFFSET;
    SCREEN_COORD = HSM_GetVTexCoordWithArgs(param_35, param_36, param_37);
    vec2 param_38 = flipped_viewport_coord;
    vec2 param_39 = TUBE_DIFFUSE_SCALE;
    vec2 param_40 = SCREEN_POS_OFFSET;
    TUBE_DIFFUSE_COORD = HSM_GetVTexCoordWithArgs(param_38, param_39, param_40);
    float param_sum_epsilon = 1.0000000116860974230803549289703e-07;
    CACHE_INFO_PARAM_SUM_CHANGED = false;
    CACHE_INFO_PARAM_SUM_CHANGED = ((res_mult_size_sum != res_mult_size_sum_feedback) || (res_mult_size2_sum != res_mult_size2_sum_feedback)) ? true : CACHE_INFO_PARAM_SUM_CHANGED;
    CACHE_INFO_PARAM_SUM_CHANGED = (abs(parameter_sum - parameter_sum_feedback) > param_sum_epsilon) ? true : CACHE_INFO_PARAM_SUM_CHANGED;
    return vec4(0.0);
}

bool HSM_CheckCacheInfoChanged()
{
    float epsilon_1 = 9.9999997473787516355514526367188e-05;
    return CACHE_INFO_PARAM_SUM_CHANGED;
}

vec2 GetScreenSize(vec2 screen_scale)
{
    vec2 screen_size = global.FinalViewportSize.xy * screen_scale;
    screen_size = vec2(ceil(screen_size.x), ceil(screen_size.y));
    return screen_size;
}

vec2 GetIntegerScaleMult(vec2 screen_size, vec2 cropped_size)
{
    float epsilon_1 = 0.00200000009499490261077880859375;
    vec2 integer_scale = screen_size / cropped_size;
    float _4088;
    if (fract(integer_scale.x + 0.001000000047497451305389404296875) < epsilon_1)
    {
        _4088 = round(integer_scale.x);
    }
    else
    {
        _4088 = integer_scale.x;
    }
    float _4104;
    if (fract(integer_scale.y + 0.001000000047497451305389404296875) < epsilon_1)
    {
        _4104 = round(integer_scale.y);
    }
    else
    {
        _4104 = integer_scale.y;
    }
    integer_scale = vec2(_4088, _4104);
    return integer_scale;
}

float extract_bit(float n, inout float b)
{
    b = clamp(b, -1.0, 24.0);
    return floor(mod(floor(n / pow(2.0, floor(b))), 2.0));
}

float sprite(vec4 spr, vec2 size, inout vec2 uv)
{
    uv = floor(uv);
    float bit = ((size.x - uv.x) - 1.0) + (uv.y * size.x);
    bool _1630 = all(greaterThanEqual(uv, vec2(0.0)));
    bool _1637;
    if (_1630)
    {
        _1637 = all(lessThan(uv, size));
    }
    else
    {
        _1637 = _1630;
    }
    bool bounds = _1637;
    float pixels = 0.0;
    float param = spr.x;
    float param_1 = bit - 72.0;
    float _1646 = extract_bit(param, param_1);
    pixels += _1646;
    float param_2 = spr.y;
    float param_3 = bit - 48.0;
    float _1656 = extract_bit(param_2, param_3);
    pixels += _1656;
    float param_4 = spr.z;
    float param_5 = bit - 24.0;
    float _1665 = extract_bit(param_4, param_5);
    pixels += _1665;
    float param_6 = spr.w;
    float param_7 = bit - 0.0;
    float _1674 = extract_bit(param_6, param_7);
    pixels += _1674;
    return bounds ? pixels : 0.0;
}

float GetChar(inout vec4 ch, vec2 uv)
{
    if (TEXT_MODE == 1)
    {
        ch = vec4(16777215.0) - ch;
    }
    if (TEXT_MODE == 2)
    {
        ch.w = (floor(ch.w / 256.0) * 256.0) + 255.0;
    }
    vec4 param = ch;
    vec2 param_1 = vec2(8.0, 12.0);
    vec2 param_2 = uv - printPos;
    float _1712 = sprite(param, param_1, param_2);
    float px = _1712;
    printPos.x += 8.0;
    return px;
}

vec4 get_digit(inout float d)
{
    d = floor(d);
    if (d == 0.0)
    {
        return ch_0;
    }
    if (d == 1.0)
    {
        return ch_1;
    }
    if (d == 2.0)
    {
        return ch_2;
    }
    if (d == 3.0)
    {
        return ch_3;
    }
    if (d == 4.0)
    {
        return ch_4;
    }
    if (d == 5.0)
    {
        return ch_5;
    }
    if (d == 6.0)
    {
        return ch_6;
    }
    if (d == 7.0)
    {
        return ch_7;
    }
    if (d == 8.0)
    {
        return ch_8;
    }
    if (d == 9.0)
    {
        return ch_9;
    }
    return vec4(0.0);
}

float print_integer(float number, int zeros, vec2 uv)
{
    float result = 0.0;
    for (int i = 4; i >= 0; i--)
    {
        float digit = mod(number / pow(10.0, float(i)), 10.0);
        if (((abs(number) > pow(10.0, float(i))) || (zeros > i)) || (i == 0))
        {
            float param = digit;
            vec4 _1894 = get_digit(param);
            vec4 param_1 = _1894;
            vec2 param_2 = uv;
            float _1898 = GetChar(param_1, param_2);
            result += _1898;
        }
    }
    return result;
}

float print_number(float number, vec2 uv, float zeros)
{
    float result = 0.0;
    for (int i = 3; float(i) >= (-zeros); i--)
    {
        float digit = mod(number / pow(10.0, float(i)), 10.0);
        bool _1807 = i > (-1);
        bool _1815;
        if (!_1807)
        {
            _1815 = fract(number) > epsilon;
        }
        else
        {
            _1815 = _1807;
        }
        if (_1815)
        {
            bool _1819 = i == (-1);
            bool _1826;
            if (_1819)
            {
                _1826 = fract(number) > epsilon;
            }
            else
            {
                _1826 = _1819;
            }
            if (_1826)
            {
                vec4 param = ch_per;
                vec2 param_1 = uv;
                float _1833 = GetChar(param, param_1);
                result += _1833;
            }
            if ((abs(number) > pow(10.0, float(i))) || (i == 0))
            {
                float param_2 = digit;
                vec4 _1849 = get_digit(param_2);
                vec4 param_3 = _1849;
                vec2 param_4 = uv;
                float _1853 = GetChar(param_3, param_4);
                result += _1853;
            }
        }
    }
    return result;
}

float DrawResolutions(vec2 uv, vec2 viewport_size, vec2 screen_size, vec2 derezed_size, vec2 negative_crop_added_size, vec2 cropped_original_size, vec2 sampling_res, vec2 int_mult)
{
    float col = 0.0;
    float current_line_index = 0.0;
    float margin = 12.0;
    printPos = vec2(margin, 0.0);
    TEXT_MODE = 0;
    printPos.x = margin;
    printPos.y += 12.0;
    TEXT_MODE = 0;
    vec4 param = ch_V;
    vec2 param_1 = uv;
    float _1921 = GetChar(param, param_1);
    col += _1921;
    vec4 param_2 = ch_i;
    vec2 param_3 = uv;
    float _1928 = GetChar(param_2, param_3);
    col += _1928;
    vec4 param_4 = ch_e;
    vec2 param_5 = uv;
    float _1935 = GetChar(param_4, param_5);
    col += _1935;
    vec4 param_6 = ch_w;
    vec2 param_7 = uv;
    float _1942 = GetChar(param_6, param_7);
    col += _1942;
    vec4 param_8 = ch_p;
    vec2 param_9 = uv;
    float _1949 = GetChar(param_8, param_9);
    col += _1949;
    vec4 param_10 = ch_o;
    vec2 param_11 = uv;
    float _1956 = GetChar(param_10, param_11);
    col += _1956;
    vec4 param_12 = ch_r;
    vec2 param_13 = uv;
    float _1963 = GetChar(param_12, param_13);
    col += _1963;
    vec4 param_14 = ch_t;
    vec2 param_15 = uv;
    float _1970 = GetChar(param_14, param_15);
    col += _1970;
    vec4 param_16 = ch_spc;
    vec2 param_17 = uv;
    float _1977 = GetChar(param_16, param_17);
    col += _1977;
    vec4 param_18 = ch_dsh;
    vec2 param_19 = uv;
    float _1984 = GetChar(param_18, param_19);
    col += _1984;
    vec4 param_20 = ch_dsh;
    vec2 param_21 = uv;
    float _1991 = GetChar(param_20, param_21);
    col += _1991;
    vec4 param_22 = ch_dsh;
    vec2 param_23 = uv;
    float _1998 = GetChar(param_22, param_23);
    col += _1998;
    vec4 param_24 = ch_dsh;
    vec2 param_25 = uv;
    float _2005 = GetChar(param_24, param_25);
    col += _2005;
    vec4 param_26 = ch_dsh;
    vec2 param_27 = uv;
    float _2012 = GetChar(param_26, param_27);
    col += _2012;
    vec4 param_28 = ch_dsh;
    vec2 param_29 = uv;
    float _2019 = GetChar(param_28, param_29);
    col += _2019;
    vec4 param_30 = ch_spc;
    vec2 param_31 = uv;
    float _2026 = GetChar(param_30, param_31);
    col += _2026;
    float param_32 = viewport_size.x;
    int param_33 = 0;
    vec2 param_34 = uv;
    float _2035 = print_integer(param_32, param_33, param_34);
    col += _2035;
    vec4 param_35 = ch_spc;
    vec2 param_36 = uv;
    float _2042 = GetChar(param_35, param_36);
    col += _2042;
    vec4 param_37 = ch_x;
    vec2 param_38 = uv;
    float _2049 = GetChar(param_37, param_38);
    col += _2049;
    vec4 param_39 = ch_spc;
    vec2 param_40 = uv;
    float _2056 = GetChar(param_39, param_40);
    col += _2056;
    float param_41 = viewport_size.y;
    int param_42 = 0;
    vec2 param_43 = uv;
    float _2065 = print_integer(param_41, param_42, param_43);
    col += _2065;
    printPos.x = margin;
    printPos.y += 12.0;
    vec4 param_44 = ch_S;
    vec2 param_45 = uv;
    float _2078 = GetChar(param_44, param_45);
    col += _2078;
    vec4 param_46 = ch_c;
    vec2 param_47 = uv;
    float _2085 = GetChar(param_46, param_47);
    col += _2085;
    vec4 param_48 = ch_r;
    vec2 param_49 = uv;
    float _2092 = GetChar(param_48, param_49);
    col += _2092;
    vec4 param_50 = ch_e;
    vec2 param_51 = uv;
    float _2099 = GetChar(param_50, param_51);
    col += _2099;
    vec4 param_52 = ch_e;
    vec2 param_53 = uv;
    float _2106 = GetChar(param_52, param_53);
    col += _2106;
    vec4 param_54 = ch_n;
    vec2 param_55 = uv;
    float _2113 = GetChar(param_54, param_55);
    col += _2113;
    vec4 param_56 = ch_spc;
    vec2 param_57 = uv;
    float _2120 = GetChar(param_56, param_57);
    col += _2120;
    vec4 param_58 = ch_dsh;
    vec2 param_59 = uv;
    float _2127 = GetChar(param_58, param_59);
    col += _2127;
    vec4 param_60 = ch_dsh;
    vec2 param_61 = uv;
    float _2134 = GetChar(param_60, param_61);
    col += _2134;
    vec4 param_62 = ch_dsh;
    vec2 param_63 = uv;
    float _2141 = GetChar(param_62, param_63);
    col += _2141;
    vec4 param_64 = ch_dsh;
    vec2 param_65 = uv;
    float _2148 = GetChar(param_64, param_65);
    col += _2148;
    vec4 param_66 = ch_dsh;
    vec2 param_67 = uv;
    float _2155 = GetChar(param_66, param_67);
    col += _2155;
    vec4 param_68 = ch_dsh;
    vec2 param_69 = uv;
    float _2162 = GetChar(param_68, param_69);
    col += _2162;
    vec4 param_70 = ch_dsh;
    vec2 param_71 = uv;
    float _2169 = GetChar(param_70, param_71);
    col += _2169;
    vec4 param_72 = ch_dsh;
    vec2 param_73 = uv;
    float _2176 = GetChar(param_72, param_73);
    col += _2176;
    vec4 param_74 = ch_spc;
    vec2 param_75 = uv;
    float _2183 = GetChar(param_74, param_75);
    col += _2183;
    float param_76 = screen_size.x;
    int param_77 = 0;
    vec2 param_78 = uv;
    float _2192 = print_integer(param_76, param_77, param_78);
    col += _2192;
    vec4 param_79 = ch_spc;
    vec2 param_80 = uv;
    float _2199 = GetChar(param_79, param_80);
    col += _2199;
    vec4 param_81 = ch_x;
    vec2 param_82 = uv;
    float _2206 = GetChar(param_81, param_82);
    col += _2206;
    vec4 param_83 = ch_spc;
    vec2 param_84 = uv;
    float _2213 = GetChar(param_83, param_84);
    col += _2213;
    float param_85 = screen_size.y;
    int param_86 = 0;
    vec2 param_87 = uv;
    float _2222 = print_integer(param_85, param_86, param_87);
    col += _2222;
    printPos.x = margin;
    printPos.y += 12.0;
    vec4 param_88 = ch_F;
    vec2 param_89 = uv;
    float _2235 = GetChar(param_88, param_89);
    col += _2235;
    vec4 param_90 = ch_i;
    vec2 param_91 = uv;
    float _2242 = GetChar(param_90, param_91);
    col += _2242;
    vec4 param_92 = ch_n;
    vec2 param_93 = uv;
    float _2249 = GetChar(param_92, param_93);
    col += _2249;
    vec4 param_94 = ch_a;
    vec2 param_95 = uv;
    float _2256 = GetChar(param_94, param_95);
    col += _2256;
    vec4 param_96 = ch_l;
    vec2 param_97 = uv;
    float _2263 = GetChar(param_96, param_97);
    col += _2263;
    vec4 param_98 = ch_spc;
    vec2 param_99 = uv;
    float _2270 = GetChar(param_98, param_99);
    col += _2270;
    vec4 param_100 = ch_A;
    vec2 param_101 = uv;
    float _2277 = GetChar(param_100, param_101);
    col += _2277;
    vec4 param_102 = ch_s;
    vec2 param_103 = uv;
    float _2284 = GetChar(param_102, param_103);
    col += _2284;
    vec4 param_104 = ch_p;
    vec2 param_105 = uv;
    float _2291 = GetChar(param_104, param_105);
    col += _2291;
    vec4 param_106 = ch_e;
    vec2 param_107 = uv;
    float _2298 = GetChar(param_106, param_107);
    col += _2298;
    vec4 param_108 = ch_c;
    vec2 param_109 = uv;
    float _2305 = GetChar(param_108, param_109);
    col += _2305;
    vec4 param_110 = ch_t;
    vec2 param_111 = uv;
    float _2312 = GetChar(param_110, param_111);
    col += _2312;
    vec4 param_112 = ch_spc;
    vec2 param_113 = uv;
    float _2319 = GetChar(param_112, param_113);
    col += _2319;
    vec4 param_114 = ch_dsh;
    vec2 param_115 = uv;
    float _2326 = GetChar(param_114, param_115);
    col += _2326;
    vec4 param_116 = ch_dsh;
    vec2 param_117 = uv;
    float _2333 = GetChar(param_116, param_117);
    col += _2333;
    vec4 param_118 = ch_spc;
    vec2 param_119 = uv;
    float _2340 = GetChar(param_118, param_119);
    col += _2340;
    float _2349;
    if ((screen_size.x / screen_size.y) > 1.0)
    {
        _2349 = screen_size.x / screen_size.y;
    }
    else
    {
        _2349 = screen_size.y / screen_size.x;
    }
    float param_120 = _2349;
    vec2 param_121 = uv;
    float param_122 = 2.0;
    float _2368 = print_number(param_120, param_121, param_122);
    col += _2368;
    printPos.x = margin;
    printPos.y += 12.0;
    vec4 param_123 = ch_N;
    vec2 param_124 = uv;
    float _2381 = GetChar(param_123, param_124);
    col += _2381;
    vec4 param_125 = ch_o;
    vec2 param_126 = uv;
    float _2388 = GetChar(param_125, param_126);
    col += _2388;
    vec4 param_127 = ch_n;
    vec2 param_128 = uv;
    float _2395 = GetChar(param_127, param_128);
    col += _2395;
    vec4 param_129 = ch_dsh;
    vec2 param_130 = uv;
    float _2402 = GetChar(param_129, param_130);
    col += _2402;
    vec4 param_131 = ch_I;
    vec2 param_132 = uv;
    float _2409 = GetChar(param_131, param_132);
    col += _2409;
    vec4 param_133 = ch_n;
    vec2 param_134 = uv;
    float _2416 = GetChar(param_133, param_134);
    col += _2416;
    vec4 param_135 = ch_t;
    vec2 param_136 = uv;
    float _2423 = GetChar(param_135, param_136);
    col += _2423;
    vec4 param_137 = ch_spc;
    vec2 param_138 = uv;
    float _2430 = GetChar(param_137, param_138);
    col += _2430;
    vec4 param_139 = ch_S;
    vec2 param_140 = uv;
    float _2437 = GetChar(param_139, param_140);
    col += _2437;
    vec4 param_141 = ch_c;
    vec2 param_142 = uv;
    float _2444 = GetChar(param_141, param_142);
    col += _2444;
    vec4 param_143 = ch_l;
    vec2 param_144 = uv;
    float _2451 = GetChar(param_143, param_144);
    col += _2451;
    vec4 param_145 = ch_spc;
    vec2 param_146 = uv;
    float _2458 = GetChar(param_145, param_146);
    col += _2458;
    vec4 param_147 = ch_pct;
    vec2 param_148 = uv;
    float _2465 = GetChar(param_147, param_148);
    col += _2465;
    vec4 param_149 = ch_dsh;
    vec2 param_150 = uv;
    float _2472 = GetChar(param_149, param_150);
    col += _2472;
    vec4 param_151 = ch_dsh;
    vec2 param_152 = uv;
    float _2479 = GetChar(param_151, param_152);
    col += _2479;
    vec4 param_153 = ch_spc;
    vec2 param_154 = uv;
    float _2486 = GetChar(param_153, param_154);
    col += _2486;
    float param_155 = (screen_size.y / viewport_size.y) * 100.0;
    vec2 param_156 = uv;
    float param_157 = 3.0;
    float _2499 = print_number(param_155, param_156, param_157);
    col += _2499;
    printPos.x = margin;
    printPos.y += 12.0;
    vec4 param_158 = ch_I;
    vec2 param_159 = uv;
    float _2512 = GetChar(param_158, param_159);
    col += _2512;
    vec4 param_160 = ch_n;
    vec2 param_161 = uv;
    float _2519 = GetChar(param_160, param_161);
    col += _2519;
    vec4 param_162 = ch_t;
    vec2 param_163 = uv;
    float _2526 = GetChar(param_162, param_163);
    col += _2526;
    vec4 param_164 = ch_spc;
    vec2 param_165 = uv;
    float _2533 = GetChar(param_164, param_165);
    col += _2533;
    vec4 param_166 = ch_S;
    vec2 param_167 = uv;
    float _2540 = GetChar(param_166, param_167);
    col += _2540;
    vec4 param_168 = ch_c;
    vec2 param_169 = uv;
    float _2547 = GetChar(param_168, param_169);
    col += _2547;
    vec4 param_170 = ch_l;
    vec2 param_171 = uv;
    float _2554 = GetChar(param_170, param_171);
    col += _2554;
    vec4 param_172 = ch_spc;
    vec2 param_173 = uv;
    float _2561 = GetChar(param_172, param_173);
    col += _2561;
    vec4 param_174 = ch_V;
    vec2 param_175 = uv;
    float _2568 = GetChar(param_174, param_175);
    col += _2568;
    vec4 param_176 = ch_e;
    vec2 param_177 = uv;
    float _2575 = GetChar(param_176, param_177);
    col += _2575;
    vec4 param_178 = ch_r;
    vec2 param_179 = uv;
    float _2582 = GetChar(param_178, param_179);
    col += _2582;
    vec4 param_180 = ch_t;
    vec2 param_181 = uv;
    float _2589 = GetChar(param_180, param_181);
    col += _2589;
    vec4 param_182 = ch_spc;
    vec2 param_183 = uv;
    float _2596 = GetChar(param_182, param_183);
    col += _2596;
    vec4 param_184 = ch_dsh;
    vec2 param_185 = uv;
    float _2603 = GetChar(param_184, param_185);
    col += _2603;
    vec4 param_186 = ch_dsh;
    vec2 param_187 = uv;
    float _2610 = GetChar(param_186, param_187);
    col += _2610;
    vec4 param_188 = ch_spc;
    vec2 param_189 = uv;
    float _2617 = GetChar(param_188, param_189);
    col += _2617;
    bool _2623 = fract(int_mult.y) < 0.00999999977648258209228515625;
    bool _2632;
    if (!_2623)
    {
        _2632 = fract(int_mult.y) > 0.9900000095367431640625;
    }
    else
    {
        _2632 = _2623;
    }
    if (_2632)
    {
        float param_190 = int_mult.y;
        vec2 param_191 = uv;
        float param_192 = 0.0;
        float _2641 = print_number(param_190, param_191, param_192);
        col += _2641;
    }
    else
    {
        float param_193 = int_mult.y;
        vec2 param_194 = uv;
        float param_195 = 3.0;
        float _2651 = print_number(param_193, param_194, param_195);
        col += _2651;
    }
    printPos.x = margin;
    printPos.y += 12.0;
    vec4 param_196 = ch_I;
    vec2 param_197 = uv;
    float _2664 = GetChar(param_196, param_197);
    col += _2664;
    vec4 param_198 = ch_n;
    vec2 param_199 = uv;
    float _2671 = GetChar(param_198, param_199);
    col += _2671;
    vec4 param_200 = ch_t;
    vec2 param_201 = uv;
    float _2678 = GetChar(param_200, param_201);
    col += _2678;
    vec4 param_202 = ch_spc;
    vec2 param_203 = uv;
    float _2685 = GetChar(param_202, param_203);
    col += _2685;
    vec4 param_204 = ch_S;
    vec2 param_205 = uv;
    float _2692 = GetChar(param_204, param_205);
    col += _2692;
    vec4 param_206 = ch_c;
    vec2 param_207 = uv;
    float _2699 = GetChar(param_206, param_207);
    col += _2699;
    vec4 param_208 = ch_l;
    vec2 param_209 = uv;
    float _2706 = GetChar(param_208, param_209);
    col += _2706;
    vec4 param_210 = ch_spc;
    vec2 param_211 = uv;
    float _2713 = GetChar(param_210, param_211);
    col += _2713;
    vec4 param_212 = ch_H;
    vec2 param_213 = uv;
    float _2720 = GetChar(param_212, param_213);
    col += _2720;
    vec4 param_214 = ch_o;
    vec2 param_215 = uv;
    float _2727 = GetChar(param_214, param_215);
    col += _2727;
    vec4 param_216 = ch_r;
    vec2 param_217 = uv;
    float _2734 = GetChar(param_216, param_217);
    col += _2734;
    vec4 param_218 = ch_z;
    vec2 param_219 = uv;
    float _2741 = GetChar(param_218, param_219);
    col += _2741;
    vec4 param_220 = ch_spc;
    vec2 param_221 = uv;
    float _2748 = GetChar(param_220, param_221);
    col += _2748;
    vec4 param_222 = ch_dsh;
    vec2 param_223 = uv;
    float _2755 = GetChar(param_222, param_223);
    col += _2755;
    vec4 param_224 = ch_dsh;
    vec2 param_225 = uv;
    float _2762 = GetChar(param_224, param_225);
    col += _2762;
    vec4 param_226 = ch_spc;
    vec2 param_227 = uv;
    float _2769 = GetChar(param_226, param_227);
    col += _2769;
    bool _2775 = fract(int_mult.x) < 0.00999999977648258209228515625;
    bool _2783;
    if (!_2775)
    {
        _2783 = fract(int_mult.x) > 0.9900000095367431640625;
    }
    else
    {
        _2783 = _2775;
    }
    if (_2783)
    {
        float param_228 = int_mult.x;
        vec2 param_229 = uv;
        float param_230 = 0.0;
        float _2792 = print_number(param_228, param_229, param_230);
        col += _2792;
    }
    else
    {
        float param_231 = int_mult.x;
        vec2 param_232 = uv;
        float param_233 = 3.0;
        float _2802 = print_number(param_231, param_232, param_233);
        col += _2802;
    }
    bool _2809 = cropped_original_size.x != sampling_res.x;
    bool _2818;
    if (!_2809)
    {
        _2818 = cropped_original_size.y != sampling_res.y;
    }
    else
    {
        _2818 = _2809;
    }
    if (_2818)
    {
        printPos.x = margin;
        printPos.y += 12.0;
        vec4 param_234 = ch_S;
        vec2 param_235 = uv;
        float _2831 = GetChar(param_234, param_235);
        col += _2831;
        vec4 param_236 = ch_a;
        vec2 param_237 = uv;
        float _2838 = GetChar(param_236, param_237);
        col += _2838;
        vec4 param_238 = ch_m;
        vec2 param_239 = uv;
        float _2845 = GetChar(param_238, param_239);
        col += _2845;
        vec4 param_240 = ch_p;
        vec2 param_241 = uv;
        float _2852 = GetChar(param_240, param_241);
        col += _2852;
        vec4 param_242 = ch_l;
        vec2 param_243 = uv;
        float _2859 = GetChar(param_242, param_243);
        col += _2859;
        vec4 param_244 = ch_i;
        vec2 param_245 = uv;
        float _2866 = GetChar(param_244, param_245);
        col += _2866;
        vec4 param_246 = ch_n;
        vec2 param_247 = uv;
        float _2873 = GetChar(param_246, param_247);
        col += _2873;
        vec4 param_248 = ch_g;
        vec2 param_249 = uv;
        float _2880 = GetChar(param_248, param_249);
        col += _2880;
        vec4 param_250 = ch_spc;
        vec2 param_251 = uv;
        float _2887 = GetChar(param_250, param_251);
        col += _2887;
        vec4 param_252 = ch_R;
        vec2 param_253 = uv;
        float _2894 = GetChar(param_252, param_253);
        col += _2894;
        vec4 param_254 = ch_e;
        vec2 param_255 = uv;
        float _2901 = GetChar(param_254, param_255);
        col += _2901;
        vec4 param_256 = ch_s;
        vec2 param_257 = uv;
        float _2908 = GetChar(param_256, param_257);
        col += _2908;
        vec4 param_258 = ch_spc;
        vec2 param_259 = uv;
        float _2915 = GetChar(param_258, param_259);
        col += _2915;
        vec4 param_260 = ch_dsh;
        vec2 param_261 = uv;
        float _2922 = GetChar(param_260, param_261);
        col += _2922;
        vec4 param_262 = ch_dsh;
        vec2 param_263 = uv;
        float _2929 = GetChar(param_262, param_263);
        col += _2929;
        vec4 param_264 = ch_spc;
        vec2 param_265 = uv;
        float _2936 = GetChar(param_264, param_265);
        col += _2936;
        float param_266 = sampling_res.x;
        int param_267 = 0;
        vec2 param_268 = uv;
        float _2945 = print_integer(param_266, param_267, param_268);
        col += _2945;
        vec4 param_269 = ch_spc;
        vec2 param_270 = uv;
        float _2952 = GetChar(param_269, param_270);
        col += _2952;
        vec4 param_271 = ch_x;
        vec2 param_272 = uv;
        float _2959 = GetChar(param_271, param_272);
        col += _2959;
        vec4 param_273 = ch_spc;
        vec2 param_274 = uv;
        float _2966 = GetChar(param_273, param_274);
        col += _2966;
        float param_275 = sampling_res.y;
        int param_276 = 0;
        vec2 param_277 = uv;
        float _2975 = print_integer(param_275, param_276, param_277);
        col += _2975;
    }
    bool _2982 = cropped_original_size.x != ROTATED_CORE_PREPPED_SIZE.x;
    bool _2991;
    if (!_2982)
    {
        _2991 = cropped_original_size.y != ROTATED_CORE_PREPPED_SIZE.y;
    }
    else
    {
        _2991 = _2982;
    }
    if (_2991)
    {
        printPos.x = margin;
        printPos.y += 12.0;
        vec4 param_278 = ch_C;
        vec2 param_279 = uv;
        float _3004 = GetChar(param_278, param_279);
        col += _3004;
        vec4 param_280 = ch_r;
        vec2 param_281 = uv;
        float _3011 = GetChar(param_280, param_281);
        col += _3011;
        vec4 param_282 = ch_o;
        vec2 param_283 = uv;
        float _3018 = GetChar(param_282, param_283);
        col += _3018;
        vec4 param_284 = ch_p;
        vec2 param_285 = uv;
        float _3025 = GetChar(param_284, param_285);
        col += _3025;
        vec4 param_286 = ch_p;
        vec2 param_287 = uv;
        float _3032 = GetChar(param_286, param_287);
        col += _3032;
        vec4 param_288 = ch_e;
        vec2 param_289 = uv;
        float _3039 = GetChar(param_288, param_289);
        col += _3039;
        vec4 param_290 = ch_d;
        vec2 param_291 = uv;
        float _3046 = GetChar(param_290, param_291);
        col += _3046;
        vec4 param_292 = ch_spc;
        vec2 param_293 = uv;
        float _3053 = GetChar(param_292, param_293);
        col += _3053;
        vec4 param_294 = ch_dsh;
        vec2 param_295 = uv;
        float _3060 = GetChar(param_294, param_295);
        col += _3060;
        vec4 param_296 = ch_dsh;
        vec2 param_297 = uv;
        float _3067 = GetChar(param_296, param_297);
        col += _3067;
        vec4 param_298 = ch_dsh;
        vec2 param_299 = uv;
        float _3074 = GetChar(param_298, param_299);
        col += _3074;
        vec4 param_300 = ch_dsh;
        vec2 param_301 = uv;
        float _3081 = GetChar(param_300, param_301);
        col += _3081;
        vec4 param_302 = ch_dsh;
        vec2 param_303 = uv;
        float _3088 = GetChar(param_302, param_303);
        col += _3088;
        vec4 param_304 = ch_dsh;
        vec2 param_305 = uv;
        float _3095 = GetChar(param_304, param_305);
        col += _3095;
        vec4 param_306 = ch_dsh;
        vec2 param_307 = uv;
        float _3102 = GetChar(param_306, param_307);
        col += _3102;
        vec4 param_308 = ch_spc;
        vec2 param_309 = uv;
        float _3109 = GetChar(param_308, param_309);
        col += _3109;
        float param_310 = cropped_original_size.x;
        int param_311 = 0;
        vec2 param_312 = uv;
        float _3118 = print_integer(param_310, param_311, param_312);
        col += _3118;
        vec4 param_313 = ch_spc;
        vec2 param_314 = uv;
        float _3125 = GetChar(param_313, param_314);
        col += _3125;
        vec4 param_315 = ch_x;
        vec2 param_316 = uv;
        float _3132 = GetChar(param_315, param_316);
        col += _3132;
        vec4 param_317 = ch_spc;
        vec2 param_318 = uv;
        float _3139 = GetChar(param_317, param_318);
        col += _3139;
        float param_319 = cropped_original_size.y;
        int param_320 = 0;
        vec2 param_321 = uv;
        float _3148 = print_integer(param_319, param_320, param_321);
        col += _3148;
    }
    bool _3155 = derezed_size.x != ROTATED_CORE_PREPPED_SIZE.x;
    bool _3164;
    if (!_3155)
    {
        _3164 = derezed_size.y != ROTATED_CORE_PREPPED_SIZE.y;
    }
    else
    {
        _3164 = _3155;
    }
    if (_3164)
    {
        printPos.x = margin;
        printPos.y += 12.0;
        vec4 param_322 = ch_N;
        vec2 param_323 = uv;
        float _3177 = GetChar(param_322, param_323);
        col += _3177;
        vec4 param_324 = ch_e;
        vec2 param_325 = uv;
        float _3184 = GetChar(param_324, param_325);
        col += _3184;
        vec4 param_326 = ch_g;
        vec2 param_327 = uv;
        float _3191 = GetChar(param_326, param_327);
        col += _3191;
        vec4 param_328 = ch_dsh;
        vec2 param_329 = uv;
        float _3198 = GetChar(param_328, param_329);
        col += _3198;
        vec4 param_330 = ch_C;
        vec2 param_331 = uv;
        float _3205 = GetChar(param_330, param_331);
        col += _3205;
        vec4 param_332 = ch_r;
        vec2 param_333 = uv;
        float _3212 = GetChar(param_332, param_333);
        col += _3212;
        vec4 param_334 = ch_o;
        vec2 param_335 = uv;
        float _3219 = GetChar(param_334, param_335);
        col += _3219;
        vec4 param_336 = ch_p;
        vec2 param_337 = uv;
        float _3226 = GetChar(param_336, param_337);
        col += _3226;
        vec4 param_338 = ch_spc;
        vec2 param_339 = uv;
        float _3233 = GetChar(param_338, param_339);
        col += _3233;
        vec4 param_340 = ch_A;
        vec2 param_341 = uv;
        float _3240 = GetChar(param_340, param_341);
        col += _3240;
        vec4 param_342 = ch_d;
        vec2 param_343 = uv;
        float _3247 = GetChar(param_342, param_343);
        col += _3247;
        vec4 param_344 = ch_d;
        vec2 param_345 = uv;
        float _3254 = GetChar(param_344, param_345);
        col += _3254;
        vec4 param_346 = ch_spc;
        vec2 param_347 = uv;
        float _3261 = GetChar(param_346, param_347);
        col += _3261;
        vec4 param_348 = ch_dsh;
        vec2 param_349 = uv;
        float _3268 = GetChar(param_348, param_349);
        col += _3268;
        vec4 param_350 = ch_dsh;
        vec2 param_351 = uv;
        float _3275 = GetChar(param_350, param_351);
        col += _3275;
        vec4 param_352 = ch_spc;
        vec2 param_353 = uv;
        float _3282 = GetChar(param_352, param_353);
        col += _3282;
        float param_354 = ROTATED_CORE_PREPPED_SIZE.x;
        int param_355 = 0;
        vec2 param_356 = uv;
        float _3291 = print_integer(param_354, param_355, param_356);
        col += _3291;
        vec4 param_357 = ch_spc;
        vec2 param_358 = uv;
        float _3298 = GetChar(param_357, param_358);
        col += _3298;
        vec4 param_359 = ch_x;
        vec2 param_360 = uv;
        float _3305 = GetChar(param_359, param_360);
        col += _3305;
        vec4 param_361 = ch_spc;
        vec2 param_362 = uv;
        float _3312 = GetChar(param_361, param_362);
        col += _3312;
        float param_363 = ROTATED_CORE_PREPPED_SIZE.y;
        int param_364 = 0;
        vec2 param_365 = uv;
        float _3321 = print_integer(param_363, param_364, param_365);
        col += _3321;
    }
    bool _3328 = derezed_size.x != ROTATED_CORE_ORIGINAL_SIZE.x;
    bool _3337;
    if (!_3328)
    {
        _3337 = derezed_size.y != ROTATED_CORE_ORIGINAL_SIZE.y;
    }
    else
    {
        _3337 = _3328;
    }
    if (_3337)
    {
        printPos.x = margin;
        printPos.y += 12.0;
        vec4 param_366 = ch_D;
        vec2 param_367 = uv;
        float _3350 = GetChar(param_366, param_367);
        col += _3350;
        vec4 param_368 = ch_e;
        vec2 param_369 = uv;
        float _3357 = GetChar(param_368, param_369);
        col += _3357;
        vec4 param_370 = ch_r;
        vec2 param_371 = uv;
        float _3364 = GetChar(param_370, param_371);
        col += _3364;
        vec4 param_372 = ch_e;
        vec2 param_373 = uv;
        float _3371 = GetChar(param_372, param_373);
        col += _3371;
        vec4 param_374 = ch_z;
        vec2 param_375 = uv;
        float _3378 = GetChar(param_374, param_375);
        col += _3378;
        vec4 param_376 = ch_e;
        vec2 param_377 = uv;
        float _3385 = GetChar(param_376, param_377);
        col += _3385;
        vec4 param_378 = ch_d;
        vec2 param_379 = uv;
        float _3392 = GetChar(param_378, param_379);
        col += _3392;
        vec4 param_380 = ch_spc;
        vec2 param_381 = uv;
        float _3399 = GetChar(param_380, param_381);
        col += _3399;
        vec4 param_382 = ch_dsh;
        vec2 param_383 = uv;
        float _3406 = GetChar(param_382, param_383);
        col += _3406;
        vec4 param_384 = ch_dsh;
        vec2 param_385 = uv;
        float _3413 = GetChar(param_384, param_385);
        col += _3413;
        vec4 param_386 = ch_dsh;
        vec2 param_387 = uv;
        float _3420 = GetChar(param_386, param_387);
        col += _3420;
        vec4 param_388 = ch_dsh;
        vec2 param_389 = uv;
        float _3427 = GetChar(param_388, param_389);
        col += _3427;
        vec4 param_390 = ch_dsh;
        vec2 param_391 = uv;
        float _3434 = GetChar(param_390, param_391);
        col += _3434;
        vec4 param_392 = ch_dsh;
        vec2 param_393 = uv;
        float _3441 = GetChar(param_392, param_393);
        col += _3441;
        vec4 param_394 = ch_dsh;
        vec2 param_395 = uv;
        float _3448 = GetChar(param_394, param_395);
        col += _3448;
        vec4 param_396 = ch_spc;
        vec2 param_397 = uv;
        float _3455 = GetChar(param_396, param_397);
        col += _3455;
        float param_398 = derezed_size.x;
        int param_399 = 0;
        vec2 param_400 = uv;
        float _3464 = print_integer(param_398, param_399, param_400);
        col += _3464;
        vec4 param_401 = ch_spc;
        vec2 param_402 = uv;
        float _3471 = GetChar(param_401, param_402);
        col += _3471;
        vec4 param_403 = ch_x;
        vec2 param_404 = uv;
        float _3478 = GetChar(param_403, param_404);
        col += _3478;
        vec4 param_405 = ch_spc;
        vec2 param_406 = uv;
        float _3485 = GetChar(param_405, param_406);
        col += _3485;
        float param_407 = derezed_size.y;
        int param_408 = 0;
        vec2 param_409 = uv;
        float _3494 = print_integer(param_407, param_408, param_409);
        col += _3494;
    }
    printPos.x = margin;
    printPos.y += 12.0;
    vec4 param_410 = ch_C;
    vec2 param_411 = uv;
    float _3507 = GetChar(param_410, param_411);
    col += _3507;
    vec4 param_412 = ch_o;
    vec2 param_413 = uv;
    float _3514 = GetChar(param_412, param_413);
    col += _3514;
    vec4 param_414 = ch_r;
    vec2 param_415 = uv;
    float _3521 = GetChar(param_414, param_415);
    col += _3521;
    vec4 param_416 = ch_e;
    vec2 param_417 = uv;
    float _3528 = GetChar(param_416, param_417);
    col += _3528;
    vec4 param_418 = ch_spc;
    vec2 param_419 = uv;
    float _3535 = GetChar(param_418, param_419);
    col += _3535;
    vec4 param_420 = ch_dsh;
    vec2 param_421 = uv;
    float _3542 = GetChar(param_420, param_421);
    col += _3542;
    vec4 param_422 = ch_dsh;
    vec2 param_423 = uv;
    float _3549 = GetChar(param_422, param_423);
    col += _3549;
    vec4 param_424 = ch_dsh;
    vec2 param_425 = uv;
    float _3556 = GetChar(param_424, param_425);
    col += _3556;
    vec4 param_426 = ch_dsh;
    vec2 param_427 = uv;
    float _3563 = GetChar(param_426, param_427);
    col += _3563;
    vec4 param_428 = ch_dsh;
    vec2 param_429 = uv;
    float _3570 = GetChar(param_428, param_429);
    col += _3570;
    vec4 param_430 = ch_dsh;
    vec2 param_431 = uv;
    float _3577 = GetChar(param_430, param_431);
    col += _3577;
    vec4 param_432 = ch_dsh;
    vec2 param_433 = uv;
    float _3584 = GetChar(param_432, param_433);
    col += _3584;
    vec4 param_434 = ch_dsh;
    vec2 param_435 = uv;
    float _3591 = GetChar(param_434, param_435);
    col += _3591;
    vec4 param_436 = ch_dsh;
    vec2 param_437 = uv;
    float _3598 = GetChar(param_436, param_437);
    col += _3598;
    vec4 param_438 = ch_dsh;
    vec2 param_439 = uv;
    float _3605 = GetChar(param_438, param_439);
    col += _3605;
    vec4 param_440 = ch_spc;
    vec2 param_441 = uv;
    float _3612 = GetChar(param_440, param_441);
    col += _3612;
    float param_442 = ROTATED_CORE_ORIGINAL_SIZE.x;
    int param_443 = 0;
    vec2 param_444 = uv;
    float _3621 = print_integer(param_442, param_443, param_444);
    col += _3621;
    vec4 param_445 = ch_spc;
    vec2 param_446 = uv;
    float _3628 = GetChar(param_445, param_446);
    col += _3628;
    vec4 param_447 = ch_x;
    vec2 param_448 = uv;
    float _3635 = GetChar(param_447, param_448);
    col += _3635;
    vec4 param_449 = ch_spc;
    vec2 param_450 = uv;
    float _3642 = GetChar(param_449, param_450);
    col += _3642;
    float param_451 = ROTATED_CORE_ORIGINAL_SIZE.y;
    int param_452 = 0;
    vec2 param_453 = uv;
    float _3651 = print_integer(param_451, param_452, param_453);
    col += _3651;
    printPos.x = margin;
    printPos.y += 24.0;
    vec4 param_454 = ch_S;
    vec2 param_455 = uv;
    float _3664 = GetChar(param_454, param_455);
    col += _3664;
    vec4 param_456 = ch_T;
    vec2 param_457 = uv;
    float _3671 = GetChar(param_456, param_457);
    col += _3671;
    vec4 param_458 = ch_A;
    vec2 param_459 = uv;
    float _3678 = GetChar(param_458, param_459);
    col += _3678;
    vec4 param_460 = ch_N;
    vec2 param_461 = uv;
    float _3685 = GetChar(param_460, param_461);
    col += _3685;
    vec4 param_462 = ch_D;
    vec2 param_463 = uv;
    float _3692 = GetChar(param_462, param_463);
    col += _3692;
    vec4 param_464 = ch_A;
    vec2 param_465 = uv;
    float _3699 = GetChar(param_464, param_465);
    col += _3699;
    vec4 param_466 = ch_R;
    vec2 param_467 = uv;
    float _3706 = GetChar(param_466, param_467);
    col += _3706;
    vec4 param_468 = ch_D;
    vec2 param_469 = uv;
    float _3713 = GetChar(param_468, param_469);
    col += _3713;
    printPos.x = margin;
    printPos.y += 12.0;
    vec4 param_470 = ch_1;
    vec2 param_471 = uv;
    float _3726 = GetChar(param_470, param_471);
    col += _3726;
    vec4 param_472 = ch_per;
    vec2 param_473 = uv;
    float _3733 = GetChar(param_472, param_473);
    col += _3733;
    vec4 param_474 = ch_0;
    vec2 param_475 = uv;
    float _3740 = GetChar(param_474, param_475);
    col += _3740;
    vec4 param_476 = ch_per;
    vec2 param_477 = uv;
    float _3747 = GetChar(param_476, param_477);
    col += _3747;
    vec4 param_478 = ch_0;
    vec2 param_479 = uv;
    float _3754 = GetChar(param_478, param_479);
    col += _3754;
    vec4 param_480 = ch_0;
    vec2 param_481 = uv;
    float _3761 = GetChar(param_480, param_481);
    col += _3761;
    vec4 param_482 = ch_4;
    vec2 param_483 = uv;
    float _3768 = GetChar(param_482, param_483);
    col += _3768;
    vec4 param_484 = ch_spc;
    vec2 param_485 = uv;
    float _3775 = GetChar(param_484, param_485);
    col += _3775;
    vec4 param_486 = ch_2;
    vec2 param_487 = uv;
    float _3782 = GetChar(param_486, param_487);
    col += _3782;
    vec4 param_488 = ch_0;
    vec2 param_489 = uv;
    float _3789 = GetChar(param_488, param_489);
    col += _3789;
    vec4 param_490 = ch_2;
    vec2 param_491 = uv;
    float _3796 = GetChar(param_490, param_491);
    col += _3796;
    vec4 param_492 = ch_2;
    vec2 param_493 = uv;
    float _3803 = GetChar(param_492, param_493);
    col += _3803;
    vec4 param_494 = ch_dsh;
    vec2 param_495 = uv;
    float _3810 = GetChar(param_494, param_495);
    col += _3810;
    vec4 param_496 = ch_0;
    vec2 param_497 = uv;
    float _3817 = GetChar(param_496, param_497);
    col += _3817;
    vec4 param_498 = ch_8;
    vec2 param_499 = uv;
    float _3824 = GetChar(param_498, param_499);
    col += _3824;
    vec4 param_500 = ch_dsh;
    vec2 param_501 = uv;
    float _3831 = GetChar(param_500, param_501);
    col += _3831;
    vec4 param_502 = ch_0;
    vec2 param_503 = uv;
    float _3838 = GetChar(param_502, param_503);
    col += _3838;
    vec4 param_504 = ch_8;
    vec2 param_505 = uv;
    float _3845 = GetChar(param_504, param_505);
    col += _3845;
    vec4 param_506 = ch_spc;
    vec2 param_507 = uv;
    float _3852 = GetChar(param_506, param_507);
    col += _3852;
    vec4 param_508 = ch_R;
    vec2 param_509 = uv;
    float _3859 = GetChar(param_508, param_509);
    col += _3859;
    vec4 param_510 = ch_e;
    vec2 param_511 = uv;
    float _3866 = GetChar(param_510, param_511);
    col += _3866;
    vec4 param_512 = ch_v;
    vec2 param_513 = uv;
    float _3873 = GetChar(param_512, param_513);
    col += _3873;
    vec4 param_514 = ch_spc;
    vec2 param_515 = uv;
    float _3880 = GetChar(param_514, param_515);
    col += _3880;
    vec4 param_516 = ch_1;
    vec2 param_517 = uv;
    float _3887 = GetChar(param_516, param_517);
    col += _3887;
    printPos.x = margin;
    printPos.y += 12.0;
    vec4 param_518 = ch_M;
    vec2 param_519 = uv;
    float _3900 = GetChar(param_518, param_519);
    col += _3900;
    vec4 param_520 = ch_E;
    vec2 param_521 = uv;
    float _3907 = GetChar(param_520, param_521);
    col += _3907;
    vec4 param_522 = ch_G;
    vec2 param_523 = uv;
    float _3914 = GetChar(param_522, param_523);
    col += _3914;
    vec4 param_524 = ch_A;
    vec2 param_525 = uv;
    float _3921 = GetChar(param_524, param_525);
    col += _3921;
    vec4 param_526 = ch_spc;
    vec2 param_527 = uv;
    float _3928 = GetChar(param_526, param_527);
    col += _3928;
    vec4 param_528 = ch_B;
    vec2 param_529 = uv;
    float _3935 = GetChar(param_528, param_529);
    col += _3935;
    vec4 param_530 = ch_E;
    vec2 param_531 = uv;
    float _3942 = GetChar(param_530, param_531);
    col += _3942;
    vec4 param_532 = ch_Z;
    vec2 param_533 = uv;
    float _3949 = GetChar(param_532, param_533);
    col += _3949;
    vec4 param_534 = ch_E;
    vec2 param_535 = uv;
    float _3956 = GetChar(param_534, param_535);
    col += _3956;
    vec4 param_536 = ch_L;
    vec2 param_537 = uv;
    float _3963 = GetChar(param_536, param_537);
    col += _3963;
    vec4 param_538 = ch_spc;
    vec2 param_539 = uv;
    float _3970 = GetChar(param_538, param_539);
    col += _3970;
    TEXT_MODE = 0;
    return col;
}

float GetTextMask(inout vec2 in_coord, vec2 viewport_size, vec2 screen_size, vec2 derezed_size, vec2 negative_crop_added_size, vec2 cropped_original_size, vec2 sampling_res, vec2 int_mult, vec2 canvas_size)
{
    in_coord = ((in_coord - vec2(0.5)) * vec2(1.0, -1.0)) + vec2(0.5);
    float downscale = 1.0;
    if (canvas_size.y > 600.0)
    {
        downscale = 2.0;
    }
    if (canvas_size.y > 1000.0)
    {
        downscale = 3.0;
    }
    textCanvasResolution = global.OutputSize.xy / vec2(downscale);
    vec2 uv = global.OutputSize.xy * in_coord;
    vec2 downscaled_uv = floor((global.OutputSize.xy * in_coord) / vec2(downscale));
    vec2 param = downscaled_uv;
    vec2 param_1 = viewport_size;
    vec2 param_2 = screen_size;
    vec2 param_3 = derezed_size;
    vec2 param_4 = negative_crop_added_size;
    vec2 param_5 = cropped_original_size;
    vec2 param_6 = sampling_res;
    vec2 param_7 = int_mult;
    float _4036 = DrawResolutions(param, param_1, param_2, param_3, param_4, param_5, param_6, param_7);
    float pixel = _4036;
    vec3 col = vec3(1.0);
    pixel *= ((1.0 - distance(mod(uv, vec2(1.0)), vec2(0.64999997615814208984375))) * 1.2000000476837158203125);
    col *= mix(vec3(0.0), vec3(1.0), vec3(pixel));
    return col.x;
}

vec4 AddText(inout vec2 in_coord, vec4 in_color)
{
    in_coord.x = ((HSM_FLIP_VIEWPORT_HORIZONTAL * HSM_FLIP_CORE_HORIZONTAL) * (in_coord.x - 0.5)) + 0.5;
    in_coord.y = ((HSM_FLIP_VIEWPORT_VERTICAL * HSM_FLIP_CORE_VERTICAL) * (in_coord.y - 0.5)) + 0.5;
    vec2 param = SCREEN_SCALE;
    vec2 screen_size = GetScreenSize(param);
    vec2 param_1 = screen_size;
    vec2 param_2 = CROPPED_ROTATED_SIZE;
    vec2 int_scale_mult = GetIntegerScaleMult(param_1, param_2);
    vec2 canvas_size = global.DerezedPassSize.xy;
    vec4 out_color = in_color;
    vec2 param_3 = in_coord + (vec2(1.0 / global.OutputSize.x, 0.0) * 2.0);
    vec2 param_4 = global.FinalViewportSize.xy;
    vec2 param_5 = screen_size;
    vec2 param_6 = ROTATED_DEREZED_SIZE;
    vec2 param_7 = ROTATED_CORE_PREPPED_SIZE;
    vec2 param_8 = CROPPED_ROTATED_SIZE;
    vec2 param_9 = CROPPED_ROTATED_SIZE_WITH_RES_MULT;
    vec2 param_10 = int_scale_mult;
    vec2 param_11 = canvas_size;
    float _4181 = GetTextMask(param_3, param_4, param_5, param_6, param_7, param_8, param_9, param_10, param_11);
    out_color = mix(out_color, vec4(0.0, 0.0, 0.0, 1.0), vec4(_4181));
    vec2 param_12 = in_coord - (vec2(1.0 / global.OutputSize.x, 0.0) * 2.0);
    vec2 param_13 = global.FinalViewportSize.xy;
    vec2 param_14 = screen_size;
    vec2 param_15 = ROTATED_DEREZED_SIZE;
    vec2 param_16 = ROTATED_CORE_PREPPED_SIZE;
    vec2 param_17 = CROPPED_ROTATED_SIZE;
    vec2 param_18 = CROPPED_ROTATED_SIZE_WITH_RES_MULT;
    vec2 param_19 = int_scale_mult;
    vec2 param_20 = canvas_size;
    float _4211 = GetTextMask(param_12, param_13, param_14, param_15, param_16, param_17, param_18, param_19, param_20);
    out_color = mix(out_color, vec4(0.0, 0.0, 0.0, 1.0), vec4(_4211));
    vec2 param_21 = in_coord + (vec2(0.0, 1.0 / global.OutputSize.y) * 1.0);
    vec2 param_22 = global.FinalViewportSize.xy;
    vec2 param_23 = screen_size;
    vec2 param_24 = ROTATED_DEREZED_SIZE;
    vec2 param_25 = ROTATED_CORE_PREPPED_SIZE;
    vec2 param_26 = CROPPED_ROTATED_SIZE;
    vec2 param_27 = CROPPED_ROTATED_SIZE_WITH_RES_MULT;
    vec2 param_28 = int_scale_mult;
    vec2 param_29 = canvas_size;
    float _4241 = GetTextMask(param_21, param_22, param_23, param_24, param_25, param_26, param_27, param_28, param_29);
    out_color = mix(out_color, vec4(0.0, 0.0, 0.0, 1.0), vec4(_4241));
    vec2 param_30 = in_coord - (vec2(0.0, 1.0 / global.OutputSize.y) * 1.0);
    vec2 param_31 = global.FinalViewportSize.xy;
    vec2 param_32 = screen_size;
    vec2 param_33 = ROTATED_DEREZED_SIZE;
    vec2 param_34 = ROTATED_CORE_PREPPED_SIZE;
    vec2 param_35 = CROPPED_ROTATED_SIZE;
    vec2 param_36 = CROPPED_ROTATED_SIZE_WITH_RES_MULT;
    vec2 param_37 = int_scale_mult;
    vec2 param_38 = canvas_size;
    float _4271 = GetTextMask(param_30, param_31, param_32, param_33, param_34, param_35, param_36, param_37, param_38);
    out_color = mix(out_color, vec4(0.0, 0.0, 0.0, 1.0), vec4(_4271));
    vec2 param_39 = in_coord;
    vec2 param_40 = global.FinalViewportSize.xy;
    vec2 param_41 = screen_size;
    vec2 param_42 = ROTATED_DEREZED_SIZE;
    vec2 param_43 = ROTATED_CORE_PREPPED_SIZE;
    vec2 param_44 = CROPPED_ROTATED_SIZE;
    vec2 param_45 = CROPPED_ROTATED_SIZE_WITH_RES_MULT;
    vec2 param_46 = int_scale_mult;
    vec2 param_47 = canvas_size;
    float _4296 = GetTextMask(param_39, param_40, param_41, param_42, param_43, param_44, param_45, param_46, param_47);
    out_color = mix(out_color, vec4(1.0, 1.0, 0.0, 1.0), vec4(_4296));
    return clamp(out_color, vec4(0.0), vec4(1.0));
}

void main()
{
    NEGATIVE_CROP_EXPAND_MULTIPLIER = 0.5;
    MAX_NEGATIVE_CROP = 0.5;
    DEFAULT_SCREEN_ASPECT = 1.3329918384552001953125;
    DEFAULT_BEZEL_ASPECT = 1.32272231578826904296875;
    DEFAULT_SCREEN_SCALE = vec2(0.0);
    DEFAULT_BEZEL_SCALE = vec2(0.0);
    INFOCACHE_MAX_INDEX = 4;
    BLEND_MODE_OFF = 0.0;
    BLEND_MODE_NORMAL = 1.0;
    BLEND_MODE_ADD = 2.0;
    BLEND_MODE_MULTIPLY = 3.0;
    SOURCE_MATTE_PREMULTIPLIED = 0.0;
    SOURCE_MATTE_WHITE = 1.0;
    SOURCE_MATTE_NONE = 2.0;
    IMAGE_ASPECT_MODE_INHERIT_ASPECT_SCALE = 0.0;
    IMAGE_ASPECT_MODE_KEEP_ASPECT = 1.0;
    FILL_MODE_STRETCH = 0.0;
    FILL_MODE_SPLIT_FILL_HORIZONTAL = 1.0;
    FILL_MODE_SPLIT_FILL_VERTICAL = 2.0;
    CACHE_INFO_PARAM_SUM_CHANGED = false;
    CURRENT_FRAME_FROM_CACHE_INFO = 0.0;
    TUBE_DIFFUSE_MASK = 0.0;
    TUBE_MASK = 0.0;
    BEZEL_MASK = 0.0;
    INSIDE_BEZEL_MASK = 0.0;
    OUTSIDE_TUBE_MASK_FOR_IMAGE = 0.0;
    FRAME_MASK = 0.0;
    FRAME_MASK_FOR_IMAGE = 0.0;
    OUTSIDE_BEZEL_MASK = 0.0;
    OUTSIDE_FRAME_MASK_FOR_IMAGE = 0.0;
    OUTSIDE_FRAME_MASK = 0.0;
    CUTOUT_MASK = 0.0;
    SCREEN_INDEX = 1.0;
    SCREEN_ASPECT = 1.0;
    SCREEN_SCALE = vec2(1.0);
    SCREEN_POS_OFFSET = vec2(0.1500000059604644775390625);
    SCREEN_SCALE_2ND_SCREEN = vec2(1.0);
    SCREEN_POS_OFFSET_2ND_SCREEN = vec2(0.1500000059604644775390625);
    VIEWPORT_SCALE = vec2(1.0);
    VIEWPORT_POS = vec2(1.0);
    TUBE_SCALE = vec2(1.0);
    TUBE_DIFFUSE_SCALE = vec2(1.0);
    TUBE_DIFFUSE_ASPECT = 1.0;
    FRAME_SCALE = vec2(1.0);
    BEZEL_OUTSIDE_SCALE = vec2(0.5);
    BACKGROUND_SCALE = vec2(0.5);
    LED_SCALE = vec2(0.5);
    DEVICE_SCALE = vec2(0.5);
    DECAL_SCALE = vec2(0.5);
    CAB_GLASS_SCALE = vec2(0.5);
    TOP_IMAGE_SCALE = vec2(0.5);
    AVERAGE_LUMA = 0.0;
    USE_VERTICAL_SCANLINES = 0.0;
    CORE_SIZE = vec2(1.0);
    ROTATED_CORE_ORIGINAL_SIZE = vec2(1.0);
    ROTATED_CORE_PREPPED_SIZE = vec2(1.0);
    ROTATED_DEREZED_SIZE = vec2(1.0);
    CROPPED_ROTATED_SIZE_WITH_RES_MULT = vec2(1.0);
    CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK = vec2(1.0);
    CROPPED_ROTATED_SIZE = vec2(1.0);
    SAMPLE_AREA_START_PIXEL_COORD = vec2(1.0);
    VIEWPORT_UNSCALED_COORD = vec2(0.5);
    SCREEN_COORD = vec2(0.5);
    TUBE_COORD = vec2(0.5);
    TUBE_DIFFUSE_COORD = vec2(0.5);
    BEZEL_OUTSIDE_COORD = vec2(0.5);
    BACKGROUND_COORD = vec2(0.5);
    DEVICE_COORD = vec2(0.5);
    LED_COORD = vec2(0.5);
    DECAL_COORD = vec2(0.5);
    CAB_GLASS_COORD = vec2(0.5);
    TOP_IMAGE_COORD = vec2(0.5);
    SCREEN_CURVED_COORD = vec2(0.5);
    TUBE_CURVED_COORD = vec2(0.5);
    TUBE_DIFFUSE_CURVED_COORD = vec2(0.5);
    BEZEL_OUTSIDE_CURVED_COORD = vec2(0.5);
    FRAME_OUTSIDE_CURVED_COORD = vec2(0.5);
    BACKGROUND_CURVED_COORD = vec2(0.5);
    LED_CURVED_COORD = vec2(0.5);
    DEVICE_CURVED_COORD = vec2(0.5);
    DECAL_CURVED_COORD = vec2(0.5);
    CAB_GLASS_CURVED_COORD = vec2(0.5);
    TOP_IMAGE_CURVED_COORD = vec2(0.5);
    HSM_RESOLUTION_DEBUG_ON = 0.0;
    HSM_CACHE_GRAPHICS_ON = 1.0;
    HSM_CACHE_UPDATE_INDICATOR_MODE = 2.0;
    HSM_GLOBAL_GRAPHICS_BRIGHTNESS = 1.0;
    HSM_STATIC_LAYERS_GAMMA = 1.0;
    HSM_AMBIENT_LIGHTING_OPACITY = 0.0;
    HSM_AMBIENT2_LIGHTING_OPACITY = 0.0;
    HSM_AMBIENT_LIGHTING_SWAP_IMAGES = 0.0;
    HSM_VIEWPORT_ZOOM = 1.0;
    HSM_VIEWPORT_ZOOM_MASK = 0.0;
    HSM_VIEWPORT_POSITION_X = -0.0;
    HSM_VIEWPORT_POSITION_Y = -0.0;
    HSM_FLIP_VIEWPORT_VERTICAL = 1.0;
    HSM_FLIP_VIEWPORT_HORIZONTAL = 1.0;
    HSM_FLIP_CORE_VERTICAL = 1.0;
    HSM_FLIP_CORE_HORIZONTAL = 1.0;
    HSM_ROTATE_CORE_IMAGE = 0.0;
    HSM_ASPECT_RATIO_ORIENTATION = 0.0;
    HSM_ASPECT_RATIO_MODE = 0.0;
    HSM_ASPECT_RATIO_EXPLICIT = 1.33329999446868896484375;
    HSM_VERTICAL_PRESET = 0.0;
    HSM_INT_SCALE_MAX_HEIGHT = 0.88999998569488525390625;
    HSM_NON_INTEGER_SCALE = 0.829699993133544921875;
    HSM_USE_PHYSICAL_SIZE_FOR_NON_INTEGER = 0.0;
    HSM_PHYSICAL_MONITOR_ASPECT_RATIO = 1.769999980926513671875;
    HSM_PHYSICAL_MONITOR_DIAGONAL_SIZE = 27.0;
    HSM_PHYSICAL_SIM_TUBE_DIAGONAL_SIZE = 18.1000003814697265625;
    HSM_USE_IMAGE_FOR_PLACEMENT = 0.0;
    HSM_PLACEMENT_IMAGE_USE_HORIZONTAL = 0.0;
    HSM_PLACEMENT_IMAGE_MODE = 0.0;
    HSM_NON_INTEGER_SCALE_OFFSET = 1.0;
    HSM_USE_SNAP_TO_CLOSEST_INT_SCALE = 0.0;
    HSM_SNAP_TO_CLOSEST_INT_SCALE_TOLERANCE = (HSM_USE_SNAP_TO_CLOSEST_INT_SCALE > 0.5) ? 0.20000000298023223876953125 : 0.0;
    HSM_SCREEN_POSITION_X = 0.0;
    HSM_SCREEN_POSITION_Y = -0.0;
    HSM_CROP_MODE = 2.0;
    HSM_CROP_PERCENT_ZOOM = 0.0;
    HSM_CROP_PERCENT_TOP = 0.0;
    HSM_CROP_PERCENT_BOTTOM = 0.0;
    HSM_CROP_PERCENT_LEFT = 0.0;
    HSM_CROP_PERCENT_RIGHT = 0.0;
    HSM_CROP_BLACK_THRESHOLD = 0.0;
    HSM_SCANLINE_DIRECTION = 0.0;
    HSM_CORE_RES_SAMPLING_MULT_SCANLINE_DIR = 1.0;
    HSM_DOWNSAMPLE_BLUR_SCANLINE_DIR = 0.0;
    HSM_CORE_RES_SAMPLING_MULT_OPPOSITE_DIR = 1.0;
    HSM_DOWNSAMPLE_BLUR_OPPOSITE_DIR = 0.0;
    HSM_CORE_RES_SAMPLING_SHIFT_OPPOSITE_DIR = 0.0;
    HSM_USE_GEOM = 0.0;
    HSM_CURVATURE_MODE = 1.0;
    HSM_CURVATURE_3D_RADIUS = 2.0;
    HSM_CURVATURE_3D_VIEW_DIST = 1.5;
    HSM_CURVATURE_3D_TILT_ANGLE_X = 0.0;
    HSM_CURVATURE_3D_TILT_ANGLE_Y = 0.0;
    HSM_CRT_CURVATURE_SCALE = 1.0;
    HSM_AB_COMPARE_SHOW_MODE = 0.0;
    HSM_AB_COMPARE_AREA = 0.0;
    HSM_AB_COMPARE_SPLIT_POSITION = 0.5;
    HSM_AB_COMPARE_FREEZE_CRT_TUBE = 0.0;
    HSM_AB_COMPARE_FREEZE_GRAPHICS = 0.0;
    HSM_SCREEN_VIGNETTE_DUALSCREEN_VIS_MODE = 0.0;
    HSM_MONOCHROME_DUALSCREEN_VIS_MODE = 0.0;
    HSM_TUBE_DIFFUSE_MODE = 0.0;
    HSM_TUBE_DIFFUSE_OPACITY = 1.0;
    HSM_TUBE_DIFFUSE_IMAGE_DUALSCREEN_VIS_MODE = 0.0;
    HSM_TUBE_DIFFUSE_IMAGE_COLORIZE_ON = 0.0;
    HSM_TUBE_DIFFUSE_IMAGE_HUE = 0.0;
    HSM_TUBE_DIFFUSE_IMAGE_SATURATION = 1.0;
    HSM_TUBE_DIFFUSE_IMAGE_BRIGHTNESS = 0.20000000298023223876953125;
    HSM_TUBE_DIFFUSE_IMAGE_GAMMA = 1.0;
    HSM_TUBE_DIFFUSE_IMAGE_AMBIENT_LIGHTING = 1.0;
    HSM_TUBE_DIFFUSE_IMAGE_AMBIENT2_LIGHTING = 0.0;
    HSM_TUBE_DIFFUSE_IMAGE_SCALE = 1.2000000476837158203125;
    HSM_TUBE_DIFFUSE_IMAGE_SCALE_X = 1.0;
    HSM_TUBE_SHADOW_IMAGE_ON = 1.0;
    HSM_TUBE_SHADOW_IMAGE_OPACITY = 0.60000002384185791015625;
    HSM_TUBE_SHADOW_IMAGE_POS_X = 0.0;
    HSM_TUBE_SHADOW_IMAGE_POS_Y = 0.0900000035762786865234375;
    HSM_TUBE_SHADOW_IMAGE_SCALE_X = 1.2200000286102294921875;
    HSM_TUBE_SHADOW_IMAGE_SCALE_Y = 1.2999999523162841796875;
    HSM_TUBE_SHADOW_CURVATURE_SCALE = 3.0;
    HSM_TUBE_COLORED_GEL_IMAGE_ON = 0.0;
    HSM_TUBE_COLORED_GEL_IMAGE_SCALE = 1.0;
    HSM_TUBE_COLORED_GEL_IMAGE_FLIP_HORIZONTAL = 1.0;
    HSM_TUBE_COLORED_GEL_IMAGE_FLIP_VERTICAL = 1.0;
    HSM_TUBE_COLORED_GEL_IMAGE_DUALSCREEN_VIS_MODE = 0.0;
    HSM_TUBE_COLORED_GEL_IMAGE_MULTIPLY_AMOUNT = 0.89999997615814208984375;
    HSM_TUBE_COLORED_GEL_IMAGE_ADDITIVE_AMOUNT = 0.0;
    HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_AMOUNT = 0.1500000059604644775390625;
    HSM_TUBE_COLORED_GEL_IMAGE_TRANSPARENCY_THRESHOLD = 0.23000000417232513427734375;
    HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_BRIGHTNESS = 1.0;
    HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_VIGNETTE = 0.0;
    HSM_TUBE_COLORED_GEL_IMAGE_FAKE_SCANLINE_AMOUNT = 0.0;
    HSM_TUBE_COLORED_GEL_IMAGE_AMBIENT_LIGHTING = 1.0;
    HSM_TUBE_COLORED_GEL_IMAGE_AMBIENT2_LIGHTING = 0.0;
    HSM_SHOW_CRT_ON_TOP_OF_COLORED_GEL = 0.0;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_ON = 0.0;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_DUALSCREEN_VIS_MODE = 0.0;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_OPACITY = 0.100000001490116119384765625;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_AMBIENT_LIGHTING = 1.0;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_AMBIENT2_LIGHTING = 0.0;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_SCALE = 1.10000002384185791015625;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_SHADOW_OPACITY = 0.4000000059604644775390625;
    HSM_DUALSCREEN_MODE = 0.0;
    HSM_DUALSCREEN_CORE_IMAGE_SPLIT_MODE = 1.0;
    HSM_DUALSCREEN_CORE_IMAGE_SWAP_SCREENS = 0.0;
    HSM_DUALSCREEN_CORE_IMAGE_SPLIT_OFFSET = 0.0;
    HSM_DUALSCREEN_VIEWPORT_SPLIT_LOCATION = 0.0;
    HSM_DUALSCREEN_SHIFT_POSITION_WITH_SCALE = 1.0;
    HSM_DUALSCREEN_POSITION_OFFSET_BETWEEN_SCREENS = 0.0;
    HSM_2ND_SCREEN_ASPECT_RATIO_MODE = 0.0;
    HSM_2ND_SCREEN_INDEPENDENT_SCALE = 0.0;
    HSM_2ND_SCREEN_SCALE_OFFSET = 1.0;
    HSM_2ND_SCREEN_POS_X = 0.0;
    HSM_2ND_SCREEN_POS_Y = 0.0;
    HSM_2ND_SCREEN_CROP_PERCENT_ZOOM = 0.0;
    HSM_2ND_SCREEN_CROP_PERCENT_TOP = 0.0;
    HSM_2ND_SCREEN_CROP_PERCENT_BOTTOM = 0.0;
    HSM_2ND_SCREEN_CROP_PERCENT_LEFT = 0.0;
    HSM_2ND_SCREEN_CROP_PERCENT_RIGHT = 0.0;
    HSM_SCREEN_REFLECTION_SCALE = 1.0;
    HSM_SCREEN_REFLECTION_POS_X = 0.0;
    HSM_SCREEN_REFLECTION_POS_Y = 0.0;
    HSM_AMBIENT_LIGHTING_HUE = 0.0;
    HSM_AMBIENT_LIGHTING_SATURATION = 1.0;
    HSM_AMBIENT_LIGHTING_VALUE = 1.0;
    HSM_AMBIENT_LIGHTING_CONTRAST = 1.0;
    HSM_AMBIENT_LIGHTING_SCALE_KEEP_ASPECT = 0.0;
    HSM_AMBIENT_LIGHTING_SCALE_WITH_ZOOM = 1.0;
    HSM_AMBIENT_LIGHTING_SCALE = 1.0;
    HSM_AMBIENT_LIGHTING_SCALE_X = 1.0;
    HSM_AMBIENT_LIGHTING_ROTATE = 0.0;
    HSM_AMBIENT_LIGHTING_MIRROR_HORZ = 0.0;
    HSM_AMBIENT_LIGHTING_POSITION_X = 0.0;
    HSM_AMBIENT_LIGHTING_POSITION_Y = -0.0;
    HSM_AMBIENT_LIGHTING_DITHERING_SAMPLES = 0.0;
    HSM_AMBIENT2_LIGHTING_HUE = 0.0;
    HSM_AMBIENT2_LIGHTING_SATURATION = 1.0;
    HSM_AMBIENT2_LIGHTING_VALUE = 2.0;
    HSM_AMBIENT2_LIGHTING_CONTRAST = 1.0;
    HSM_AMBIENT2_LIGHTING_SCALE_KEEP_ASPECT = 1.0;
    HSM_AMBIENT2_LIGHTING_SCALE_WITH_ZOOM = 1.0;
    HSM_AMBIENT2_LIGHTING_SCALE = 1.0;
    HSM_AMBIENT2_LIGHTING_SCALE_X = 1.0;
    HSM_AMBIENT2_LIGHTING_ROTATE = 0.0;
    HSM_AMBIENT2_LIGHTING_MIRROR_HORZ = 0.0;
    HSM_AMBIENT2_LIGHTING_POSITION_X = 0.0;
    HSM_AMBIENT2_LIGHTING_POSITION_Y = -0.0;
    HSM_BZL_OPACITY = 1.0;
    HSM_BZL_BLEND_MODE = 1.0;
    HSM_BZL_WIDTH = 0.107799999415874481201171875;
    HSM_BZL_HEIGHT = 0.0873199999332427978515625;
    HSM_BZL_INNER_CORNER_RADIUS_SCALE = 0.800000011920928955078125;
    HSM_BZL_INNER_EDGE_THICKNESS = 0.0076999999582767486572265625;
    HSM_BZL_INNER_EDGE_SHARPNESS = 0.949999988079071044921875;
    HSM_BZL_OUTER_POSITION_Y = 0.0;
    HSM_BZL_OUTER_CURVATURE_SCALE = 0.0;
    HSM_BZL_OUTER_CORNER_RADIUS_SCALE = 0.540000021457672119140625;
    HSM_BZL_BRIGHTNESS = 0.300000011920928955078125;
    HSM_BZL_HIGHLIGHT = 0.00999999977648258209228515625;
    HSM_BZL_NOISE = 0.300000011920928955078125;
    HSM_BZL_INNER_EDGE_SHADOW = 0.699999988079071044921875;
    HSM_BZL_COLOR_HUE = 0.0;
    HSM_BZL_COLOR_SATURATION = 0.0;
    HSM_BZL_COLOR_VALUE = 0.100000001490116119384765625;
    HSM_BZL_AMBIENT_LIGHTING_MULTIPLIER = 1.0;
    HSM_BZL_AMBIENT2_LIGHTING_MULTIPLIER = 0.0;
    HSM_FRM_USE_INDEPENDENT_COLOR = 0.0;
    HSM_FRM_COLOR_HUE = 0.0;
    HSM_FRM_COLOR_SATURATION = 0.0;
    HSM_FRM_COLOR_VALUE = 0.100000001490116119384765625;
    HSM_FRM_OPACITY = 1.0;
    HSM_FRM_BLEND_MODE = 1.0;
    HSM_FRM_TEXTURE_OPACITY = 0.014999999664723873138427734375;
    HSM_FRM_TEXTURE_BLEND_MODE = 2.0;
    HSM_FRM_NOISE = 0.300000011920928955078125;
    HSM_FRM_INNER_EDGE_THICKNESS = 0.0030000000260770320892333984375;
    HSM_FRM_THICKNESS = 0.070000000298023223876953125;
    HSM_FRM_THICKNESS_SCALE_X = 1.0;
    HSM_FRM_OUTER_POS_Y = 0.0;
    HSM_FRM_OUTER_CURVATURE_SCALE = 0.0;
    HSM_FRM_OUTER_CORNER_RADIUS = 5.0;
    HSM_FRM_OUTER_EDGE_THICKNESS = 0.006000000052154064178466796875;
    HSM_FRM_OUTER_EDGE_SHADING = 0.5;
    HSM_FRM_SHADOW_OPACITY = 1.0;
    HSM_FRM_SHADOW_WIDTH = 0.100000001490116119384765625;
    HSM_REFLECT_CORNER_FADE = 0.100000001490116119384765625;
    HSM_REFLECT_CORNER_FADE_DISTANCE = 1.0;
    HSM_REFLECT_CORNER_INNER_SPREAD = 5.0;
    HSM_REFLECT_CORNER_OUTER_SPREAD = 1.60000002384185791015625;
    HSM_REFLECT_CORNER_ROTATION_OFFSET_TOP = 0.0;
    HSM_REFLECT_CORNER_ROTATION_OFFSET_BOTTOM = 0.0;
    HSM_REFLECT_CORNER_SPREAD_FALLOFF = 100.0;
    HSM_REFLECT_GLOBAL_AMOUNT = 0.4000000059604644775390625;
    HSM_REFLECT_GLOBAL_GAMMA_ADJUST = 1.2000000476837158203125;
    HSM_REFLECT_DIRECT_AMOUNT = 1.5;
    HSM_REFLECT_DIFFUSED_AMOUNT = 0.5;
    HSM_REFLECT_FULLSCREEN_GLOW = 0.75;
    HSM_REFLECT_FULLSCREEN_GLOW_GAMMA = 3.0;
    HSM_REFLECT_BEZEL_INNER_EDGE_AMOUNT = 1.2999999523162841796875;
    HSM_REFLECT_BEZEL_INNER_EDGE_FULLSCREEN_GLOW = 0.4000000059604644775390625;
    HSM_REFLECT_FRAME_INNER_EDGE_AMOUNT = 0.5;
    HSM_REFLECT_FRAME_INNER_EDGE_SHARPNESS = 0.89999997615814208984375;
    HSM_REFLECT_FADE_AMOUNT = 1.0;
    HSM_REFLECT_RADIAL_FADE_WIDTH = 0.2857142984867095947265625;
    HSM_REFLECT_RADIAL_FADE_HEIGHT = 0.2857142984867095947265625;
    HSM_REFLECT_LATERAL_OUTER_FADE_POSITION = 0.017999999225139617919921875;
    HSM_REFLECT_LATERAL_OUTER_FADE_DISTANCE = 0.20000000298023223876953125;
    HSM_REFLECT_BLUR_NUM_SAMPLES = 12.0;
    HSM_REFLECT_BLUR_MIN = 0.0;
    HSM_REFLECT_BLUR_MAX = 0.949999988079071044921875;
    HSM_REFLECT_BLUR_FALLOFF_DISTANCE = 1.0;
    HSM_REFLECT_NOISE_AMOUNT = 0.5;
    HSM_REFLECT_NOISE_SAMPLES = 1.0;
    HSM_REFLECT_NOISE_SAMPLE_DISTANCE = 0.20000000298023223876953125;
    HSM_GLASS_BORDER_ON = 0.0;
    HSM_REFLECT_VIGNETTE_AMOUNT = 0.0;
    HSM_REFLECT_VIGNETTE_SIZE = 1.0;
    HSM_BG_LAYER_ORDER = 0.0;
    HSM_VIEWPORT_VIGNETTE_LAYER_ORDER = 1.0;
    HSM_LED_LAYER_ORDER = 2.0;
    HSM_DEVICE_LAYER_ORDER = 3.0;
    HSM_CRT_LAYER_ORDER = 5.0;
    HSM_DECAL_LAYER_ORDER = 7.0;
    HSM_CAB_GLASS_LAYER_ORDER = 9.0;
    HSM_TOP_LAYER_ORDER = 12.0;
    HSM_CUTOUT_ASPECT_MODE = 4.0;
    HSM_CUTOUT_EXPLICIT_ASPECT = 1.33333003520965576171875;
    HSM_CUTOUT_SCALE_MODE = 0.0;
    HSM_CUTOUT_SCALE_FULL_WITH_ZOOM = 1.0;
    HSM_CUTOUT_KEEP_ASPECT = 1.0;
    HSM_CUTOUT_SCALE = 1.0;
    HSM_CUTOUT_SCALE_X = 1.0;
    HSM_CUTOUT_POS_X = -0.0;
    HSM_CUTOUT_POS_Y = 0.0;
    HSM_CUTOUT_CORNER_RADIUS = 0.0;
    HSM_LAYERING_DEBUG_MASK_MODE = -1.0;
    HSM_BG_OPACITY = 1.0;
    HSM_BG_COLORIZE_ON = 0.0;
    HSM_BG_HUE = 0.0;
    HSM_BG_SATURATION = 1.0;
    HSM_BG_BRIGHTNESS = 1.0;
    HSM_BG_GAMMA = 1.0;
    HSM_BG_AMBIENT_LIGHTING_MULTIPLIER = 1.0;
    HSM_BG_AMBIENT2_LIGHTING_MULTIPLIER = 0.0;
    HSM_BG_APPLY_AMBIENT_IN_ADD_MODE = 0.0;
    HSM_BG_BLEND_MODE = 1.0;
    HSM_BG_SOURCE_MATTE_TYPE = 0.0;
    HSM_BG_MASK_MODE = 0.0;
    HSM_BG_CUTOUT_MODE = 0.0;
    HSM_BG_DUALSCREEN_VIS_MODE = 0.0;
    HSM_BG_SCALE_MODE = 0.0;
    HSM_BG_SCALE_FULL_WITH_ZOOM = 1.0;
    HSM_BG_SCALE_KEEP_ASPECT = 1.0;
    HSM_BG_FILL_MODE = 0.0;
    HSM_BG_SCALE = 1.0;
    HSM_BG_SCALE_X = 1.0;
    HSM_BG_POS_X = -0.0;
    HSM_BG_POS_Y = 0.0;
    HSM_BG_MIRROR_WRAP = 1.0;
    HSM_BG_MIPMAPPING_BLEND_BIAS = 0.0;
    HSM_VIEWPORT_VIGNETTE_OPACITY = 0.0;
    HSM_VIEWPORT_VIGNETTE_MASK_MODE = 5.0;
    HSM_VIEWPORT_VIGNETTE_CUTOUT_MODE = 0.0;
    HSM_VIEWPORT_VIGNETTE_SCALE_MODE = 0.0;
    HSM_VIEWPORT_VIGNETTE_SCALE = 1.0;
    HSM_VIEWPORT_VIGNETTE_SCALE_X = 1.0;
    HSM_VIEWPORT_VIGNETTE_POS_X = -0.0;
    HSM_VIEWPORT_VIGNETTE_POS_Y = 0.0;
    HSM_LED_OPACITY = 1.0;
    HSM_LED_COLORIZE_ON = 0.0;
    HSM_LED_HUE = 0.0;
    HSM_LED_SATURATION = 1.0;
    HSM_LED_BRIGHTNESS = 1.0;
    HSM_LED_GAMMA = 1.0;
    HSM_LED_AMBIENT_LIGHTING_MULTIPLIER = 1.0;
    HSM_LED_AMBIENT2_LIGHTING_MULTIPLIER = 0.0;
    HSM_LED_APPLY_AMBIENT_IN_ADD_MODE = 0.0;
    HSM_LED_BLEND_MODE = 2.0;
    HSM_LED_SOURCE_MATTE_TYPE = 0.0;
    HSM_LED_MASK_MODE = 0.0;
    HSM_LED_CUTOUT_MODE = 0.0;
    HSM_LED_DUALSCREEN_VIS_MODE = 0.0;
    HSM_LED_SCALE_MODE = 3.0;
    HSM_LED_SCALE_FULL_WITH_ZOOM = 1.0;
    HSM_LED_SCALE_KEEP_ASPECT = 1.0;
    HSM_LED_FILL_MODE = 0.0;
    HSM_LED_SCALE = 1.0;
    HSM_LED_SCALE_X = 1.0;
    HSM_LED_POS_X = -0.0;
    HSM_LED_POS_Y = 0.0;
    HSM_LED_MIPMAPPING_BLEND_BIAS = 0.0;
    HSM_DEVICE_OPACITY = 1.0;
    HSM_DEVICE_COLORIZE_ON = 0.0;
    HSM_DEVICE_HUE = 0.0;
    HSM_DEVICE_SATURATION = 1.0;
    HSM_DEVICE_BRIGHTNESS = 1.0;
    HSM_DEVICE_GAMMA = 1.0;
    HSM_DEVICE_AMBIENT_LIGHTING_MULTIPLIER = 1.0;
    HSM_DEVICE_AMBIENT2_LIGHTING_MULTIPLIER = 0.0;
    HSM_DEVICE_APPLY_AMBIENT_IN_ADD_MODE = 0.0;
    HSM_DEVICE_BLEND_MODE = 1.0;
    HSM_DEVICE_SOURCE_MATTE_TYPE = 0.0;
    HSM_DEVICE_MASK_MODE = 0.0;
    HSM_DEVICE_CUTOUT_MODE = 0.0;
    HSM_DEVICE_DUALSCREEN_VIS_MODE = 0.0;
    HSM_DEVICE_SCALE_MODE = 1.0;
    HSM_DEVICE_SCALE_FULL_WITH_ZOOM = 1.0;
    HSM_DEVICE_COPY_INHERITED_COORD = 0.0;
    HSM_DEVICE_SCALE_KEEP_ASPECT = 1.0;
    HSM_DEVICE_FILL_MODE = 0.0;
    HSM_DEVICE_SCALE = 1.0;
    HSM_DEVICE_SCALE_X = 1.0;
    HSM_DEVICE_POS_X = -0.0;
    HSM_DEVICE_POS_Y = 0.0;
    HSM_DEVICE_MIPMAPPING_BLEND_BIAS = 0.0;
    HSM_DECAL_OPACITY = 1.0;
    HSM_DECAL_COLORIZE_ON = 0.0;
    HSM_DECAL_HUE = 0.0;
    HSM_DECAL_SATURATION = 1.0;
    HSM_DECAL_BRIGHTNESS = 1.0;
    HSM_DECAL_GAMMA = 1.0;
    HSM_DECAL_AMBIENT_LIGHTING_MULTIPLIER = 1.0;
    HSM_DECAL_AMBIENT2_LIGHTING_MULTIPLIER = 0.0;
    HSM_DECAL_APPLY_AMBIENT_IN_ADD_MODE = 0.0;
    HSM_DECAL_BLEND_MODE = 1.0;
    HSM_DECAL_SOURCE_MATTE_TYPE = 0.0;
    HSM_DECAL_MASK_MODE = 0.0;
    HSM_DECAL_CUTOUT_MODE = 0.0;
    HSM_DECAL_DUALSCREEN_VIS_MODE = 0.0;
    HSM_DECAL_SCALE_MODE = 0.0;
    HSM_DECAL_SCALE_FULL_WITH_ZOOM = 1.0;
    HSM_DECAL_SCALE_KEEP_ASPECT = 1.0;
    HSM_DECAL_FILL_MODE = 0.0;
    HSM_DECAL_SCALE = 1.0;
    HSM_DECAL_SCALE_X = 1.0;
    HSM_DECAL_POS_X = -0.0;
    HSM_DECAL_POS_Y = 0.0;
    HSM_DECAL_MIPMAPPING_BLEND_BIAS = 0.0;
    HSM_CAB_GLASS_OPACITY = 1.0;
    HSM_CAB_GLASS_COLORIZE_ON = 0.0;
    HSM_CAB_GLASS_HUE = 0.0;
    HSM_CAB_GLASS_SATURATION = 1.0;
    HSM_CAB_GLASS_BRIGHTNESS = 1.0;
    HSM_CAB_GLASS_GAMMA = 1.0;
    HSM_CAB_GLASS_AMBIENT_LIGHTING_MULTIPLIER = 1.0;
    HSM_CAB_GLASS_AMBIENT2_LIGHTING_MULTIPLIER = 0.0;
    HSM_CAB_GLASS_APPLY_AMBIENT_IN_ADD_MODE = 0.0;
    HSM_CAB_GLASS_BLEND_MODE = 1.0;
    HSM_CAB_GLASS_SOURCE_MATTE_TYPE = 0.0;
    HSM_CAB_GLASS_MASK_MODE = 0.0;
    HSM_CAB_GLASS_CUTOUT_MODE = 0.0;
    HSM_CAB_GLASS_DUALSCREEN_VIS_MODE = 0.0;
    HSM_CAB_GLASS_SCALE_MODE = 0.0;
    HSM_CAB_GLASS_SCALE_FULL_WITH_ZOOM = 1.0;
    HSM_CAB_GLASS_SCALE_KEEP_ASPECT = 1.0;
    HSM_CAB_GLASS_FILL_MODE = 0.0;
    HSM_CAB_GLASS_SCALE = 1.0;
    HSM_CAB_GLASS_SCALE_X = 1.0;
    HSM_CAB_GLASS_POS_X = -0.0;
    HSM_CAB_GLASS_POS_Y = 0.0;
    HSM_CAB_GLASS_MIPMAPPING_BLEND_BIAS = 0.0;
    HSM_TOP_OPACITY = 1.0;
    HSM_TOP_COLORIZE_ON = 0.0;
    HSM_TOP_HUE = 0.0;
    HSM_TOP_SATURATION = 1.0;
    HSM_TOP_BRIGHTNESS = 1.0;
    HSM_TOP_GAMMA = 1.0;
    HSM_TOP_AMBIENT_LIGHTING_MULTIPLIER = 1.0;
    HSM_TOP_AMBIENT2_LIGHTING_MULTIPLIER = 0.0;
    HSM_TOP_APPLY_AMBIENT_IN_ADD_MODE = 0.0;
    HSM_TOP_BLEND_MODE = 1.0;
    HSM_TOP_SOURCE_MATTE_TYPE = 0.0;
    HSM_TOP_MASK_MODE = 0.0;
    HSM_TOP_CUTOUT_MODE = 0.0;
    HSM_TOP_DUALSCREEN_VIS_MODE = 0.0;
    HSM_TOP_SCALE_MODE = 0.0;
    HSM_TOP_SCALE_FULL_WITH_ZOOM = 1.0;
    HSM_TOP_SCALE_KEEP_ASPECT = 1.0;
    HSM_TOP_FILL_MODE = 0.0;
    HSM_TOP_SCALE = 1.0;
    HSM_TOP_SCALE_X = 1.0;
    HSM_TOP_POS_X = -0.0;
    HSM_TOP_POS_Y = 0.0;
    HSM_TOP_MIRROR_WRAP = 1.0;
    HSM_TOP_MIPMAPPING_BLEND_BIAS = 0.0;
    HSM_RENDER_SIMPLE_MODE = 0.0;
    HSM_RENDER_SIMPLE_MASK_TYPE = 0.0;
    CURVATURE_MODE_OFF = 0.0;
    CURVATURE_MODE_2D = 1.0;
    CURVATURE_MODE_2D_CYLINDER = 2.0;
    CURVATURE_MODE_3D_1 = 3.0;
    CURVATURE_MODE_3D_2 = 4.0;
    CURVATURE_MODE_3D_CYLINDER = 5.0;
    TEXT_MODE = 0;
    ch_spc = vec4(0.0);
    ch_exc = vec4(12408.0, 7895088.0, 3145776.0, 3145728.0);
    ch_quo = vec4(26214.0, 6693888.0, 0.0, 0.0);
    ch_hsh = vec4(27756.0, 16673900.0, 7143020.0, 7077888.0);
    ch_dol = vec4(3158140.0, 12632184.0, 789752.0, 3158016.0);
    ch_pct = vec4(0.0, 12897304.0, 3170508.0, 9175040.0);
    ch_amp = vec4(28888.0, 14184698.0, 14601436.0, 7733248.0);
    ch_apo = vec4(12336.0, 3170304.0, 0.0, 0.0);
    ch_lbr = vec4(3096.0, 3170400.0, 6303768.0, 786432.0);
    ch_rbr = vec4(24624.0, 1575948.0, 792624.0, 6291456.0);
    ch_ast = vec4(0.0, 6700287.0, 3958272.0, 0.0);
    ch_crs = vec4(0.0, 1579134.0, 1579008.0, 0.0);
    ch_com = vec4(0.0, 0.0, 56.0, 3694592.0);
    ch_dsh = vec4(0.0, 254.0, 0.0, 0.0);
    ch_per = vec4(0.0, 0.0, 56.0, 3670016.0);
    ch_lsl = vec4(2.0, 396312.0, 3170496.0, 8388608.0);
    ch_0 = vec4(31942.0, 14079702.0, 14079686.0, 8126464.0);
    ch_1 = vec4(4144.0, 15740976.0, 3158064.0, 16515072.0);
    ch_2 = vec4(30924.0, 13372440.0, 3170508.0, 16515072.0);
    ch_3 = vec4(30924.0, 789560.0, 789708.0, 7864320.0);
    ch_4 = vec4(3100.0, 3960012.0, 16649228.0, 1966080.0);
    ch_5 = vec4(64704.0, 12632312.0, 789708.0, 7864320.0);
    ch_6 = vec4(14432.0, 12632312.0, 13421772.0, 7864320.0);
    ch_7 = vec4(65222.0, 12977676.0, 1585200.0, 3145728.0);
    ch_8 = vec4(30924.0, 13429880.0, 14470348.0, 7864320.0);
    ch_9 = vec4(30924.0, 13421692.0, 1579056.0, 7340032.0);
    ch_col = vec4(0.0, 3684352.0, 14392.0, 0.0);
    ch_scl = vec4(0.0, 3684352.0, 14392.0, 1585152.0);
    ch_les = vec4(3096.0, 3170496.0, 6303768.0, 786432.0);
    ch_equ = vec4(0.0, 32256.0, 8257536.0, 0.0);
    ch_grt = vec4(24624.0, 1575942.0, 792624.0, 6291456.0);
    ch_que = vec4(30924.0, 792624.0, 3145776.0, 3145728.0);
    ch_ats = vec4(31942.0, 13033182.0, 14598336.0, 8126464.0);
    ch_A = vec4(12408.0, 13421772.0, 16567500.0, 13369344.0);
    ch_B = vec4(64614.0, 6710908.0, 6710886.0, 16515072.0);
    ch_C = vec4(15462.0, 13025472.0, 12633702.0, 3932160.0);
    ch_D = vec4(63596.0, 6710886.0, 6710892.0, 16252928.0);
    ch_E = vec4(65122.0, 6317180.0, 6578274.0, 16646144.0);
    ch_F = vec4(65126.0, 6448252.0, 6578272.0, 15728640.0);
    ch_G = vec4(15462.0, 13025472.0, 13551206.0, 4063232.0);
    ch_H = vec4(52428.0, 13421820.0, 13421772.0, 13369344.0);
    ch_I = vec4(30768.0, 3158064.0, 3158064.0, 7864320.0);
    ch_J = vec4(7692.0, 789516.0, 13421772.0, 7864320.0);
    ch_K = vec4(58982.0, 7105656.0, 7105638.0, 15073280.0);
    ch_L = vec4(61536.0, 6316128.0, 6448742.0, 16646144.0);
    ch_M = vec4(50926.0, 16711382.0, 13027014.0, 12976128.0);
    ch_N = vec4(50886.0, 15136510.0, 14601926.0, 12976128.0);
    ch_O = vec4(14444.0, 13027014.0, 13026924.0, 3670016.0);
    ch_P = vec4(64614.0, 6710908.0, 6316128.0, 15728640.0);
    ch_Q = vec4(14444.0, 13027014.0, 13557372.0, 794112.0);
    ch_R = vec4(64614.0, 6710908.0, 7104102.0, 15073280.0);
    ch_S = vec4(30924.0, 13418608.0, 1625292.0, 7864320.0);
    ch_T = vec4(64692.0, 3158064.0, 3158064.0, 7864320.0);
    ch_U = vec4(52428.0, 13421772.0, 13421772.0, 7864320.0);
    ch_V = vec4(52428.0, 13421772.0, 13421688.0, 3145728.0);
    ch_W = vec4(50886.0, 13027030.0, 14052460.0, 7077888.0);
    ch_X = vec4(52428.0, 13400112.0, 7916748.0, 13369344.0);
    ch_Y = vec4(52428.0, 13421688.0, 3158064.0, 7864320.0);
    ch_Z = vec4(65230.0, 9967664.0, 6316742.0, 16646144.0);
    ch_lsb = vec4(15408.0, 3158064.0, 3158064.0, 3932160.0);
    ch_rsl = vec4(128.0, 12607536.0, 1575942.0, 131072.0);
    ch_rsb = vec4(15372.0, 789516.0, 789516.0, 3932160.0);
    ch_pow = vec4(1063020.0, 12976128.0, 0.0, 0.0);
    ch_usc = vec4(0.0, 0.0, 0.0, 65280.0);
    ch_a = vec4(0.0, 30732.0, 8178892.0, 7733248.0);
    ch_b = vec4(57440.0, 6323302.0, 6710886.0, 14417920.0);
    ch_c = vec4(0.0, 30924.0, 12632268.0, 7864320.0);
    ch_d = vec4(7180.0, 818380.0, 13421772.0, 7733248.0);
    ch_e = vec4(0.0, 30924.0, 16564428.0, 7864320.0);
    ch_f = vec4(14444.0, 6316280.0, 6316128.0, 15728640.0);
    ch_g = vec4(0.0, 30412.0, 13421692.0, 838776.0);
    ch_h = vec4(57440.0, 6319222.0, 6710886.0, 15073280.0);
    ch_i = vec4(6168.0, 30744.0, 1579032.0, 8257536.0);
    ch_j = vec4(3084.0, 15372.0, 789516.0, 13421688.0);
    ch_k = vec4(57440.0, 6317676.0, 7892070.0, 15073280.0);
    ch_l = vec4(30744.0, 1579032.0, 1579032.0, 8257536.0);
    ch_m = vec4(0.0, 64726.0, 14079702.0, 12976128.0);
    ch_n = vec4(0.0, 63692.0, 13421772.0, 13369344.0);
    ch_o = vec4(0.0, 30924.0, 13421772.0, 7864320.0);
    ch_p = vec4(0.0, 56422.0, 6710886.0, 8151280.0);
    ch_q = vec4(0.0, 30412.0, 13421772.0, 8129566.0);
    ch_r = vec4(0.0, 60526.0, 7757920.0, 15728640.0);
    ch_s = vec4(0.0, 30924.0, 6297804.0, 7864320.0);
    ch_t = vec4(32.0, 6356064.0, 6316140.0, 3670016.0);
    ch_u = vec4(0.0, 52428.0, 13421772.0, 7733248.0);
    ch_v = vec4(0.0, 52428.0, 13421688.0, 3145728.0);
    ch_w = vec4(0.0, 50886.0, 14079596.0, 7077888.0);
    ch_x = vec4(0.0, 50796.0, 3684460.0, 12976128.0);
    ch_y = vec4(0.0, 26214.0, 6710844.0, 792816.0);
    ch_z = vec4(0.0, 64652.0, 1597636.0, 16515072.0);
    ch_lpa = vec4(7216.0, 3170496.0, 6303792.0, 1835008.0);
    ch_bar = vec4(6168.0, 1579008.0, 1579032.0, 1572864.0);
    ch_rpa = vec4(57392.0, 3151884.0, 1585200.0, 14680064.0);
    ch_tid = vec4(29658.0, 13500416.0, 0.0, 0.0);
    ch_lar = vec4(0.0, 1063020.0, 13027070.0, 0.0);
    textCanvasResolution = vec2(0.0);
    printPos = vec2(0.0);
    epsilon = 0.001000000047497451305389404296875;
    vec2 UNFLIPPED_VIEWPORT_COORD = vTexCoord;
    vec2 VIEWPORT_COORD = vTexCoord;
    vec2 param = vTexCoord;
    vec4 _4315 = HSM_UpdateGlobalScreenValuesFromCache(InfoCachePass, InfoCachePassFeedback, param);
    FragColor = vec4(0.0);
    vec4 feedback_color_test = texture(TextPassFeedback, vec2(0.0));
    bool _4324 = feedback_color_test.w < 0.0;
    bool _4329;
    if (_4324)
    {
        _4329 = !HSM_CheckCacheInfoChanged();
    }
    else
    {
        _4329 = _4324;
    }
    if (_4329)
    {
        FragColor = texture(TextPassFeedback, UNFLIPPED_VIEWPORT_COORD);
        return;
    }
    VIEWPORT_COORD.y = ((HSM_FLIP_VIEWPORT_VERTICAL * HSM_FLIP_CORE_VERTICAL) * (VIEWPORT_COORD.y - 0.5)) + 0.5;
    VIEWPORT_COORD.x = ((HSM_FLIP_VIEWPORT_HORIZONTAL * HSM_FLIP_CORE_HORIZONTAL) * (VIEWPORT_COORD.x - 0.5)) + 0.5;
    vec2 param_1 = VIEWPORT_COORD - vec2(MAX_NEGATIVE_CROP, -MAX_NEGATIVE_CROP);
    vec4 param_2 = FragColor;
    vec4 _4363 = AddText(param_1, param_2);
    FragColor = _4363;
    bool _4369 = UNFLIPPED_VIEWPORT_COORD.x < (2.0 / global.OutputSize.x);
    bool _4378;
    if (_4369)
    {
        _4378 = UNFLIPPED_VIEWPORT_COORD.y < (2.0 / global.OutputSize.y);
    }
    else
    {
        _4378 = _4369;
    }
    if (_4378)
    {
        FragColor = vec4(0.00999999977648258209228515625, 0.00999999977648258209228515625, 0.00999999977648258209228515625, -1.0);
    }
}

