#version 430

layout(binding = 0, std140) uniform UBO
{
    mat4 MVP;
    vec4 SourceSize;
    vec4 OriginalSize;
    vec4 CorePassSize;
    vec4 CorePassFeedbackSize;
    vec4 OutputSize;
    vec4 FinalViewportSize;
    vec4 NegativeCropAddedPassSize;
    vec4 DerezedPassSize;
    int FrameDirection;
    uint FrameCount;
    float HSM_RESOLUTION_DEBUG_ON;
    float HSM_CACHE_GRAPHICS_ON;
    float HSM_CACHE_UPDATE_INDICATOR_MODE;
    float HSM_GLOBAL_GRAPHICS_BRIGHTNESS;
    float HSM_STATIC_LAYERS_GAMMA;
    float HSM_AMBIENT_LIGHTING_OPACITY;
    float HSM_AMBIENT2_LIGHTING_OPACITY;
    float HSM_AMBIENT_LIGHTING_SWAP_IMAGES;
    float HSM_AMBIENT_LIGHTING_HUE;
    float HSM_AMBIENT_LIGHTING_SATURATION;
    float HSM_AMBIENT_LIGHTING_VALUE;
    float HSM_AMBIENT_LIGHTING_CONTRAST;
    float HSM_AMBIENT_LIGHTING_SCALE_KEEP_ASPECT;
    float HSM_AMBIENT_LIGHTING_SCALE_WITH_ZOOM;
    float HSM_AMBIENT_LIGHTING_SCALE;
    float HSM_AMBIENT_LIGHTING_SCALE_X;
    float HSM_AMBIENT_LIGHTING_ROTATE;
    float HSM_AMBIENT_LIGHTING_MIRROR_HORZ;
    float HSM_AMBIENT_LIGHTING_POSITION_X;
    float HSM_AMBIENT_LIGHTING_POSITION_Y;
    float HSM_AMBIENT_LIGHTING_DITHERING_SAMPLES;
    float HSM_AMBIENT2_LIGHTING_HUE;
    float HSM_AMBIENT2_LIGHTING_SATURATION;
    float HSM_AMBIENT2_LIGHTING_VALUE;
    float HSM_AMBIENT2_LIGHTING_CONTRAST;
    float HSM_AMBIENT2_LIGHTING_SCALE_KEEP_ASPECT;
    float HSM_AMBIENT2_LIGHTING_SCALE_WITH_ZOOM;
    float HSM_AMBIENT2_LIGHTING_SCALE;
    float HSM_AMBIENT2_LIGHTING_SCALE_X;
    float HSM_AMBIENT2_LIGHTING_ROTATE;
    float HSM_AMBIENT2_LIGHTING_MIRROR_HORZ;
    float HSM_AMBIENT2_LIGHTING_POSITION_X;
    float HSM_AMBIENT2_LIGHTING_POSITION_Y;
    float HSM_VIEWPORT_ZOOM;
    float HSM_VIEWPORT_POSITION_X;
    float HSM_VIEWPORT_POSITION_Y;
    float HSM_VIEWPORT_ZOOM_MASK;
    float HSM_FLIP_VIEWPORT_VERTICAL;
    float HSM_FLIP_VIEWPORT_HORIZONTAL;
    float HSM_FLIP_CORE_VERTICAL;
    float HSM_FLIP_CORE_HORIZONTAL;
    float HSM_ROTATE_CORE_IMAGE;
    float HSM_ASPECT_RATIO_ORIENTATION;
    float HSM_ASPECT_RATIO_MODE;
    float HSM_ASPECT_RATIO_EXPLICIT;
    float HSM_INT_SCALE_MODE;
    float HSM_INT_SCALE_MULTIPLE_OFFSET;
    float HSM_INT_SCALE_MULTIPLE_OFFSET_LONG;
    float HSM_INT_SCALE_MAX_HEIGHT;
    float HSM_VERTICAL_PRESET;
    float HSM_NON_INTEGER_SCALE;
    float HSM_USE_PHYSICAL_SIZE_FOR_NON_INTEGER;
    float HSM_PHYSICAL_MONITOR_ASPECT_RATIO;
    float HSM_PHYSICAL_MONITOR_DIAGONAL_SIZE;
    float HSM_PHYSICAL_SIM_TUBE_DIAGONAL_SIZE;
    float HSM_USE_IMAGE_FOR_PLACEMENT;
    float HSM_PLACEMENT_IMAGE_USE_HORIZONTAL;
    float HSM_PLACEMENT_IMAGE_MODE;
    float HSM_NON_INTEGER_SCALE_OFFSET;
    float HSM_USE_SNAP_TO_CLOSEST_INT_SCALE;
    float HSM_SNAP_TO_CLOSEST_INT_SCALE_TOLERANCE;
    float HSM_SCREEN_POSITION_X;
    float HSM_SCREEN_POSITION_Y;
    float HSM_CROP_MODE;
    float HSM_CROP_PERCENT_ZOOM;
    float HSM_CROP_PERCENT_TOP;
    float HSM_CROP_PERCENT_BOTTOM;
    float HSM_CROP_PERCENT_LEFT;
    float HSM_CROP_PERCENT_RIGHT;
    float HSM_CROP_BLACK_THRESHOLD;
    float HSM_SCANLINE_DIRECTION;
    float HSM_CORE_RES_SAMPLING_MULT_SCANLINE_DIR;
    float HSM_DOWNSAMPLE_BLUR_SCANLINE_DIR;
    float HSM_CORE_RES_SAMPLING_MULT_OPPOSITE_DIR;
    float HSM_DOWNSAMPLE_BLUR_OPPOSITE_DIR;
    float HSM_CORE_RES_SAMPLING_SHIFT_OPPOSITE_DIR;
    float HSM_INTERLACE_TRIGGER_RES;
    float HSM_INTERLACE_MODE;
    float HSM_INTERLACE_EFFECT_SMOOTHNESS_INTERS;
    float HSM_INTERLACE_SCANLINE_EFFECT;
    float iscans;
    float HSM_FAKE_SCANLINE_MODE;
    float HSM_FAKE_SCANLINE_OPACITY;
    float HSM_FAKE_SCANLINE_RES_MODE;
    float HSM_FAKE_SCANLINE_RES;
    float HSM_FAKE_SCANLINE_INT_SCALE;
    float HSM_FAKE_SCANLINE_ROLL;
    float HSM_FAKE_SCANLINE_CURVATURE;
    float HSM_FAKE_SCANLINE_BRIGHTNESS_CUTOFF;
    float HSM_DUALSCREEN_MODE;
    float HSM_DUALSCREEN_CORE_IMAGE_SPLIT_MODE;
    float HSM_DUALSCREEN_CORE_IMAGE_SWAP_SCREENS;
    float HSM_DUALSCREEN_CORE_IMAGE_SPLIT_OFFSET;
    float HSM_DUALSCREEN_VIEWPORT_SPLIT_LOCATION;
    float HSM_DUALSCREEN_SHIFT_POSITION_WITH_SCALE;
    float HSM_DUALSCREEN_POSITION_OFFSET_BETWEEN_SCREENS;
    float HSM_2ND_SCREEN_ASPECT_RATIO_MODE;
    float HSM_2ND_SCREEN_INDEPENDENT_SCALE;
    float HSM_2ND_SCREEN_SCALE_OFFSET;
    float HSM_2ND_SCREEN_POS_X;
    float HSM_2ND_SCREEN_POS_Y;
    float HSM_2ND_SCREEN_CROP_PERCENT_ZOOM;
    float HSM_2ND_SCREEN_CROP_PERCENT_TOP;
    float HSM_2ND_SCREEN_CROP_PERCENT_BOTTOM;
    float HSM_2ND_SCREEN_CROP_PERCENT_LEFT;
    float HSM_2ND_SCREEN_CROP_PERCENT_RIGHT;
    float HSM_CURVATURE_MODE;
    float HSM_CURVATURE_2D_SCALE_LONG_AXIS;
    float HSM_CURVATURE_2D_SCALE_SHORT_AXIS;
    float HSM_CURVATURE_3D_RADIUS;
    float HSM_CURVATURE_3D_VIEW_DIST;
    float HSM_CURVATURE_3D_TILT_ANGLE_X;
    float HSM_CURVATURE_3D_TILT_ANGLE_Y;
    float HSM_CRT_CURVATURE_SCALE;
    float HSM_ANTI_FLICKER_ON;
    float HSM_ANTI_FLICKER_THRESHOLD;
    float HSM_AB_COMPARE_SHOW_MODE;
    float HSM_AB_COMPARE_AREA;
    float HSM_AB_COMPARE_FREEZE_CRT_TUBE;
    float HSM_AB_COMPARE_FREEZE_GRAPHICS;
    float HSM_AB_COMPARE_SPLIT_AREA;
    float HSM_AB_COMPARE_SPLIT_POSITION;
    float HSM_CRT_BLEND_MODE;
    float HSM_CRT_BLEND_AMOUNT;
    float HSM_CRT_SCREEN_BLEND_MODE;
    float HSM_SCREEN_VIGNETTE_ON;
    float HSM_SCREEN_VIGNETTE_DUALSCREEN_VIS_MODE;
    float HSM_SCREEN_VIGNETTE_STRENGTH;
    float HSM_SCREEN_VIGNETTE_POWER;
    float HSM_SCREEN_VIGNETTE_IN_REFLECTION;
    float HSM_MONOCHROME_MODE;
    float HSM_MONOCHROME_BRIGHTNESS;
    float HSM_MONOCHROME_GAMMA;
    float HSM_MONOCHROME_HUE_OFFSET;
    float HSM_MONOCHROME_SATURATION;
    float HSM_MONOCHROME_DUALSCREEN_VIS_MODE;
    float HSM_SCREEN_REFLECTION_SCALE;
    float HSM_SCREEN_REFLECTION_POS_X;
    float HSM_SCREEN_REFLECTION_POS_Y;
    float HSM_TUBE_DIFFUSE_MODE;
    float HSM_TUBE_DIFFUSE_IMAGE_DUALSCREEN_VIS_MODE;
    float HSM_TUBE_DIFFUSE_OPACITY;
    float HSM_TUBE_DIFFUSE_IMAGE_HUE;
    float HSM_TUBE_DIFFUSE_IMAGE_COLORIZE_ON;
    float HSM_TUBE_DIFFUSE_IMAGE_SATURATION;
    float HSM_TUBE_DIFFUSE_IMAGE_BRIGHTNESS;
    float HSM_TUBE_DIFFUSE_IMAGE_GAMMA;
    float HSM_TUBE_DIFFUSE_IMAGE_AMBIENT_LIGHTING;
    float HSM_TUBE_DIFFUSE_IMAGE_AMBIENT2_LIGHTING;
    float HSM_TUBE_DIFFUSE_IMAGE_SCALE;
    float HSM_TUBE_DIFFUSE_IMAGE_SCALE_X;
    float HSM_TUBE_EMPTY_THICKNESS;
    float HSM_TUBE_EMPTY_THICKNESS_X_SCALE;
    float HSM_TUBE_DIFFUSE_FORCE_ASPECT;
    float HSM_TUBE_EXPLICIT_ASPECT;
    float HSM_SCREEN_CORNER_RADIUS_SCALE;
    float HSM_TUBE_COLORED_GEL_IMAGE_ON;
    float HSM_TUBE_COLORED_GEL_IMAGE_DUALSCREEN_VIS_MODE;
    float HSM_TUBE_COLORED_GEL_IMAGE_MULTIPLY_AMOUNT;
    float HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_AMOUNT;
    float HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_BRIGHTNESS;
    float HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_VIGNETTE;
    float HSM_TUBE_COLORED_GEL_IMAGE_TRANSPARENCY_THRESHOLD;
    float HSM_TUBE_COLORED_GEL_IMAGE_ADDITIVE_AMOUNT;
    float HSM_SHOW_CRT_ON_TOP_OF_COLORED_GEL;
    float HSM_TUBE_SHADOW_IMAGE_ON;
    float HSM_TUBE_SHADOW_IMAGE_OPACITY;
    float HSM_TUBE_SHADOW_IMAGE_SCALE_X;
    float HSM_TUBE_SHADOW_IMAGE_SCALE_Y;
    float HSM_TUBE_SHADOW_IMAGE_POS_X;
    float HSM_TUBE_SHADOW_IMAGE_POS_Y;
    float HSM_TUBE_SHADOW_CURVATURE_SCALE;
    float HSM_TUBE_COLORED_GEL_IMAGE_AMBIENT_LIGHTING;
    float HSM_TUBE_COLORED_GEL_IMAGE_AMBIENT2_LIGHTING;
    float HSM_TUBE_COLORED_GEL_IMAGE_FAKE_SCANLINE_AMOUNT;
    float HSM_TUBE_COLORED_GEL_IMAGE_SCALE;
    float HSM_TUBE_COLORED_GEL_IMAGE_FLIP_HORIZONTAL;
    float HSM_TUBE_COLORED_GEL_IMAGE_FLIP_VERTICAL;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_ON;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_DUALSCREEN_VIS_MODE;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_OPACITY;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_AMBIENT_LIGHTING;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_AMBIENT2_LIGHTING;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_SCALE;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_SHADOW_OPACITY;
    float HSM_TUBE_STATIC_REFLECTION_IMAGE_DITHERING_SAMPLES;
    float HSM_GLOBAL_CORNER_RADIUS;
    float HSM_TUBE_BLACK_EDGE_CORNER_RADIUS_SCALE;
    float HSM_TUBE_BLACK_EDGE_SHARPNESS;
    float HSM_TUBE_BLACK_EDGE_CURVATURE_SCALE;
    float HSM_TUBE_BLACK_EDGE_THICKNESS;
    float HSM_TUBE_BLACK_EDGE_THICKNESS_X_SCALE;
    float HSM_BZL_USE_INDEPENDENT_SCALE;
    float HSM_BZL_INDEPENDENT_SCALE;
    float HSM_BZL_USE_INDEPENDENT_CURVATURE;
    float HSM_BZL_INDEPENDENT_CURVATURE_SCALE_LONG_AXIS;
    float HSM_BZL_INDEPENDENT_CURVATURE_SCALE_SHORT_AXIS;
    float HSM_BZL_OPACITY;
    float HSM_BZL_BLEND_MODE;
    float HSM_BZL_WIDTH;
    float HSM_BZL_HEIGHT;
    float HSM_BZL_SCALE_OFFSET;
    float HSM_BZL_INNER_CURVATURE_SCALE;
    float HSM_BZL_INNER_CORNER_RADIUS_SCALE;
    float HSM_BZL_OUTER_CURVATURE_SCALE;
    float HSM_BZL_INNER_EDGE_THICKNESS;
    float HSM_BZL_INNER_EDGE_SHARPNESS;
    float HSM_BZL_OUTER_CORNER_RADIUS_SCALE;
    float HSM_BZL_INNER_EDGE_SHADOW;
    float HSM_BZL_COLOR_HUE;
    float HSM_BZL_COLOR_SATURATION;
    float HSM_BZL_COLOR_VALUE;
    float HSM_BZL_NOISE;
    float HSM_BZL_BRIGHTNESS;
    float HSM_BZL_HIGHLIGHT;
    float HSM_BZL_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_BZL_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_FRM_USE_INDEPENDENT_COLOR;
    float HSM_FRM_COLOR_HUE;
    float HSM_FRM_COLOR_SATURATION;
    float HSM_FRM_COLOR_VALUE;
    float HSM_FRM_NOISE;
    float HSM_FRM_OUTER_CURVATURE_SCALE;
    float HSM_FRM_THICKNESS;
    float HSM_FRM_THICKNESS_SCALE_X;
    float HSM_FRM_OUTER_POS_Y;
    float HSM_FRM_INNER_EDGE_THICKNESS;
    float HSM_FRM_OUTER_EDGE_THICKNESS;
    float HSM_FRM_OUTER_EDGE_SHADING;
    float HSM_FRM_OUTER_CORNER_RADIUS;
    float HSM_BZL_OUTER_POSITION_Y;
    float HSM_FRM_SHADOW_OPACITY;
    float HSM_FRM_SHADOW_WIDTH;
    float HSM_REFLECT_CORNER_FADE;
    float HSM_REFLECT_CORNER_INNER_SPREAD;
    float HSM_REFLECT_CORNER_OUTER_SPREAD;
    float HSM_REFLECT_CORNER_ROTATION_OFFSET_TOP;
    float HSM_REFLECT_CORNER_ROTATION_OFFSET_BOTTOM;
    float HSM_REFLECT_CORNER_SPREAD_FALLOFF;
    float HSM_REFLECT_CORNER_FADE_DISTANCE;
    float HSM_REFLECT_GLOBAL_AMOUNT;
    float HSM_REFLECT_GLOBAL_GAMMA_ADJUST;
    float HSM_REFLECT_BEZEL_INNER_EDGE_AMOUNT;
    float HSM_REFLECT_BEZEL_INNER_EDGE_FULLSCREEN_GLOW;
    float HSM_REFLECT_FRAME_INNER_EDGE_AMOUNT;
    float HSM_REFLECT_FRAME_INNER_EDGE_SHARPNESS;
    float HSM_REFLECT_DIRECT_AMOUNT;
    float HSM_REFLECT_DIFFUSED_AMOUNT;
    float HSM_REFLECT_FULLSCREEN_GLOW;
    float HSM_REFLECT_FULLSCREEN_GLOW_GAMMA;
    float HSM_REFLECT_FADE_AMOUNT;
    float HSM_REFLECT_RADIAL_FADE_WIDTH;
    float HSM_REFLECT_RADIAL_FADE_HEIGHT;
    float HSM_REFLECT_LATERAL_OUTER_FADE_POSITION;
    float HSM_REFLECT_LATERAL_OUTER_FADE_DISTANCE;
    float HSM_REFLECT_VIGNETTE_AMOUNT;
    float HSM_REFLECT_VIGNETTE_SIZE;
    float HSM_REFLECT_NOISE_AMOUNT;
    float HSM_REFLECT_NOISE_SAMPLES;
    float HSM_REFLECT_NOISE_SAMPLE_DISTANCE;
    float HSM_REFLECT_BLUR_NUM_SAMPLES;
    float HSM_REFLECT_BLUR_FALLOFF_DISTANCE;
    float HSM_REFLECT_BLUR_MIN;
    float HSM_REFLECT_BLUR_MAX;
    float HSM_REFLECT_MASK_IMG_AMOUNT;
    float HSM_REFLECT_IS_LAST_PASS;
    float HSM_GLASS_BORDER_ON;
    float HSM_POTATO_SHOW_BG_OVER_SCREEN;
    float HSM_STANDARD_DECAL_SCALE_WITH_FRAME;
    float HSM_STANDARD_TOP_SCALE_WITH_FRAME;
    float HSM_BG_LAYER_ORDER;
    float HSM_VIEWPORT_VIGNETTE_LAYER_ORDER;
    float HSM_CRT_LAYER_ORDER;
    float HSM_DEVICE_LAYER_ORDER;
    float HSM_CAB_GLASS_LAYER_ORDER;
    float HSM_DECAL_LAYER_ORDER;
    float HSM_LED_LAYER_ORDER;
    float HSM_TOP_LAYER_ORDER;
    float HSM_CUTOUT_ASPECT_MODE;
    float HSM_CUTOUT_EXPLICIT_ASPECT;
    float HSM_CUTOUT_SCALE_MODE;
    float HSM_CUTOUT_SCALE_FULL_WITH_ZOOM;
    float HSM_CUTOUT_KEEP_ASPECT;
    float HSM_CUTOUT_SCALE;
    float HSM_CUTOUT_SCALE_X;
    float HSM_CUTOUT_CORNER_RADIUS;
    float HSM_CUTOUT_POS_X;
    float HSM_CUTOUT_POS_Y;
    float HSM_BG_OPACITY;
    float HSM_BG_HUE;
    float HSM_BG_COLORIZE_ON;
    float HSM_BG_SATURATION;
    float HSM_BG_BRIGHTNESS;
    float HSM_BG_GAMMA;
    float HSM_BG_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_BG_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_BG_APPLY_AMBIENT_IN_ADD_MODE;
    float HSM_BG_BLEND_MODE;
    float HSM_BG_SOURCE_MATTE_TYPE;
    float HSM_BG_MASK_MODE;
    float HSM_BG_CUTOUT_MODE;
    float HSM_BG_DUALSCREEN_VIS_MODE;
    float HSM_BG_SCALE_MODE;
    float HSM_BG_SCALE_FULL_WITH_ZOOM;
    float HSM_BG_FILL_MODE;
    float HSM_BG_SCALE_KEEP_ASPECT;
    float HSM_BG_SCALE;
    float HSM_BG_SCALE_X;
    float HSM_BG_POS_X;
    float HSM_BG_POS_Y;
    float HSM_BG_MIRROR_WRAP;
    float HSM_BG_MIPMAPPING_BLEND_BIAS;
    float HSM_VIEWPORT_VIGNETTE_OPACITY;
    float HSM_VIEWPORT_VIGNETTE_MASK_MODE;
    float HSM_VIEWPORT_VIGNETTE_CUTOUT_MODE;
    float HSM_VIEWPORT_VIGNETTE_SCALE_MODE;
    float HSM_VIEWPORT_VIGNETTE_SCALE;
    float HSM_VIEWPORT_VIGNETTE_SCALE_X;
    float HSM_VIEWPORT_VIGNETTE_POS_X;
    float HSM_VIEWPORT_VIGNETTE_POS_Y;
    float HSM_LED_OPACITY;
    float HSM_LED_HUE;
    float HSM_LED_COLORIZE_ON;
    float HSM_LED_SATURATION;
    float HSM_LED_BRIGHTNESS;
    float HSM_LED_GAMMA;
    float HSM_LED_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_LED_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_LED_APPLY_AMBIENT_IN_ADD_MODE;
    float HSM_LED_BLEND_MODE;
    float HSM_LED_SOURCE_MATTE_TYPE;
    float HSM_LED_MASK_MODE;
    float HSM_LED_CUTOUT_MODE;
    float HSM_LED_DUALSCREEN_VIS_MODE;
    float HSM_LED_SCALE_MODE;
    float HSM_LED_SCALE_FULL_WITH_ZOOM;
    float HSM_LED_SCALE_KEEP_ASPECT;
    float HSM_LED_FILL_MODE;
    float HSM_LED_SCALE;
    float HSM_LED_SCALE_X;
    float HSM_LED_POS_X;
    float HSM_LED_POS_Y;
    float HSM_LED_MIPMAPPING_BLEND_BIAS;
    float HSM_DEVICE_OPACITY;
    float HSM_DEVICE_HUE;
    float HSM_DEVICE_COLORIZE_ON;
    float HSM_DEVICE_SATURATION;
    float HSM_DEVICE_BRIGHTNESS;
    float HSM_DEVICE_GAMMA;
    float HSM_DEVICE_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_DEVICE_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_DEVICE_APPLY_AMBIENT_IN_ADD_MODE;
    float HSM_DEVICE_BLEND_MODE;
    float HSM_DEVICE_SOURCE_MATTE_TYPE;
    float HSM_DEVICE_MASK_MODE;
    float HSM_DEVICE_CUTOUT_MODE;
    float HSM_DEVICE_DUALSCREEN_VIS_MODE;
    float HSM_DEVICE_SCALE_MODE;
    float HSM_DEVICE_SCALE_FULL_WITH_ZOOM;
    float HSM_DEVICE_SCALE_KEEP_ASPECT;
    float HSM_DEVICE_FILL_MODE;
    float HSM_DEVICE_SCALE;
    float HSM_DEVICE_SCALE_X;
    float HSM_DEVICE_POS_X;
    float HSM_DEVICE_POS_Y;
    float HSM_DEVICE_COPY_INHERITED_COORD;
    float HSM_REFLECT_MASK_SCALE_MODE;
    float HSM_DEVICE_MIPMAPPING_BLEND_BIAS;
    float HSM_FRM_OPACITY;
    float HSM_FRM_BLEND_MODE;
    float HSM_FRM_TEXTURE_OPACITY;
    float HSM_FRM_TEXTURE_BLEND_MODE;
    float HSM_DECAL_OPACITY;
    float HSM_DECAL_HUE;
    float HSM_DECAL_COLORIZE_ON;
    float HSM_DECAL_SATURATION;
    float HSM_DECAL_BRIGHTNESS;
    float HSM_DECAL_GAMMA;
    float HSM_DECAL_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_DECAL_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_DECAL_APPLY_AMBIENT_IN_ADD_MODE;
    float HSM_DECAL_BLEND_MODE;
    float HSM_DECAL_SOURCE_MATTE_TYPE;
    float HSM_DECAL_MASK_MODE;
    float HSM_DECAL_CUTOUT_MODE;
    float HSM_DECAL_DUALSCREEN_VIS_MODE;
    float HSM_DECAL_SCALE_MODE;
    float HSM_DECAL_SCALE_FULL_WITH_ZOOM;
    float HSM_DECAL_SCALE_KEEP_ASPECT;
    float HSM_DECAL_FILL_MODE;
    float HSM_DECAL_SCALE;
    float HSM_DECAL_SCALE_X;
    float HSM_DECAL_POS_X;
    float HSM_DECAL_POS_Y;
    float HSM_DECAL_MIPMAPPING_BLEND_BIAS;
    float HSM_CAB_GLASS_OPACITY;
    float HSM_CAB_GLASS_HUE;
    float HSM_CAB_GLASS_COLORIZE_ON;
    float HSM_CAB_GLASS_SATURATION;
    float HSM_CAB_GLASS_BRIGHTNESS;
    float HSM_CAB_GLASS_GAMMA;
    float HSM_CAB_GLASS_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_CAB_GLASS_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_CAB_GLASS_APPLY_AMBIENT_IN_ADD_MODE;
    float HSM_CAB_GLASS_BLEND_MODE;
    float HSM_CAB_GLASS_SOURCE_MATTE_TYPE;
    float HSM_CAB_GLASS_MASK_MODE;
    float HSM_CAB_GLASS_CUTOUT_MODE;
    float HSM_CAB_GLASS_DUALSCREEN_VIS_MODE;
    float HSM_CAB_GLASS_SCALE_MODE;
    float HSM_CAB_GLASS_SCALE_FULL_WITH_ZOOM;
    float HSM_CAB_GLASS_SCALE_KEEP_ASPECT;
    float HSM_CAB_GLASS_FILL_MODE;
    float HSM_CAB_GLASS_SCALE;
    float HSM_CAB_GLASS_SCALE_X;
    float HSM_CAB_GLASS_POS_X;
    float HSM_CAB_GLASS_POS_Y;
    float HSM_CAB_GLASS_MIPMAPPING_BLEND_BIAS;
    float HSM_TOP_OPACITY;
    float HSM_TOP_HUE;
    float HSM_TOP_COLORIZE_ON;
    float HSM_TOP_SATURATION;
    float HSM_TOP_BRIGHTNESS;
    float HSM_TOP_GAMMA;
    float HSM_TOP_AMBIENT_LIGHTING_MULTIPLIER;
    float HSM_TOP_AMBIENT2_LIGHTING_MULTIPLIER;
    float HSM_TOP_APPLY_AMBIENT_IN_ADD_MODE;
    float HSM_TOP_BLEND_MODE;
    float HSM_TOP_SOURCE_MATTE_TYPE;
    float HSM_TOP_MASK_MODE;
    float HSM_TOP_CUTOUT_MODE;
    float HSM_TOP_DUALSCREEN_VIS_MODE;
    float HSM_TOP_SCALE_MODE;
    float HSM_TOP_SCALE_FULL_WITH_ZOOM;
    float HSM_TOP_SCALE_KEEP_ASPECT;
    float HSM_TOP_FILL_MODE;
    float HSM_TOP_SCALE;
    float HSM_TOP_SCALE_X;
    float HSM_TOP_POS_X;
    float HSM_TOP_POS_Y;
    float HSM_TOP_MIRROR_WRAP;
    float HSM_TOP_MIPMAPPING_BLEND_BIAS;
    float HSM_RENDER_SIMPLE_MODE;
    float HSM_RENDER_SIMPLE_MASK_TYPE;
    float HSM_LAYERING_DEBUG_MASK_MODE;
    float HSM_INTRO_LOGO_BLEND_MODE;
    float HSM_INTRO_LOGO_FLIP_VERTICAL;
    float HSM_INTRO_NOISE_BLEND_MODE;
    float HSM_INTRO_NOISE_HOLD;
    float HSM_INTRO_NOISE_FADE_OUT;
    float HSM_INTRO_SOLID_BLACK_HOLD;
    float HSM_INTRO_SOLID_BLACK_FADE_OUT;
    float HSM_INTRO_SOLID_COLOR_BLEND_MODE;
    float HSM_INTRO_LOGO_OVER_SOLID_COLOR;
    float HSM_INTRO_LOGO_PLACEMENT;
    float HSM_INTRO_LOGO_HEIGHT;
    float HSM_INTRO_LOGO_POS_X;
    float HSM_INTRO_LOGO_POS_Y;
    float HSM_INTRO_WHEN_TO_SHOW;
    float HSM_INTRO_SPEED;
    float HSM_INTRO_LOGO_WAIT;
    float HSM_INTRO_LOGO_FADE_IN;
    float HSM_INTRO_LOGO_HOLD;
    float HSM_INTRO_LOGO_FADE_OUT;
    float HSM_INTRO_SOLID_COLOR_HUE;
    float HSM_INTRO_SOLID_COLOR_SAT;
    float HSM_INTRO_SOLID_COLOR_VALUE;
    float HSM_INTRO_SOLID_COLOR_HOLD;
    float HSM_INTRO_SOLID_COLOR_FADE_OUT;
    float GAMMA_INPUT;
    float gamma_out;
    float post_br;
    float post_br_affect_black_level;
    float glow;
    float bloom;
    float mask_bloom;
    float bloom_dist;
    float halation;
    float TATE;
    float IOS;
    float OS;
    float BLOOM;
    float overscanX;
    float overscanY;
    float intres;
    float prescalex;
    float c_shape;
    float sborder;
    float csize;
    float bsize1;
    float warpX;
    float warpY;
    float gamma_c;
    float brightboost;
    float brightboost1;
    float blendMode;
    float gsl;
    float scanline1;
    float scanline2;
    float beam_min;
    float beam_max;
    float beam_size;
    float vertmask;
    float scans;
    float scan_falloff;
    float spike;
    float ring;
    float scangamma;
    float rolling_scan;
    float h_sharp;
    float s_sharp;
    float smart_ei;
    float ei_limit;
    float sth;
    float barspeed;
    float barintensity;
    float bardir;
    float shadowMask;
    float maskstr;
    float mcut;
    float masksize;
    float maskDark;
    float maskLight;
    float mask_gamma;
    float slotmask;
    float slotmask1;
    float slotwidth;
    float double_slot;
    float slotms;
    float mclip;
    float mshift;
    float mask_layout;
    float GDV_DECONVERGENCE_ON;
    float decons;
    float GDV_NOISE_ON;
    float addnoised;
    float noisetype;
    float noiseresd;
    float deconrr;
    float deconrg;
    float deconrb;
    float deconrry;
    float deconrgy;
    float deconrby;
    float deconsmooth;
    float dctypex;
    float dctypey;
    float g_grade_on;
    float wp_temperature;
    float g_satr;
    float g_satg;
    float g_satb;
    float AS;
    float asat;
    float hcrt_h_size;
    float hcrt_v_size;
    float hcrt_h_cent;
    float hcrt_v_cent;
    float hcrt_pin_phase;
    float hcrt_pin_amp;
} global;

struct Push
{
    vec4 OriginalSize;
    vec4 OutputSize;
    uint FrameCount;
};

uniform Push params;

layout(binding = 4) uniform sampler2D NegativeCropAddedPass;
layout(binding = 3) uniform sampler2D PrePass;
layout(binding = 1) uniform sampler2D InfoCachePass;
layout(binding = 2) uniform sampler2D InfoCachePassFeedback;

layout(location = 0) in vec2 vTexCoord;
layout(location = 0) out vec4 FragColor;
float NEGATIVE_CROP_EXPAND_MULTIPLIER;
float MAX_NEGATIVE_CROP;
float DEFAULT_SCREEN_ASPECT;
float DEFAULT_BEZEL_ASPECT;
vec2 DEFAULT_SCREEN_SCALE;
vec2 DEFAULT_BEZEL_SCALE;
int INFOCACHE_MAX_INDEX;
float BLEND_MODE_OFF;
float BLEND_MODE_NORMAL;
float BLEND_MODE_ADD;
float BLEND_MODE_MULTIPLY;
float SOURCE_MATTE_PREMULTIPLIED;
float SOURCE_MATTE_WHITE;
float SOURCE_MATTE_NONE;
float IMAGE_ASPECT_MODE_INHERIT_ASPECT_SCALE;
float IMAGE_ASPECT_MODE_KEEP_ASPECT;
float FILL_MODE_STRETCH;
float FILL_MODE_SPLIT_FILL_HORIZONTAL;
float FILL_MODE_SPLIT_FILL_VERTICAL;
bool CACHE_INFO_PARAM_SUM_CHANGED;
float CURRENT_FRAME_FROM_CACHE_INFO;
float TUBE_DIFFUSE_MASK;
float TUBE_MASK;
float BEZEL_MASK;
float INSIDE_BEZEL_MASK;
float OUTSIDE_TUBE_MASK_FOR_IMAGE;
float FRAME_MASK;
float FRAME_MASK_FOR_IMAGE;
float OUTSIDE_BEZEL_MASK;
float OUTSIDE_FRAME_MASK_FOR_IMAGE;
float OUTSIDE_FRAME_MASK;
float CUTOUT_MASK;
float SCREEN_INDEX;
float SCREEN_ASPECT;
vec2 SCREEN_SCALE;
vec2 SCREEN_POS_OFFSET;
vec2 SCREEN_SCALE_2ND_SCREEN;
vec2 SCREEN_POS_OFFSET_2ND_SCREEN;
vec2 VIEWPORT_SCALE;
vec2 VIEWPORT_POS;
vec2 TUBE_SCALE;
vec2 TUBE_DIFFUSE_SCALE;
float TUBE_DIFFUSE_ASPECT;
vec2 FRAME_SCALE;
vec2 BEZEL_OUTSIDE_SCALE;
vec2 BACKGROUND_SCALE;
vec2 LED_SCALE;
vec2 DEVICE_SCALE;
vec2 DECAL_SCALE;
vec2 CAB_GLASS_SCALE;
vec2 TOP_IMAGE_SCALE;
float AVERAGE_LUMA;
float USE_VERTICAL_SCANLINES;
vec2 CORE_SIZE;
vec2 ROTATED_CORE_ORIGINAL_SIZE;
vec2 ROTATED_CORE_PREPPED_SIZE;
vec2 ROTATED_DEREZED_SIZE;
vec2 CROPPED_ROTATED_SIZE_WITH_RES_MULT;
vec2 CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK;
vec2 CROPPED_ROTATED_SIZE;
vec2 SAMPLE_AREA_START_PIXEL_COORD;
vec2 VIEWPORT_UNSCALED_COORD;
vec2 SCREEN_COORD;
vec2 TUBE_COORD;
vec2 TUBE_DIFFUSE_COORD;
vec2 BEZEL_OUTSIDE_COORD;
vec2 BACKGROUND_COORD;
vec2 DEVICE_COORD;
vec2 LED_COORD;
vec2 DECAL_COORD;
vec2 CAB_GLASS_COORD;
vec2 TOP_IMAGE_COORD;
vec2 SCREEN_CURVED_COORD;
vec2 TUBE_CURVED_COORD;
vec2 TUBE_DIFFUSE_CURVED_COORD;
vec2 BEZEL_OUTSIDE_CURVED_COORD;
vec2 FRAME_OUTSIDE_CURVED_COORD;
vec2 BACKGROUND_CURVED_COORD;
vec2 LED_CURVED_COORD;
vec2 DEVICE_CURVED_COORD;
vec2 DECAL_CURVED_COORD;
vec2 CAB_GLASS_CURVED_COORD;
vec2 TOP_IMAGE_CURVED_COORD;
float HSM_RESOLUTION_DEBUG_ON;
float HSM_CACHE_GRAPHICS_ON;
float HSM_CACHE_UPDATE_INDICATOR_MODE;
float HSM_GLOBAL_GRAPHICS_BRIGHTNESS;
float HSM_STATIC_LAYERS_GAMMA;
float HSM_AMBIENT_LIGHTING_OPACITY;
float HSM_AMBIENT2_LIGHTING_OPACITY;
float HSM_AMBIENT_LIGHTING_SWAP_IMAGES;
float HSM_VIEWPORT_ZOOM;
float HSM_VIEWPORT_ZOOM_MASK;
float HSM_VIEWPORT_POSITION_X;
float HSM_VIEWPORT_POSITION_Y;
float HSM_FLIP_VIEWPORT_VERTICAL;
float HSM_FLIP_VIEWPORT_HORIZONTAL;
float HSM_FLIP_CORE_VERTICAL;
float HSM_FLIP_CORE_HORIZONTAL;
float HSM_ROTATE_CORE_IMAGE;
float HSM_ASPECT_RATIO_ORIENTATION;
float HSM_ASPECT_RATIO_MODE;
float HSM_ASPECT_RATIO_EXPLICIT;
float HSM_VERTICAL_PRESET;
float HSM_INT_SCALE_MAX_HEIGHT;
float HSM_NON_INTEGER_SCALE;
float HSM_USE_PHYSICAL_SIZE_FOR_NON_INTEGER;
float HSM_PHYSICAL_MONITOR_ASPECT_RATIO;
float HSM_PHYSICAL_MONITOR_DIAGONAL_SIZE;
float HSM_PHYSICAL_SIM_TUBE_DIAGONAL_SIZE;
float HSM_USE_IMAGE_FOR_PLACEMENT;
float HSM_PLACEMENT_IMAGE_USE_HORIZONTAL;
float HSM_PLACEMENT_IMAGE_MODE;
float HSM_NON_INTEGER_SCALE_OFFSET;
float HSM_USE_SNAP_TO_CLOSEST_INT_SCALE;
float HSM_SNAP_TO_CLOSEST_INT_SCALE_TOLERANCE;
float HSM_SCREEN_POSITION_X;
float HSM_SCREEN_POSITION_Y;
float HSM_CROP_MODE;
float HSM_CROP_PERCENT_ZOOM;
float HSM_CROP_PERCENT_TOP;
float HSM_CROP_PERCENT_BOTTOM;
float HSM_CROP_PERCENT_LEFT;
float HSM_CROP_PERCENT_RIGHT;
float HSM_CROP_BLACK_THRESHOLD;
float HSM_SCANLINE_DIRECTION;
float HSM_CORE_RES_SAMPLING_MULT_SCANLINE_DIR;
float HSM_DOWNSAMPLE_BLUR_SCANLINE_DIR;
float HSM_CORE_RES_SAMPLING_MULT_OPPOSITE_DIR;
float HSM_DOWNSAMPLE_BLUR_OPPOSITE_DIR;
float HSM_CORE_RES_SAMPLING_SHIFT_OPPOSITE_DIR;
float HSM_USE_GEOM;
float HSM_CURVATURE_MODE;
float HSM_CURVATURE_3D_RADIUS;
float HSM_CURVATURE_3D_VIEW_DIST;
float HSM_CURVATURE_3D_TILT_ANGLE_X;
float HSM_CURVATURE_3D_TILT_ANGLE_Y;
float HSM_CRT_CURVATURE_SCALE;
float HSM_AB_COMPARE_SHOW_MODE;
float HSM_AB_COMPARE_AREA;
float HSM_AB_COMPARE_SPLIT_POSITION;
float HSM_AB_COMPARE_FREEZE_CRT_TUBE;
float HSM_AB_COMPARE_FREEZE_GRAPHICS;
float HSM_SCREEN_VIGNETTE_DUALSCREEN_VIS_MODE;
float HSM_MONOCHROME_DUALSCREEN_VIS_MODE;
float HSM_TUBE_DIFFUSE_MODE;
float HSM_TUBE_DIFFUSE_OPACITY;
float HSM_TUBE_DIFFUSE_IMAGE_DUALSCREEN_VIS_MODE;
float HSM_TUBE_DIFFUSE_IMAGE_COLORIZE_ON;
float HSM_TUBE_DIFFUSE_IMAGE_HUE;
float HSM_TUBE_DIFFUSE_IMAGE_SATURATION;
float HSM_TUBE_DIFFUSE_IMAGE_BRIGHTNESS;
float HSM_TUBE_DIFFUSE_IMAGE_GAMMA;
float HSM_TUBE_DIFFUSE_IMAGE_AMBIENT_LIGHTING;
float HSM_TUBE_DIFFUSE_IMAGE_AMBIENT2_LIGHTING;
float HSM_TUBE_DIFFUSE_IMAGE_SCALE;
float HSM_TUBE_DIFFUSE_IMAGE_SCALE_X;
float HSM_TUBE_SHADOW_IMAGE_ON;
float HSM_TUBE_SHADOW_IMAGE_OPACITY;
float HSM_TUBE_SHADOW_IMAGE_POS_X;
float HSM_TUBE_SHADOW_IMAGE_POS_Y;
float HSM_TUBE_SHADOW_IMAGE_SCALE_X;
float HSM_TUBE_SHADOW_IMAGE_SCALE_Y;
float HSM_TUBE_SHADOW_CURVATURE_SCALE;
float HSM_TUBE_COLORED_GEL_IMAGE_ON;
float HSM_TUBE_COLORED_GEL_IMAGE_SCALE;
float HSM_TUBE_COLORED_GEL_IMAGE_FLIP_HORIZONTAL;
float HSM_TUBE_COLORED_GEL_IMAGE_FLIP_VERTICAL;
float HSM_TUBE_COLORED_GEL_IMAGE_DUALSCREEN_VIS_MODE;
float HSM_TUBE_COLORED_GEL_IMAGE_MULTIPLY_AMOUNT;
float HSM_TUBE_COLORED_GEL_IMAGE_ADDITIVE_AMOUNT;
float HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_AMOUNT;
float HSM_TUBE_COLORED_GEL_IMAGE_TRANSPARENCY_THRESHOLD;
float HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_BRIGHTNESS;
float HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_VIGNETTE;
float HSM_TUBE_COLORED_GEL_IMAGE_FAKE_SCANLINE_AMOUNT;
float HSM_TUBE_COLORED_GEL_IMAGE_AMBIENT_LIGHTING;
float HSM_TUBE_COLORED_GEL_IMAGE_AMBIENT2_LIGHTING;
float HSM_SHOW_CRT_ON_TOP_OF_COLORED_GEL;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_ON;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_DUALSCREEN_VIS_MODE;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_OPACITY;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_AMBIENT_LIGHTING;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_AMBIENT2_LIGHTING;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_SCALE;
float HSM_TUBE_STATIC_REFLECTION_IMAGE_SHADOW_OPACITY;
float HSM_DUALSCREEN_MODE;
float HSM_DUALSCREEN_CORE_IMAGE_SPLIT_MODE;
float HSM_DUALSCREEN_CORE_IMAGE_SWAP_SCREENS;
float HSM_DUALSCREEN_CORE_IMAGE_SPLIT_OFFSET;
float HSM_DUALSCREEN_VIEWPORT_SPLIT_LOCATION;
float HSM_DUALSCREEN_SHIFT_POSITION_WITH_SCALE;
float HSM_DUALSCREEN_POSITION_OFFSET_BETWEEN_SCREENS;
float HSM_2ND_SCREEN_ASPECT_RATIO_MODE;
float HSM_2ND_SCREEN_INDEPENDENT_SCALE;
float HSM_2ND_SCREEN_SCALE_OFFSET;
float HSM_2ND_SCREEN_POS_X;
float HSM_2ND_SCREEN_POS_Y;
float HSM_2ND_SCREEN_CROP_PERCENT_ZOOM;
float HSM_2ND_SCREEN_CROP_PERCENT_TOP;
float HSM_2ND_SCREEN_CROP_PERCENT_BOTTOM;
float HSM_2ND_SCREEN_CROP_PERCENT_LEFT;
float HSM_2ND_SCREEN_CROP_PERCENT_RIGHT;
float HSM_SCREEN_REFLECTION_SCALE;
float HSM_SCREEN_REFLECTION_POS_X;
float HSM_SCREEN_REFLECTION_POS_Y;
float HSM_AMBIENT_LIGHTING_HUE;
float HSM_AMBIENT_LIGHTING_SATURATION;
float HSM_AMBIENT_LIGHTING_VALUE;
float HSM_AMBIENT_LIGHTING_CONTRAST;
float HSM_AMBIENT_LIGHTING_SCALE_KEEP_ASPECT;
float HSM_AMBIENT_LIGHTING_SCALE_WITH_ZOOM;
float HSM_AMBIENT_LIGHTING_SCALE;
float HSM_AMBIENT_LIGHTING_SCALE_X;
float HSM_AMBIENT_LIGHTING_ROTATE;
float HSM_AMBIENT_LIGHTING_MIRROR_HORZ;
float HSM_AMBIENT_LIGHTING_POSITION_X;
float HSM_AMBIENT_LIGHTING_POSITION_Y;
float HSM_AMBIENT_LIGHTING_DITHERING_SAMPLES;
float HSM_AMBIENT2_LIGHTING_HUE;
float HSM_AMBIENT2_LIGHTING_SATURATION;
float HSM_AMBIENT2_LIGHTING_VALUE;
float HSM_AMBIENT2_LIGHTING_CONTRAST;
float HSM_AMBIENT2_LIGHTING_SCALE_KEEP_ASPECT;
float HSM_AMBIENT2_LIGHTING_SCALE_WITH_ZOOM;
float HSM_AMBIENT2_LIGHTING_SCALE;
float HSM_AMBIENT2_LIGHTING_SCALE_X;
float HSM_AMBIENT2_LIGHTING_ROTATE;
float HSM_AMBIENT2_LIGHTING_MIRROR_HORZ;
float HSM_AMBIENT2_LIGHTING_POSITION_X;
float HSM_AMBIENT2_LIGHTING_POSITION_Y;
float HSM_BZL_OPACITY;
float HSM_BZL_BLEND_MODE;
float HSM_BZL_WIDTH;
float HSM_BZL_HEIGHT;
float HSM_BZL_INNER_CORNER_RADIUS_SCALE;
float CURVATURE_MODE_OFF;
float CURVATURE_MODE_2D;
float CURVATURE_MODE_2D_CYLINDER;
float CURVATURE_MODE_3D_1;
float CURVATURE_MODE_3D_2;
float CURVATURE_MODE_3D_CYLINDER;
bool use_vert_scanlines_bool;

vec2 HSM_GetViewportCoordWithFlip(vec2 viewport_coord)
{
    vec2 out_coord = viewport_coord;
    if (HSM_FLIP_VIEWPORT_VERTICAL == (-1.0))
    {
        out_coord.y = 1.0 - out_coord.y;
    }
    if (HSM_FLIP_VIEWPORT_HORIZONTAL == (-1.0))
    {
        out_coord.x = 1.0 - out_coord.x;
    }
    return out_coord;
}

vec2 HSM_GetViewportCoordWithZoomAndPan(vec2 viewport_coord)
{
    vec2 param = viewport_coord;
    vec2 out_coord = HSM_GetViewportCoordWithFlip(param);
    out_coord = ((out_coord - vec2(0.5)) / vec2(HSM_VIEWPORT_ZOOM)) + vec2(0.5);
    out_coord.x += HSM_VIEWPORT_POSITION_X;
    out_coord.y -= HSM_VIEWPORT_POSITION_Y;
    return out_coord;
}

float HSM_GetScreenIndex(vec2 viewport_coord)
{
    float out_index = 1.0;
    float output_aspect = global.FinalViewportSize.x / global.FinalViewportSize.y;
    if (HSM_DUALSCREEN_MODE == 0.0)
    {
        out_index = 1.0;
    }
    if (HSM_DUALSCREEN_MODE == 1.0)
    {
        out_index = float((viewport_coord.y < (0.5 + (HSM_DUALSCREEN_VIEWPORT_SPLIT_LOCATION / output_aspect))) ? 1 : 2);
    }
    if (HSM_DUALSCREEN_MODE == 2.0)
    {
        out_index = float((viewport_coord.x < (0.5 + (HSM_DUALSCREEN_VIEWPORT_SPLIT_LOCATION / output_aspect))) ? 1 : 2);
    }
    return out_index;
}

vec2 HSM_GetRotatedNegativeCropAddedSize()
{
    return (global.NegativeCropAddedPassSize.yx * HSM_ROTATE_CORE_IMAGE) + (global.NegativeCropAddedPassSize.xy * (1.0 - HSM_ROTATE_CORE_IMAGE));
}

vec2 HSM_GetRotatedCoreOriginalSize()
{
    return (global.OriginalSize.yx * HSM_ROTATE_CORE_IMAGE) + (global.OriginalSize.xy * (1.0 - HSM_ROTATE_CORE_IMAGE));
}

vec4 HSM_GetCacheSampleRange(float column_index, float row_index)
{
    float num_rows = 8.0;
    float num_columns = 8.0;
    float range_width = 1.0 / num_columns;
    float range_height = 1.0 / num_rows;
    float zero_based_row_index = row_index - 1.0;
    float zero_based_column_index = column_index - 1.0;
    vec4 out_sample_range = vec4(0.0);
    out_sample_range.x = zero_based_column_index * range_width;
    out_sample_range.y = zero_based_row_index * range_height;
    out_sample_range.z = out_sample_range.x + range_width;
    out_sample_range.w = out_sample_range.y + range_height;
    return out_sample_range;
}

vec2 HSM_GetCacheSampleCoord(float column_index, float row_index)
{
    float num_rows = 8.0;
    float num_columns = 8.0;
    float range_width = 1.0 / num_columns;
    float range_height = 1.0 / num_rows;
    float param = column_index;
    float param_1 = row_index;
    vec4 sample_range = HSM_GetCacheSampleRange(param, param_1);
    return vec2(sample_range.x + (range_width / 2.0), sample_range.y + (range_height / 2.0));
}

float HSM_GetUseVerticalScanlines(float screen_aspect)
{
    float auto_use_vert_scanlines = float(int(screen_aspect < 1.0));
    float scanline_direction = float((HSM_SCANLINE_DIRECTION < 2.0) ? 0 : 1);
    if (HSM_SCANLINE_DIRECTION < 1.0)
    {
        if (HSM_DUALSCREEN_MODE < 1.0)
        {
            scanline_direction = auto_use_vert_scanlines;
        }
    }
    return scanline_direction;
}

vec2 HSM_GetCoordWithPositionOffset(vec2 in_coord, vec2 position_offset)
{
    return in_coord - position_offset;
}

vec2 HSM_GetInverseScaledCoord(vec2 in_coord, vec2 in_scale)
{
    vec2 middle = vec2(0.499989986419677734375);
    vec2 diff = in_coord - middle;
    vec2 screen_inverse_scale = vec2(1.0) / in_scale;
    vec2 scaled_coord = middle + (diff * screen_inverse_scale);
    return scaled_coord;
}

vec2 HSM_GetVTexCoordWithArgs(vec2 in_coord, vec2 in_scale, vec2 position_offset)
{
    vec2 param = in_coord;
    vec2 param_1 = position_offset;
    vec2 param_2 = HSM_GetCoordWithPositionOffset(param, param_1);
    vec2 param_3 = in_scale;
    return HSM_GetInverseScaledCoord(param_2, param_3);
}

vec4 HSM_UpdateGlobalScreenValuesFromCache(sampler2D in_cache_pass, sampler2D in_cache_feedback_pass, vec2 vTexCoord_1)
{
    float output_aspect = global.FinalViewportSize.x / global.FinalViewportSize.y;
    vec2 param = vTexCoord_1;
    vec2 flipped_viewport_coord = HSM_GetViewportCoordWithZoomAndPan(param);
    vec2 param_1 = flipped_viewport_coord;
    SCREEN_INDEX = HSM_GetScreenIndex(param_1);
    CORE_SIZE = global.CorePassSize.xy;
    ROTATED_CORE_PREPPED_SIZE = HSM_GetRotatedNegativeCropAddedSize();
    ROTATED_CORE_ORIGINAL_SIZE = HSM_GetRotatedCoreOriginalSize();
    vec2 sample_coord = vec2(0.0);
    vec4 texture_sample = vec4(0.0);
    float param_2 = 1.0;
    float param_3 = 1.0;
    sample_coord = HSM_GetCacheSampleCoord(param_2, param_3);
    texture_sample = texture(in_cache_pass, sample_coord);
    AVERAGE_LUMA = texture_sample.w;
    float res_mult_size_sum = 0.0;
    float res_mult_size_sum_feedback = 0.0;
    float res_mult_size2_sum = 0.0;
    float res_mult_size2_sum_feedback = 0.0;
    if (SCREEN_INDEX == 1.0)
    {
        float param_4 = 2.0;
        float param_5 = 1.0;
        sample_coord = HSM_GetCacheSampleCoord(param_4, param_5);
        texture_sample = texture(in_cache_pass, sample_coord);
        SCREEN_ASPECT = texture_sample.x;
        SCREEN_SCALE = texture_sample.zw;
        float param_6 = 3.0;
        float param_7 = 1.0;
        sample_coord = HSM_GetCacheSampleCoord(param_6, param_7);
        texture_sample = texture(in_cache_pass, sample_coord);
        TUBE_SCALE = texture_sample.xy;
        SCREEN_POS_OFFSET = texture_sample.zw;
        float param_8 = 3.0;
        float param_9 = 4.0;
        sample_coord = HSM_GetCacheSampleCoord(param_8, param_9);
        texture_sample = texture(in_cache_pass, sample_coord);
        TUBE_DIFFUSE_SCALE = texture_sample.xy;
        TUBE_DIFFUSE_ASPECT = (TUBE_DIFFUSE_SCALE.x / TUBE_DIFFUSE_SCALE.y) * output_aspect;
        float param_10 = 4.0;
        float param_11 = 1.0;
        sample_coord = HSM_GetCacheSampleCoord(param_10, param_11);
        texture_sample = texture(in_cache_pass, sample_coord);
        CROPPED_ROTATED_SIZE_WITH_RES_MULT = texture_sample.xy;
        res_mult_size_sum = CROPPED_ROTATED_SIZE_WITH_RES_MULT.x + CROPPED_ROTATED_SIZE_WITH_RES_MULT.y;
        texture_sample = texture(in_cache_feedback_pass, sample_coord);
        CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK = texture_sample.xy;
        res_mult_size_sum_feedback = CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK.x + CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK.y;
        float param_12 = 1.0;
        float param_13 = 2.0;
        sample_coord = HSM_GetCacheSampleCoord(param_12, param_13);
        texture_sample = texture(in_cache_pass, sample_coord);
        CROPPED_ROTATED_SIZE = texture_sample.xy;
        SAMPLE_AREA_START_PIXEL_COORD = texture_sample.zw;
    }
    if (SCREEN_INDEX == 2.0)
    {
        float param_14 = 2.0;
        float param_15 = 2.0;
        sample_coord = HSM_GetCacheSampleCoord(param_14, param_15);
        texture_sample = texture(in_cache_pass, sample_coord);
        SCREEN_ASPECT = texture_sample.x;
        SCREEN_SCALE = texture_sample.yz;
        float param_16 = 3.0;
        float param_17 = 2.0;
        sample_coord = HSM_GetCacheSampleCoord(param_16, param_17);
        texture_sample = texture(in_cache_pass, sample_coord);
        TUBE_SCALE = texture_sample.xy;
        SCREEN_POS_OFFSET = texture_sample.zw;
        float param_18 = 3.0;
        float param_19 = 4.0;
        sample_coord = HSM_GetCacheSampleCoord(param_18, param_19);
        texture_sample = texture(in_cache_pass, sample_coord);
        TUBE_DIFFUSE_SCALE = texture_sample.zw;
        TUBE_DIFFUSE_ASPECT = (TUBE_DIFFUSE_SCALE.x / TUBE_DIFFUSE_SCALE.y) * output_aspect;
        float param_20 = 4.0;
        float param_21 = 2.0;
        sample_coord = HSM_GetCacheSampleCoord(param_20, param_21);
        texture_sample = texture(in_cache_pass, sample_coord);
        CROPPED_ROTATED_SIZE_WITH_RES_MULT = texture_sample.xy;
        res_mult_size2_sum = CROPPED_ROTATED_SIZE_WITH_RES_MULT.x + CROPPED_ROTATED_SIZE_WITH_RES_MULT.y;
        texture_sample = texture(in_cache_feedback_pass, sample_coord);
        CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK = texture_sample.xy;
        res_mult_size2_sum_feedback = CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK.x + CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK.y;
        float param_22 = 1.0;
        float param_23 = 3.0;
        sample_coord = HSM_GetCacheSampleCoord(param_22, param_23);
        texture_sample = texture(in_cache_pass, sample_coord);
        CROPPED_ROTATED_SIZE = texture_sample.xy;
        SAMPLE_AREA_START_PIXEL_COORD = texture_sample.zw;
    }
    float param_24 = 2.0;
    float param_25 = 3.0;
    sample_coord = HSM_GetCacheSampleCoord(param_24, param_25);
    texture_sample = texture(in_cache_pass, sample_coord);
    CORE_SIZE = texture_sample.xy;
    float param_26 = 3.0;
    float param_27 = 3.0;
    sample_coord = HSM_GetCacheSampleCoord(param_26, param_27);
    texture_sample = texture(in_cache_pass, sample_coord);
    VIEWPORT_SCALE = texture_sample.xy;
    VIEWPORT_POS = texture_sample.zw;
    float param_28 = 4.0;
    float param_29 = 3.0;
    sample_coord = HSM_GetCacheSampleCoord(param_28, param_29);
    texture_sample = texture(in_cache_pass, sample_coord);
    SCREEN_SCALE_2ND_SCREEN = texture_sample.xy;
    SCREEN_POS_OFFSET_2ND_SCREEN = texture_sample.zw;
    float param_30 = 1.0;
    float param_31 = 4.0;
    sample_coord = HSM_GetCacheSampleCoord(param_30, param_31);
    texture_sample = texture(in_cache_pass, sample_coord);
    float parameter_sum = texture_sample.x;
    CURRENT_FRAME_FROM_CACHE_INFO = texture_sample.y;
    ROTATED_DEREZED_SIZE = texture_sample.zw;
    texture_sample = texture(in_cache_feedback_pass, sample_coord);
    float parameter_sum_feedback = texture_sample.x;
    float param_32 = 2.0;
    float param_33 = 4.0;
    sample_coord = HSM_GetCacheSampleCoord(param_32, param_33);
    texture_sample = texture(in_cache_pass, sample_coord);
    NEGATIVE_CROP_EXPAND_MULTIPLIER = texture_sample.x;
    MAX_NEGATIVE_CROP = texture_sample.y;
    float param_34 = SCREEN_ASPECT;
    USE_VERTICAL_SCANLINES = HSM_GetUseVerticalScanlines(param_34);
    vec2 param_35 = flipped_viewport_coord;
    vec2 param_36 = SCREEN_SCALE;
    vec2 param_37 = SCREEN_POS_OFFSET;
    SCREEN_COORD = HSM_GetVTexCoordWithArgs(param_35, param_36, param_37);
    vec2 param_38 = flipped_viewport_coord;
    vec2 param_39 = TUBE_DIFFUSE_SCALE;
    vec2 param_40 = SCREEN_POS_OFFSET;
    TUBE_DIFFUSE_COORD = HSM_GetVTexCoordWithArgs(param_38, param_39, param_40);
    float param_sum_epsilon = 1.0000000116860974230803549289703e-07;
    CACHE_INFO_PARAM_SUM_CHANGED = false;
    CACHE_INFO_PARAM_SUM_CHANGED = ((res_mult_size_sum != res_mult_size_sum_feedback) || (res_mult_size2_sum != res_mult_size2_sum_feedback)) ? true : CACHE_INFO_PARAM_SUM_CHANGED;
    CACHE_INFO_PARAM_SUM_CHANGED = (abs(parameter_sum - parameter_sum_feedback) > param_sum_epsilon) ? true : CACHE_INFO_PARAM_SUM_CHANGED;
    return vec4(0.0);
}

vec2 HSM_GetRotatedDerezedSize()
{
    return (global.DerezedPassSize.yx * HSM_ROTATE_CORE_IMAGE) + (global.DerezedPassSize.xy * (1.0 - HSM_ROTATE_CORE_IMAGE));
}

vec3 fetch_pixel(vec2 coord)
{
    vec2 prescale_tex_size = vec2(textureSize(NegativeCropAddedPass, 0));
    vec2 dx = vec2(1.0 / prescale_tex_size.x, 0.0) * HSM_DOWNSAMPLE_BLUR_SCANLINE_DIR;
    vec2 dy = vec2(0.0, 1.0 / prescale_tex_size.y) * HSM_DOWNSAMPLE_BLUR_OPPOSITE_DIR;
    if (use_vert_scanlines_bool)
    {
        dx = vec2(1.0 / prescale_tex_size.x, 0.0) * HSM_DOWNSAMPLE_BLUR_OPPOSITE_DIR;
        dy = vec2(0.0, 1.0 / prescale_tex_size.y) * HSM_DOWNSAMPLE_BLUR_SCANLINE_DIR;
    }
    vec2 d1 = dx + dy;
    vec2 d2 = dx - dy;
    float sum = 15.0;
    vec3 result = ((((((((texture(PrePass, coord).xyz * 3.0) + (texture(PrePass, coord + dx).xyz * 2.0)) + (texture(PrePass, coord - dx).xyz * 2.0)) + (texture(PrePass, coord + dy).xyz * 2.0)) + (texture(PrePass, coord - dy).xyz * 2.0)) + texture(PrePass, coord + d1).xyz) + texture(PrePass, coord - d1).xyz) + texture(PrePass, coord + d2).xyz) + texture(PrePass, coord - d2).xyz;
    return result / vec3(sum);
}

vec3 plant(vec3 tar, float r)
{
    float t = max(max(tar.x, tar.y), tar.z) + 9.9999997473787516355514526367188e-06;
    return (tar * r) / vec3(t);
}

void main()
{
    NEGATIVE_CROP_EXPAND_MULTIPLIER = 0.5;
    MAX_NEGATIVE_CROP = 0.5;
    DEFAULT_SCREEN_ASPECT = 1.3329918384552001953125;
    DEFAULT_BEZEL_ASPECT = 1.32272231578826904296875;
    DEFAULT_SCREEN_SCALE = vec2(0.0);
    DEFAULT_BEZEL_SCALE = vec2(0.0);
    INFOCACHE_MAX_INDEX = 4;
    BLEND_MODE_OFF = 0.0;
    BLEND_MODE_NORMAL = 1.0;
    BLEND_MODE_ADD = 2.0;
    BLEND_MODE_MULTIPLY = 3.0;
    SOURCE_MATTE_PREMULTIPLIED = 0.0;
    SOURCE_MATTE_WHITE = 1.0;
    SOURCE_MATTE_NONE = 2.0;
    IMAGE_ASPECT_MODE_INHERIT_ASPECT_SCALE = 0.0;
    IMAGE_ASPECT_MODE_KEEP_ASPECT = 1.0;
    FILL_MODE_STRETCH = 0.0;
    FILL_MODE_SPLIT_FILL_HORIZONTAL = 1.0;
    FILL_MODE_SPLIT_FILL_VERTICAL = 2.0;
    CACHE_INFO_PARAM_SUM_CHANGED = false;
    CURRENT_FRAME_FROM_CACHE_INFO = 0.0;
    TUBE_DIFFUSE_MASK = 0.0;
    TUBE_MASK = 0.0;
    BEZEL_MASK = 0.0;
    INSIDE_BEZEL_MASK = 0.0;
    OUTSIDE_TUBE_MASK_FOR_IMAGE = 0.0;
    FRAME_MASK = 0.0;
    FRAME_MASK_FOR_IMAGE = 0.0;
    OUTSIDE_BEZEL_MASK = 0.0;
    OUTSIDE_FRAME_MASK_FOR_IMAGE = 0.0;
    OUTSIDE_FRAME_MASK = 0.0;
    CUTOUT_MASK = 0.0;
    SCREEN_INDEX = 1.0;
    SCREEN_ASPECT = 1.0;
    SCREEN_SCALE = vec2(1.0);
    SCREEN_POS_OFFSET = vec2(0.1500000059604644775390625);
    SCREEN_SCALE_2ND_SCREEN = vec2(1.0);
    SCREEN_POS_OFFSET_2ND_SCREEN = vec2(0.1500000059604644775390625);
    VIEWPORT_SCALE = vec2(1.0);
    VIEWPORT_POS = vec2(1.0);
    TUBE_SCALE = vec2(1.0);
    TUBE_DIFFUSE_SCALE = vec2(1.0);
    TUBE_DIFFUSE_ASPECT = 1.0;
    FRAME_SCALE = vec2(1.0);
    BEZEL_OUTSIDE_SCALE = vec2(0.5);
    BACKGROUND_SCALE = vec2(0.5);
    LED_SCALE = vec2(0.5);
    DEVICE_SCALE = vec2(0.5);
    DECAL_SCALE = vec2(0.5);
    CAB_GLASS_SCALE = vec2(0.5);
    TOP_IMAGE_SCALE = vec2(0.5);
    AVERAGE_LUMA = 0.0;
    USE_VERTICAL_SCANLINES = 0.0;
    CORE_SIZE = vec2(1.0);
    ROTATED_CORE_ORIGINAL_SIZE = vec2(1.0);
    ROTATED_CORE_PREPPED_SIZE = vec2(1.0);
    ROTATED_DEREZED_SIZE = vec2(1.0);
    CROPPED_ROTATED_SIZE_WITH_RES_MULT = vec2(1.0);
    CROPPED_ROTATED_SIZE_WITH_RES_MULT_FEEDBACK = vec2(1.0);
    CROPPED_ROTATED_SIZE = vec2(1.0);
    SAMPLE_AREA_START_PIXEL_COORD = vec2(1.0);
    VIEWPORT_UNSCALED_COORD = vec2(0.5);
    SCREEN_COORD = vec2(0.5);
    TUBE_COORD = vec2(0.5);
    TUBE_DIFFUSE_COORD = vec2(0.5);
    BEZEL_OUTSIDE_COORD = vec2(0.5);
    BACKGROUND_COORD = vec2(0.5);
    DEVICE_COORD = vec2(0.5);
    LED_COORD = vec2(0.5);
    DECAL_COORD = vec2(0.5);
    CAB_GLASS_COORD = vec2(0.5);
    TOP_IMAGE_COORD = vec2(0.5);
    SCREEN_CURVED_COORD = vec2(0.5);
    TUBE_CURVED_COORD = vec2(0.5);
    TUBE_DIFFUSE_CURVED_COORD = vec2(0.5);
    BEZEL_OUTSIDE_CURVED_COORD = vec2(0.5);
    FRAME_OUTSIDE_CURVED_COORD = vec2(0.5);
    BACKGROUND_CURVED_COORD = vec2(0.5);
    LED_CURVED_COORD = vec2(0.5);
    DEVICE_CURVED_COORD = vec2(0.5);
    DECAL_CURVED_COORD = vec2(0.5);
    CAB_GLASS_CURVED_COORD = vec2(0.5);
    TOP_IMAGE_CURVED_COORD = vec2(0.5);
    HSM_RESOLUTION_DEBUG_ON = 0.0;
    HSM_CACHE_GRAPHICS_ON = 1.0;
    HSM_CACHE_UPDATE_INDICATOR_MODE = 2.0;
    HSM_GLOBAL_GRAPHICS_BRIGHTNESS = 1.0;
    HSM_STATIC_LAYERS_GAMMA = 1.0;
    HSM_AMBIENT_LIGHTING_OPACITY = 0.0;
    HSM_AMBIENT2_LIGHTING_OPACITY = 0.0;
    HSM_AMBIENT_LIGHTING_SWAP_IMAGES = 0.0;
    HSM_VIEWPORT_ZOOM = 1.0;
    HSM_VIEWPORT_ZOOM_MASK = 0.0;
    HSM_VIEWPORT_POSITION_X = -0.0;
    HSM_VIEWPORT_POSITION_Y = -0.0;
    HSM_FLIP_VIEWPORT_VERTICAL = 1.0;
    HSM_FLIP_VIEWPORT_HORIZONTAL = 1.0;
    HSM_FLIP_CORE_VERTICAL = 1.0;
    HSM_FLIP_CORE_HORIZONTAL = 1.0;
    HSM_ROTATE_CORE_IMAGE = 0.0;
    HSM_ASPECT_RATIO_ORIENTATION = 0.0;
    HSM_ASPECT_RATIO_MODE = 0.0;
    HSM_ASPECT_RATIO_EXPLICIT = 1.33329999446868896484375;
    HSM_VERTICAL_PRESET = 0.0;
    HSM_INT_SCALE_MAX_HEIGHT = 0.88999998569488525390625;
    HSM_NON_INTEGER_SCALE = 0.829699993133544921875;
    HSM_USE_PHYSICAL_SIZE_FOR_NON_INTEGER = 0.0;
    HSM_PHYSICAL_MONITOR_ASPECT_RATIO = 1.769999980926513671875;
    HSM_PHYSICAL_MONITOR_DIAGONAL_SIZE = 27.0;
    HSM_PHYSICAL_SIM_TUBE_DIAGONAL_SIZE = 18.1000003814697265625;
    HSM_USE_IMAGE_FOR_PLACEMENT = 0.0;
    HSM_PLACEMENT_IMAGE_USE_HORIZONTAL = 0.0;
    HSM_PLACEMENT_IMAGE_MODE = 0.0;
    HSM_NON_INTEGER_SCALE_OFFSET = 1.0;
    HSM_USE_SNAP_TO_CLOSEST_INT_SCALE = 0.0;
    HSM_SNAP_TO_CLOSEST_INT_SCALE_TOLERANCE = (HSM_USE_SNAP_TO_CLOSEST_INT_SCALE > 0.5) ? 0.20000000298023223876953125 : 0.0;
    HSM_SCREEN_POSITION_X = 0.0;
    HSM_SCREEN_POSITION_Y = -0.0;
    HSM_CROP_MODE = 2.0;
    HSM_CROP_PERCENT_ZOOM = 0.0;
    HSM_CROP_PERCENT_TOP = 0.0;
    HSM_CROP_PERCENT_BOTTOM = 0.0;
    HSM_CROP_PERCENT_LEFT = 0.0;
    HSM_CROP_PERCENT_RIGHT = 0.0;
    HSM_CROP_BLACK_THRESHOLD = 0.0;
    HSM_SCANLINE_DIRECTION = 0.0;
    HSM_CORE_RES_SAMPLING_MULT_SCANLINE_DIR = 1.0;
    HSM_DOWNSAMPLE_BLUR_SCANLINE_DIR = 0.0;
    HSM_CORE_RES_SAMPLING_MULT_OPPOSITE_DIR = 1.0;
    HSM_DOWNSAMPLE_BLUR_OPPOSITE_DIR = 0.0;
    HSM_CORE_RES_SAMPLING_SHIFT_OPPOSITE_DIR = 0.0;
    HSM_USE_GEOM = 0.0;
    HSM_CURVATURE_MODE = 1.0;
    HSM_CURVATURE_3D_RADIUS = 2.0;
    HSM_CURVATURE_3D_VIEW_DIST = 1.5;
    HSM_CURVATURE_3D_TILT_ANGLE_X = 0.0;
    HSM_CURVATURE_3D_TILT_ANGLE_Y = 0.0;
    HSM_CRT_CURVATURE_SCALE = 1.0;
    HSM_AB_COMPARE_SHOW_MODE = 0.0;
    HSM_AB_COMPARE_AREA = 0.0;
    HSM_AB_COMPARE_SPLIT_POSITION = 0.5;
    HSM_AB_COMPARE_FREEZE_CRT_TUBE = 0.0;
    HSM_AB_COMPARE_FREEZE_GRAPHICS = 0.0;
    HSM_SCREEN_VIGNETTE_DUALSCREEN_VIS_MODE = 0.0;
    HSM_MONOCHROME_DUALSCREEN_VIS_MODE = 0.0;
    HSM_TUBE_DIFFUSE_MODE = 0.0;
    HSM_TUBE_DIFFUSE_OPACITY = 1.0;
    HSM_TUBE_DIFFUSE_IMAGE_DUALSCREEN_VIS_MODE = 0.0;
    HSM_TUBE_DIFFUSE_IMAGE_COLORIZE_ON = 0.0;
    HSM_TUBE_DIFFUSE_IMAGE_HUE = 0.0;
    HSM_TUBE_DIFFUSE_IMAGE_SATURATION = 1.0;
    HSM_TUBE_DIFFUSE_IMAGE_BRIGHTNESS = 0.20000000298023223876953125;
    HSM_TUBE_DIFFUSE_IMAGE_GAMMA = 1.0;
    HSM_TUBE_DIFFUSE_IMAGE_AMBIENT_LIGHTING = 1.0;
    HSM_TUBE_DIFFUSE_IMAGE_AMBIENT2_LIGHTING = 0.0;
    HSM_TUBE_DIFFUSE_IMAGE_SCALE = 1.2000000476837158203125;
    HSM_TUBE_DIFFUSE_IMAGE_SCALE_X = 1.0;
    HSM_TUBE_SHADOW_IMAGE_ON = 1.0;
    HSM_TUBE_SHADOW_IMAGE_OPACITY = 0.60000002384185791015625;
    HSM_TUBE_SHADOW_IMAGE_POS_X = 0.0;
    HSM_TUBE_SHADOW_IMAGE_POS_Y = 0.0900000035762786865234375;
    HSM_TUBE_SHADOW_IMAGE_SCALE_X = 1.2200000286102294921875;
    HSM_TUBE_SHADOW_IMAGE_SCALE_Y = 1.2999999523162841796875;
    HSM_TUBE_SHADOW_CURVATURE_SCALE = 3.0;
    HSM_TUBE_COLORED_GEL_IMAGE_ON = 0.0;
    HSM_TUBE_COLORED_GEL_IMAGE_SCALE = 1.0;
    HSM_TUBE_COLORED_GEL_IMAGE_FLIP_HORIZONTAL = 1.0;
    HSM_TUBE_COLORED_GEL_IMAGE_FLIP_VERTICAL = 1.0;
    HSM_TUBE_COLORED_GEL_IMAGE_DUALSCREEN_VIS_MODE = 0.0;
    HSM_TUBE_COLORED_GEL_IMAGE_MULTIPLY_AMOUNT = 0.89999997615814208984375;
    HSM_TUBE_COLORED_GEL_IMAGE_ADDITIVE_AMOUNT = 0.0;
    HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_AMOUNT = 0.1500000059604644775390625;
    HSM_TUBE_COLORED_GEL_IMAGE_TRANSPARENCY_THRESHOLD = 0.23000000417232513427734375;
    HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_BRIGHTNESS = 1.0;
    HSM_TUBE_COLORED_GEL_IMAGE_NORMAL_VIGNETTE = 0.0;
    HSM_TUBE_COLORED_GEL_IMAGE_FAKE_SCANLINE_AMOUNT = 0.0;
    HSM_TUBE_COLORED_GEL_IMAGE_AMBIENT_LIGHTING = 1.0;
    HSM_TUBE_COLORED_GEL_IMAGE_AMBIENT2_LIGHTING = 0.0;
    HSM_SHOW_CRT_ON_TOP_OF_COLORED_GEL = 0.0;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_ON = 0.0;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_DUALSCREEN_VIS_MODE = 0.0;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_OPACITY = 0.100000001490116119384765625;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_AMBIENT_LIGHTING = 1.0;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_AMBIENT2_LIGHTING = 0.0;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_SCALE = 1.10000002384185791015625;
    HSM_TUBE_STATIC_REFLECTION_IMAGE_SHADOW_OPACITY = 0.4000000059604644775390625;
    HSM_DUALSCREEN_MODE = 0.0;
    HSM_DUALSCREEN_CORE_IMAGE_SPLIT_MODE = 1.0;
    HSM_DUALSCREEN_CORE_IMAGE_SWAP_SCREENS = 0.0;
    HSM_DUALSCREEN_CORE_IMAGE_SPLIT_OFFSET = 0.0;
    HSM_DUALSCREEN_VIEWPORT_SPLIT_LOCATION = 0.0;
    HSM_DUALSCREEN_SHIFT_POSITION_WITH_SCALE = 1.0;
    HSM_DUALSCREEN_POSITION_OFFSET_BETWEEN_SCREENS = 0.0;
    HSM_2ND_SCREEN_ASPECT_RATIO_MODE = 0.0;
    HSM_2ND_SCREEN_INDEPENDENT_SCALE = 0.0;
    HSM_2ND_SCREEN_SCALE_OFFSET = 1.0;
    HSM_2ND_SCREEN_POS_X = 0.0;
    HSM_2ND_SCREEN_POS_Y = 0.0;
    HSM_2ND_SCREEN_CROP_PERCENT_ZOOM = 0.0;
    HSM_2ND_SCREEN_CROP_PERCENT_TOP = 0.0;
    HSM_2ND_SCREEN_CROP_PERCENT_BOTTOM = 0.0;
    HSM_2ND_SCREEN_CROP_PERCENT_LEFT = 0.0;
    HSM_2ND_SCREEN_CROP_PERCENT_RIGHT = 0.0;
    HSM_SCREEN_REFLECTION_SCALE = 1.0;
    HSM_SCREEN_REFLECTION_POS_X = 0.0;
    HSM_SCREEN_REFLECTION_POS_Y = 0.0;
    HSM_AMBIENT_LIGHTING_HUE = 0.0;
    HSM_AMBIENT_LIGHTING_SATURATION = 1.0;
    HSM_AMBIENT_LIGHTING_VALUE = 1.0;
    HSM_AMBIENT_LIGHTING_CONTRAST = 1.0;
    HSM_AMBIENT_LIGHTING_SCALE_KEEP_ASPECT = 0.0;
    HSM_AMBIENT_LIGHTING_SCALE_WITH_ZOOM = 1.0;
    HSM_AMBIENT_LIGHTING_SCALE = 1.0;
    HSM_AMBIENT_LIGHTING_SCALE_X = 1.0;
    HSM_AMBIENT_LIGHTING_ROTATE = 0.0;
    HSM_AMBIENT_LIGHTING_MIRROR_HORZ = 0.0;
    HSM_AMBIENT_LIGHTING_POSITION_X = 0.0;
    HSM_AMBIENT_LIGHTING_POSITION_Y = -0.0;
    HSM_AMBIENT_LIGHTING_DITHERING_SAMPLES = 0.0;
    HSM_AMBIENT2_LIGHTING_HUE = 0.0;
    HSM_AMBIENT2_LIGHTING_SATURATION = 1.0;
    HSM_AMBIENT2_LIGHTING_VALUE = 2.0;
    HSM_AMBIENT2_LIGHTING_CONTRAST = 1.0;
    HSM_AMBIENT2_LIGHTING_SCALE_KEEP_ASPECT = 1.0;
    HSM_AMBIENT2_LIGHTING_SCALE_WITH_ZOOM = 1.0;
    HSM_AMBIENT2_LIGHTING_SCALE = 1.0;
    HSM_AMBIENT2_LIGHTING_SCALE_X = 1.0;
    HSM_AMBIENT2_LIGHTING_ROTATE = 0.0;
    HSM_AMBIENT2_LIGHTING_MIRROR_HORZ = 0.0;
    HSM_AMBIENT2_LIGHTING_POSITION_X = 0.0;
    HSM_AMBIENT2_LIGHTING_POSITION_Y = -0.0;
    HSM_BZL_OPACITY = 1.0;
    HSM_BZL_BLEND_MODE = 1.0;
    HSM_BZL_WIDTH = 0.107799999415874481201171875;
    HSM_BZL_HEIGHT = 0.0873199999332427978515625;
    HSM_BZL_INNER_CORNER_RADIUS_SCALE = 0.800000011920928955078125;
    CURVATURE_MODE_OFF = 0.0;
    CURVATURE_MODE_2D = 1.0;
    CURVATURE_MODE_2D_CYLINDER = 2.0;
    CURVATURE_MODE_3D_1 = 3.0;
    CURVATURE_MODE_3D_2 = 4.0;
    CURVATURE_MODE_3D_CYLINDER = 5.0;
    use_vert_scanlines_bool = false;
    vec3 c1 = vec3(0.0);
    vec3 c2 = vec3(0.0);
    vec2 param = vTexCoord;
    vec4 _1058 = HSM_UpdateGlobalScreenValuesFromCache(InfoCachePass, InfoCachePassFeedback, param);
    use_vert_scanlines_bool = USE_VERTICAL_SCANLINES > 0.5;
    if (HSM_ROTATE_CORE_IMAGE > 0.5)
    {
        use_vert_scanlines_bool = !use_vert_scanlines_bool;
    }
    vec2 rotated_derezed_size = HSM_GetRotatedDerezedSize();
    float _1071;
    if (use_vert_scanlines_bool)
    {
        _1071 = rotated_derezed_size.x;
    }
    else
    {
        _1071 = rotated_derezed_size.y;
    }
    float derezed_opposite_dir_res = _1071;
    float derezed_scaled_opposite_dir_res = derezed_opposite_dir_res * HSM_CORE_RES_SAMPLING_MULT_OPPOSITE_DIR;
    float _1086;
    if (use_vert_scanlines_bool)
    {
        _1086 = ROTATED_CORE_PREPPED_SIZE.x;
    }
    else
    {
        _1086 = ROTATED_CORE_PREPPED_SIZE.y;
    }
    float orig_opposite_dir_res = _1086;
    float scaled_opposite_dir_res = orig_opposite_dir_res * HSM_CORE_RES_SAMPLING_MULT_OPPOSITE_DIR;
    float _1101;
    if (use_vert_scanlines_bool)
    {
        _1101 = ROTATED_CORE_PREPPED_SIZE.y;
    }
    else
    {
        _1101 = ROTATED_CORE_PREPPED_SIZE.x;
    }
    float orig_scanline_dir_res = _1101;
    float _1112;
    if (use_vert_scanlines_bool)
    {
        _1112 = vTexCoord.x;
    }
    else
    {
        _1112 = vTexCoord.y;
    }
    float tex_coord_scan_dir = _1112;
    vec2 downsample_offset = vec2(0.0, (1.0 / orig_opposite_dir_res) / NEGATIVE_CROP_EXPAND_MULTIPLIER);
    if (use_vert_scanlines_bool)
    {
        downsample_offset = vec2((1.0 / orig_opposite_dir_res) / NEGATIVE_CROP_EXPAND_MULTIPLIER, 0.0);
    }
    if ((HSM_DOWNSAMPLE_BLUR_SCANLINE_DIR + HSM_DOWNSAMPLE_BLUR_OPPOSITE_DIR) > 0.0)
    {
        vec2 param_1 = vTexCoord;
        c1 = fetch_pixel(param_1);
        vec2 param_2 = vTexCoord + downsample_offset;
        c2 = fetch_pixel(param_2);
    }
    else
    {
        c1 = texture(PrePass, vTexCoord).xyz;
        c2 = texture(PrePass, vTexCoord + downsample_offset).xyz;
    }
    vec3 c = c1;
    float intera = 1.0;
    float gamma_in = 2.400000095367431640625;
    float m1 = max(max(c1.x, c1.y), c1.z);
    float m2 = max(max(c2.x, c2.y), c2.z);
    vec3 df = abs(c1 - c2);
    float d = max(max(df.x, df.y), df.z);
    if (false)
    {
        d = mix(0.100000001490116119384765625 * d, 10.0 * d, step(m1 / (m2 + 9.9999997473787516355514526367188e-05), m2 / (m1 + 9.9999997473787516355514526367188e-05)));
    }
    float r = m1;
    if ((600.0 <= derezed_scaled_opposite_dir_res) && true)
    {
        intera = 0.25;
        float line_no = clamp(floor(mod(orig_opposite_dir_res * tex_coord_scan_dir, 2.0)), 0.0, 1.0);
        float frame_no = clamp(floor(mod(float(params.FrameCount), 2.0)), 0.0, 1.0);
        float ii = abs(line_no - frame_no);
        if (false)
        {
            vec3 param_3 = mix(c2, c2 * c2, vec3(0.25));
            float param_4 = max(max(c2.x, c2.y), c2.z);
            c2 = plant(param_3, param_4);
            r = clamp(max(m1 * ii, 0.800000011920928955078125 * min(m1, m2)), 0.0, 1.0);
            vec3 param_5 = mix(mix(c1, c2, vec3(min(mix(m1, 1.0 - m2, min(m1, 1.0 - m1)) / (d + 9.9999997473787516355514526367188e-06), 1.0))), c1, vec3(ii));
            float param_6 = r;
            c = plant(param_5, param_6);
            if (false)
            {
                c = mix(c2, c1, vec3(ii)) * 0.89999997615814208984375;
            }
            intera = 0.0;
        }
        if (true)
        {
            vec3 param_7 = mix(c, c * c, vec3(0.125));
            float param_8 = max(max(c.x, c.y), c.z);
            c = plant(param_7, param_8);
            intera = 0.449999988079071044921875;
        }
        if (false)
        {
            c = mix(c2, c1, vec3(0.5));
            vec3 param_9 = mix(c, c * c, vec3(0.125));
            float param_10 = max(max(c.x, c.y), c.z);
            c = plant(param_9, param_10);
            intera = 0.449999988079071044921875;
        }
    }
    c = pow(c, vec3(gamma_in));
    if (vTexCoord.x > 0.5)
    {
        gamma_in = intera;
    }
    else
    {
        gamma_in = 1.0 / gamma_in;
    }
    FragColor = vec4(c, gamma_in);
}

